#include <stdlib.h>

#ifndef included_ASE_Compiler_Cxx_IORGenerator_stub
#include <ASE/Compiler/Cxx/IORGenerator_Stub.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_Cxx_IORGenerator_IORGenerator(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (obj)
  {
    return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.Cxx.IORGenerator", _exception);
  }
  else
  {
    const struct ASE_Compiler_Cxx_IORGenerator__external *(*_extFunc)(void);
    
    _extFunc = (const struct ASE_Compiler_Cxx_IORGenerator__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.Cxx.IORGenerator", &_exception);
    return (*((*_extFunc)()->createObject))(_exception);
  }
}

struct string__array *ASE_Compiler_Cxx_IORGenerator_getSourceLanguages(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSourceLanguages))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_setSourceLanguages(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct string__array *outputLanguages, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setSourceLanguages))(self->d_object, outputLanguages, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_IORGenerator_getSource(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ const char *language, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSource))(self->d_object, language, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_setSource(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setSource))(self->d_object, language, vertices, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_addSource(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addSource))(self->d_object, language, vertices, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_removeSource(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeSource))(self->d_object, language, vertices, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_IORGenerator_getRepository(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getRepository))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_setRepository(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setRepository))(self->d_object, repository, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_visitVertex(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitVertex))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_visitSpecification(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Specification__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitSpecification))(self->d_object, node, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_visitPackage(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Package__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPackage))(self->d_object, node, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_visitType(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Type__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitType))(self->d_object, node, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_visitTypeUniverse(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_TypeUniverse__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitTypeUniverse))(self->d_object, node, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_visitEnumerator(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumerator__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitEnumerator))(self->d_object, node, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_visitArray(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Array__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitArray))(self->d_object, node, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_visitParameter(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Parameter__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitParameter))(self->d_object, node, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_visitMethod(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitMethod))(self->d_object, node, _exception);
}

int ASE_Compiler_Cxx_IORGenerator_getReverseEdges(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReverseEdges))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_setReverseEdges(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setReverseEdges))(self->d_object, reverseEdges, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_traverseVertex(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->traverseVertex))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_resetVertexNumbering(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->resetVertexNumbering))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_discoverVertex(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->discoverVertex))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_finishVertex(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->finishVertex))(self->d_object, vertex, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_IORGenerator_getVerticesSeen(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getVerticesSeen))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_setVerticesSeen(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setVerticesSeen))(self->d_object, seen, _exception);
}

int ASE_Compiler_Cxx_IORGenerator_getVertexSeen(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getVertexSeen))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_setVertexSeen(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setVertexSeen))(self->d_object, vertex, state, _exception);
}

int32_t ASE_Compiler_Cxx_IORGenerator_getReferenceCount(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_addReference(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_deleteReference(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_Cxx_IORGenerator_isSame(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_Cxx_IORGenerator_getClassName(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_Cxx_IORGenerator_getName(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_setName(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_Cxx_IORGenerator_isInstanceOf(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_Cxx_IORGenerator_getSuper(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_visitInterface(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitInterface))(self->d_object, node, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_visitClass(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitClass))(self->d_object, node, _exception);
}

void ASE_Compiler_Cxx_IORGenerator_visitEnumeration(struct ASE_Compiler_Cxx_IORGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumeration__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitEnumeration))(self->d_object, node, _exception);
}
