#include <stdlib.h>

#ifndef included_ASE_Compiler_Python_Comment_stub
#include <ASE/Compiler/Python/Comment_Stub.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_Python_Comment_Comment(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (obj)
  {
    return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.Python.Comment", _exception);
  }
  else
  {
    const struct ASE_Compiler_Python_Comment__external *(*_extFunc)(void);
    
    _extFunc = (const struct ASE_Compiler_Python_Comment__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.Python.Comment", &_exception);
    return (*((*_extFunc)()->createObject))(_exception);
  }
}

const char *ASE_Compiler_Python_Comment_getComment(struct ASE_Compiler_Python_Comment__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getComment))(self->d_object, _exception);
}

void ASE_Compiler_Python_Comment_setComment(struct ASE_Compiler_Python_Comment__object *self, /*in*/ const char *comment, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setComment))(self->d_object, comment, _exception);
}

int32_t ASE_Compiler_Python_Comment_getReferenceCount(struct ASE_Compiler_Python_Comment__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_Python_Comment_addReference(struct ASE_Compiler_Python_Comment__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_Python_Comment_deleteReference(struct ASE_Compiler_Python_Comment__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_Python_Comment_isSame(struct ASE_Compiler_Python_Comment__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_Python_Comment_getClassName(struct ASE_Compiler_Python_Comment__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_Python_Comment_getName(struct ASE_Compiler_Python_Comment__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_Python_Comment_setName(struct ASE_Compiler_Python_Comment__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_Python_Comment_isInstanceOf(struct ASE_Compiler_Python_Comment__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_Python_Comment_getSuper(struct ASE_Compiler_Python_Comment__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}
