#include <stdlib.h>

#ifndef included_ASE_Compiler_Python_Output_stub
#include <ASE/Compiler/Python/Output_Stub.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_Python_Output_Output(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (obj)
  {
    return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.Python.Output", _exception);
  }
  else
  {
    const struct ASE_Compiler_Python_Output__external *(*_extFunc)(void);
    
    _extFunc = (const struct ASE_Compiler_Python_Output__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.Python.Output", &_exception);
    return (*((*_extFunc)()->createObject))(_exception);
  }
}

int ASE_Compiler_Python_Output_getDisableOutput(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getDisableOutput))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_setDisableOutput(struct ASE_Compiler_Python_Output__object *self, /*in*/ int disableOutput, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setDisableOutput))(self->d_object, disableOutput, _exception);
}

int ASE_Compiler_Python_Output_getDisableSource(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getDisableSource))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_setDisableSource(struct ASE_Compiler_Python_Output__object *self, /*in*/ int disableSource, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setDisableSource))(self->d_object, disableSource, _exception);
}

const char *ASE_Compiler_Python_Output_getRoot(struct ASE_Compiler_Python_Output__object *self, /*in*/ enum ASE_Compiler_CodePurpose__enum purpose, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getRoot))(self->d_object, purpose, _exception);
}

void ASE_Compiler_Python_Output_setRoot(struct ASE_Compiler_Python_Output__object *self, /*in*/ enum ASE_Compiler_CodePurpose__enum purpose, /*in*/ const char *root, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setRoot))(self->d_object, purpose, root, _exception);
}

struct string__array *ASE_Compiler_Python_Output_getIncludeDirectories(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getIncludeDirectories))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_setIncludeDirectories(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct string__array *dirs, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setIncludeDirectories))(self->d_object, dirs, _exception);
}

struct string__array *ASE_Compiler_Python_Output_getSystemIncludeDirectories(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSystemIncludeDirectories))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_setSystemIncludeDirectories(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct string__array *dirs, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setSystemIncludeDirectories))(self->d_object, dirs, _exception);
}

struct string__array *ASE_Compiler_Python_Output_getFiles(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getFiles))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_setFiles(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct string__array *files, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setFiles))(self->d_object, files, _exception);
}

const char *ASE_Compiler_Python_Output_getTab(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getTab))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_setTab(struct ASE_Compiler_Python_Output__object *self, /*in*/ const char *tab, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setTab))(self->d_object, tab, _exception);
}

int32_t ASE_Compiler_Python_Output_getIndentSize(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getIndentSize))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_setIndentSize(struct ASE_Compiler_Python_Output__object *self, /*in*/ int32_t indentSize, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setIndentSize))(self->d_object, indentSize, _exception);
}

void ASE_Compiler_Python_Output_increaseIndent(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->increaseIndent))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_decreaseIndent(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->decreaseIndent))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_indent(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->indent))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_println(struct ASE_Compiler_Python_Output__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->println))(self->d_object, s, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Python_Output_getRepository(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getRepository))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_setRepository(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setRepository))(self->d_object, repository, _exception);
}

void ASE_Compiler_Python_Output_visitVertex(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitVertex))(self->d_object, vertex, _exception);
}

int ASE_Compiler_Python_Output_getReverseEdges(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReverseEdges))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_setReverseEdges(struct ASE_Compiler_Python_Output__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setReverseEdges))(self->d_object, reverseEdges, _exception);
}

void ASE_Compiler_Python_Output_traverseVertex(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->traverseVertex))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Python_Output_resetVertexNumbering(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->resetVertexNumbering))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_discoverVertex(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->discoverVertex))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Python_Output_finishVertex(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->finishVertex))(self->d_object, vertex, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Python_Output_getVerticesSeen(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getVerticesSeen))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_setVerticesSeen(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setVerticesSeen))(self->d_object, seen, _exception);
}

int ASE_Compiler_Python_Output_getVertexSeen(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getVertexSeen))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Python_Output_setVertexSeen(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setVertexSeen))(self->d_object, vertex, state, _exception);
}

int32_t ASE_Compiler_Python_Output_getReferenceCount(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_addReference(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_deleteReference(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_Python_Output_isSame(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_Python_Output_getClassName(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_Python_Output_getName(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_setName(struct ASE_Compiler_Python_Output__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_Python_Output_isInstanceOf(struct ASE_Compiler_Python_Output__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_Python_Output_getSuper(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}

void ASE_Compiler_Python_Output_visitAdd(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Add__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAdd))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitAnd(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_And__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAnd))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitAssAttr(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_AssAttr__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAssAttr))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitAssList(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_AssList__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAssList))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitAssName(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_AssName__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAssName))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitAssTuple(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_AssTuple__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAssTuple))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitAssign(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Assign__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAssign))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitAugAssign(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_AugAssign__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAugAssign))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitBitand(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Bitand__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitBitand))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitBitor(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Bitor__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitBitor))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitBitxor(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Bitxor__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitBitxor))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitBreak(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Break__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitBreak))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitCallFunc(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_CallFunc__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitCallFunc))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitClass(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitClass))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitCompare(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Compare__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitCompare))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitConst(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Const__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitConst))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitPyNone(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_PyNone__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPyNone))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitContinue(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Continue__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitContinue))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitDict(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Dict__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitDict))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitDiscard(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Discard__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitDiscard))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitDiv(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Div__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitDiv))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitEllipsis(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Ellipsis__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitEllipsis))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitFor(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_For__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitFor))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitListCompFor(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_ListCompFor__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitListCompFor))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitFunction(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Function__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitFunction))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitLambda(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Lambda__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitLambda))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitGetAttr(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_GetAttr__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitGetAttr))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitGlobal(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Global__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitGlobal))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitIf(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_If__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitIf))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitListCompIf(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_ListCompIf__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitListCompIf))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitImport(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Import__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitImport))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitFrom(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_From__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitFrom))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitInvert(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Invert__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitInvert))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitKeyword(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Keyword__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitKeyword))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitLeftShift(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_LeftShift__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitLeftShift))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitList(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_List__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitList))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitListComp(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_ListComp__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitListComp))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitMod(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Mod__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitMod))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitMul(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Mul__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitMul))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitName(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Name__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitName))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitNot(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Not__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitNot))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitOr(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Or__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitOr))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitPass(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Pass__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPass))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitPower(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Power__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPower))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitPrint(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Print__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPrint))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitPrintnl(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Printnl__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPrintnl))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitRaise(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Raise__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitRaise))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitReturn(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Return__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitReturn))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitRightShift(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_RightShift__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitRightShift))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitSlice(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Slice__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitSlice))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitStmt(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Stmt__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitStmt))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitSub(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Sub__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitSub))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitSubscript(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Subscript__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitSubscript))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitTryExcept(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_TryExcept__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitTryExcept))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitTryFinally(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_TryFinally__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitTryFinally))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitTuple(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Tuple__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitTuple))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitUnaryAdd(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_UnaryAdd__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitUnaryAdd))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitUnarySub(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_UnarySub__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitUnarySub))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitWhile(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_While__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitWhile))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitYield(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Yield__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitYield))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_printDocComment(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Vertex__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->printDocComment))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_visitModule(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Module__object *node, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitModule))(self->d_object, node, _exception);
}

void ASE_Compiler_Python_Output_write(struct ASE_Compiler_Python_Output__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->write))(self->d_object, s, _exception);
}
