#include <stdlib.h>

#ifndef included_ASE_Compiler_SIDL_Class_stub
#include <ASE/Compiler/SIDL/Class_Stub.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_SIDL_Class_Class(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (obj)
  {
    return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.SIDL.Class", _exception);
  }
  else
  {
    const struct ASE_Compiler_SIDL_Class__external *(*_extFunc)(void);
    
    _extFunc = (const struct ASE_Compiler_SIDL_Class__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.SIDL.Class", &_exception);
    return (*((*_extFunc)()->createObject))(_exception);
  }
}

struct string__array *ASE_Compiler_SIDL_Class_getTemplateIdentifiers(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getTemplateIdentifiers))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setTemplateIdentifiers(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct string__array *templateIds, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setTemplateIdentifiers))(self->d_object, templateIds, _exception);
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Class_clone(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->clone))(self->d_object, _exception);
}

const char *ASE_Compiler_SIDL_Class_getIdentifier(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getIdentifier))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setIdentifier(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ const char *identifier, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setIdentifier))(self->d_object, identifier, _exception);
}

struct ASE_Compiler_Attribute__array *ASE_Compiler_SIDL_Class_getAttributes(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttributes))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setAttributes(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_Attribute__array *attributes, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setAttributes))(self->d_object, attributes, _exception);
}

int ASE_Compiler_SIDL_Class_hasAttribute(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->hasAttribute))(self->d_object, name, _exception);
}

void ASE_Compiler_SIDL_Class_addAttribute(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_Attribute__object *attribute, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addAttribute))(self->d_object, attribute, _exception);
}

void ASE_Compiler_SIDL_Class_deleteAttribute(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Attribute__object *ASE_Compiler_SIDL_Class_getAttribute(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Class_getParent(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getParent))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setParent(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_Vertex__object *parent, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setParent))(self->d_object, parent, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_SIDL_Class_getChildren(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getChildren))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setChildren(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_SIDL_Class_addChildren(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_SIDL_Class_removeChildren(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeChildren))(self->d_object, children, _exception);
}

int32_t ASE_Compiler_SIDL_Class_getLineNumber(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getLineNumber))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setLineNumber(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ int32_t lineNumber, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setLineNumber))(self->d_object, lineNumber, _exception);
}

struct ASE_Compiler_Comment__array *ASE_Compiler_SIDL_Class_getComments(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getComments))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setComments(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_SIDL_Class_addComments(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_SIDL_Class_removeComments(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeComments))(self->d_object, comments, _exception);
}

int32_t ASE_Compiler_SIDL_Class_getReferenceCount(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_addReference(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_deleteReference(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_SIDL_Class_isSame(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_SIDL_Class_getClassName(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_SIDL_Class_getName(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setName(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_SIDL_Class_isInstanceOf(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_SIDL_Class_getSuper(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}

struct ASE_Compiler_SIDL_Vertex__array *ASE_Compiler_SIDL_Class_getDependencies(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getDependencies))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setDependencies(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setDependencies))(self->d_object, dependencies, _exception);
}

void ASE_Compiler_SIDL_Class_addDependencies(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addDependencies))(self->d_object, dependencies, _exception);
}

void ASE_Compiler_SIDL_Class_removeDependencies(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeDependencies))(self->d_object, dependencies, _exception);
}

struct ASE_Compiler_SIDL_Vertex__object *ASE_Compiler_SIDL_Class_copy(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->copy))(self->d_object, _exception);
}

const char *ASE_Compiler_SIDL_Class_getFullIdentifier(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getFullIdentifier))(self->d_object, _exception);
}

int ASE_Compiler_SIDL_Class_getBaseType(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getBaseType))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setBaseType(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ int baseType, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setBaseType))(self->d_object, baseType, _exception);
}

struct ASE_Compiler_SIDL_Interface__array *ASE_Compiler_SIDL_Class_getParents(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getParents))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setParents(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *parents, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setParents))(self->d_object, parents, _exception);
}

void ASE_Compiler_SIDL_Class_addParents(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *parents, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addParents))(self->d_object, parents, _exception);
}

void ASE_Compiler_SIDL_Class_removeParents(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *parents, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeParents))(self->d_object, parents, _exception);
}

struct ASE_Compiler_SIDL_Method__array *ASE_Compiler_SIDL_Class_getMethods(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getMethods))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setMethods(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__array *methods, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setMethods))(self->d_object, methods, _exception);
}

void ASE_Compiler_SIDL_Class_addMethods(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__array *methods, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addMethods))(self->d_object, methods, _exception);
}

void ASE_Compiler_SIDL_Class_removeMethods(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__array *methods, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeMethods))(self->d_object, methods, _exception);
}

void ASE_Compiler_SIDL_Class_accept(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Visitor__object *visitor, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->accept))(self->d_object, visitor, _exception);
}

struct ASE_Compiler_SIDL_Interface__array *ASE_Compiler_SIDL_Class_getInterfaces(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getInterfaces))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setInterfaces(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *interfaces, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setInterfaces))(self->d_object, interfaces, _exception);
}

void ASE_Compiler_SIDL_Class_addInterfaces(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *interfaces, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addInterfaces))(self->d_object, interfaces, _exception);
}

void ASE_Compiler_SIDL_Class_removeInterfaces(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *interfaces, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeInterfaces))(self->d_object, interfaces, _exception);
}

struct ASE_Compiler_SIDL_Method__array *ASE_Compiler_SIDL_Class_getImplementedMethods(struct ASE_Compiler_SIDL_Class__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getImplementedMethods))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Class_setImplementedMethods(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__array *methods, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setImplementedMethods))(self->d_object, methods, _exception);
}

void ASE_Compiler_SIDL_Class_addImplementedMethods(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__array *methods, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addImplementedMethods))(self->d_object, methods, _exception);
}

void ASE_Compiler_SIDL_Class_removeImplementedMethods(struct ASE_Compiler_SIDL_Class__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__array *methods, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeImplementedMethods))(self->d_object, methods, _exception);
}
