#ifndef included_ASE_Compiler_SIDL_Method_stub
#define included_ASE_Compiler_SIDL_Method_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_SIDL_Method
#include <ASE/Compiler/SIDL/Method_IOR.h>
#endif

/* ASE.Compiler.SIDL.Method.Method: Constructor and cast method */
void *ASE_Compiler_SIDL_Method_Method(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Templated.getTemplateIdentifiers:  Get the identifiers which are quantified over types */
struct string__array *ASE_Compiler_SIDL_Method_getTemplateIdentifiers(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Templated.setTemplateIdentifiers:  Set the identifiers which are quantified over types */
void ASE_Compiler_SIDL_Method_setTemplateIdentifiers(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct string__array *templateIds, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.clone:  Return an empty object of the same type */
struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Method_clone(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.copy:  Return a deep copy of this subtree */
struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Method_copy(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getIdentifier:  Retrieve the identifier associated with this vertex */
const char *ASE_Compiler_SIDL_Method_getIdentifier(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setIdentifier:  Assign the identifier associated with this vertex */
void ASE_Compiler_SIDL_Method_setIdentifier(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ const char *identifier, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getAttributes:  Get attribute list for this element */
struct ASE_Compiler_Attribute__array *ASE_Compiler_SIDL_Method_getAttributes(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setAttributes:  Set attribute list for this element */
void ASE_Compiler_SIDL_Method_setAttributes(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Attribute__array *attributes, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.hasAttribute:  Determine whether an attribute is present on this vertex */
int ASE_Compiler_SIDL_Method_hasAttribute(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.addAttribute:  Add attribute to this vertex */
void ASE_Compiler_SIDL_Method_addAttribute(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Attribute__object *attribute, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.deleteAttribute:  Remove an attribute on this vertex
   Throws an exception if the attribute does not exist */
void ASE_Compiler_SIDL_Method_deleteAttribute(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getAttribute:  Get an attribute on this vertex
   Throws an exception if the attribute does not exist */
struct ASE_Compiler_Attribute__object *ASE_Compiler_SIDL_Method_getAttribute(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getParent:  Retrieve the parent of this vertex */
struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Method_getParent(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setParent:  Assign the parent of this vertex */
void ASE_Compiler_SIDL_Method_setParent(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Vertex__object *parent, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getChildren:  Retrieve the children of this vertex */
struct ASE_Compiler_Vertex__array *ASE_Compiler_SIDL_Method_getChildren(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setChildren:  Set the children of this vertex */
void ASE_Compiler_SIDL_Method_setChildren(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.addChildren:  Add children to this vertex (duplicates allowed) */
void ASE_Compiler_SIDL_Method_addChildren(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.removeChildren:  Remove children from this vertex
   Throws an exception if any child does not exist */
void ASE_Compiler_SIDL_Method_removeChildren(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getLineNumber:  Retrieve the line number associated with this vertex */
int32_t ASE_Compiler_SIDL_Method_getLineNumber(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setLineNumber:  Set the line number associated with this vertex */
void ASE_Compiler_SIDL_Method_setLineNumber(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ int32_t lineNumber, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getComments:  Retrieve the comments of this vertex */
struct ASE_Compiler_Comment__array *ASE_Compiler_SIDL_Method_getComments(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setComments:  Set the children of this vertex */
void ASE_Compiler_SIDL_Method_setComments(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.addComments:  Add comments to this vertex (duplicates allowed) */
void ASE_Compiler_SIDL_Method_addComments(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.removeComments:  Remove comments from this vertex
   Throws an exception if a comment does not exist */
void ASE_Compiler_SIDL_Method_removeComments(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_SIDL_Method_getReferenceCount(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_SIDL_Method_addReference(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_SIDL_Method_deleteReference(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_SIDL_Method_isSame(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_SIDL_Method_getClassName(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_SIDL_Method_getName(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_SIDL_Method_setName(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_SIDL_Method_isInstanceOf(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_SIDL_Method_getSuper(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Vertex.getDependencies:  Retrieve nodes on which this node depends */
struct ASE_Compiler_SIDL_Vertex__array *ASE_Compiler_SIDL_Method_getDependencies(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Vertex.setDependencies:  Set nodes on which this node depends */
void ASE_Compiler_SIDL_Method_setDependencies(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Vertex.addDependencies:  Add nodes on which this node depends */
void ASE_Compiler_SIDL_Method_addDependencies(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Vertex.removeDependencies:  Remove nodes on which this node depends
   Throws an exception if a dependency does not exist */
void ASE_Compiler_SIDL_Method_removeDependencies(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.accept:  Overridden to dispatch correctly */
void ASE_Compiler_SIDL_Method_accept(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Visitor__object *visitor, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.getFullIdentifier:  Need to override this to calculate the fully qualified method name */
const char *ASE_Compiler_SIDL_Method_getFullIdentifier(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.getReturnParameter:  Retrieve the return parameter */
struct ASE_Compiler_SIDL_Parameter__object *ASE_Compiler_SIDL_Method_getReturnParameter(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.setReturnParameter:  Set the return parameter */
void ASE_Compiler_SIDL_Method_setReturnParameter(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Parameter__object *parameter, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.getExceptions:  Retrieve the exceptions thrown by the method */
struct ASE_Compiler_SIDL_Interface__array *ASE_Compiler_SIDL_Method_getExceptions(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.setExceptions:  Set the exceptions thrown by the method */
void ASE_Compiler_SIDL_Method_setExceptions(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *exceptions, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.addExceptions:  Add to the exceptions thrown by the method */
void ASE_Compiler_SIDL_Method_addExceptions(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *exceptions, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.removeExceptions:  Remove from the exceptions thrown by the method
   Throws an exception if an exception does not exist */
void ASE_Compiler_SIDL_Method_removeExceptions(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *exceptions, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.getStatic:  Retrieve the flag indicating whether the method is static */
int ASE_Compiler_SIDL_Method_getStatic(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.setStatic:  Set the flag indicating whether the method is static */
void ASE_Compiler_SIDL_Method_setStatic(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ int isStatic, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.getInternal:  Retrieve the flag indicating whether the method is not present in the SIDL interface */
int ASE_Compiler_SIDL_Method_getInternal(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.setInternal:  Set the flag indicating whether the method is not present in the SIDL interface */
void ASE_Compiler_SIDL_Method_setInternal(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ int isInternal, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.getVirtual:  Retrieve the flag indicating whether this method may be inherited, or must be implemented by every class */
int ASE_Compiler_SIDL_Method_getVirtual(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.setVirtual:  Set the flag indicating whether this method may be inherited, or must be implemented by every class */
void ASE_Compiler_SIDL_Method_setVirtual(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ int isVirtual, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.getPurpose:  NOTICE: These should be ASE.Compiler.CodePurpose when this gets fixed
 Retrieve the list of purposes for which this method is defined */
struct int__array *ASE_Compiler_SIDL_Method_getPurpose(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.setPurpose:  Set the list of purposes for which this method is defined */
void ASE_Compiler_SIDL_Method_setPurpose(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct int__array *purpose, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.addPurpose:  Add purposes in which the method is defined */
void ASE_Compiler_SIDL_Method_addPurpose(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct int__array *purpose, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.removePurpose:  Remove purposes in which the method is defined
   Throws an exception if a purpose does not exist */
void ASE_Compiler_SIDL_Method_removePurpose(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct int__array *purpose, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.getInParameters:  Retrieve the parameters whose values will be read on input */
struct ASE_Compiler_SIDL_Parameter__array *ASE_Compiler_SIDL_Method_getInParameters(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Method.getOutParameters:  Retrieve the parameters which will return values, including the return value */
struct ASE_Compiler_SIDL_Parameter__array *ASE_Compiler_SIDL_Method_getOutParameters(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
