#include <stdlib.h>

#ifndef included_ASE_Compiler_SIDL_Package_stub
#include <ASE/Compiler/SIDL/Package_Stub.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_SIDL_Package_Package(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (obj)
  {
    return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.SIDL.Package", _exception);
  }
  else
  {
    const struct ASE_Compiler_SIDL_Package__external *(*_extFunc)(void);
    
    _extFunc = (const struct ASE_Compiler_SIDL_Package__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.SIDL.Package", &_exception);
    return (*((*_extFunc)()->createObject))(_exception);
  }
}

struct string__array *ASE_Compiler_SIDL_Package_getTemplateIdentifiers(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getTemplateIdentifiers))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Package_setTemplateIdentifiers(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct string__array *templateIds, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setTemplateIdentifiers))(self->d_object, templateIds, _exception);
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Package_clone(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->clone))(self->d_object, _exception);
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Package_copy(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->copy))(self->d_object, _exception);
}

const char *ASE_Compiler_SIDL_Package_getIdentifier(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getIdentifier))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Package_setIdentifier(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ const char *identifier, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setIdentifier))(self->d_object, identifier, _exception);
}

struct ASE_Compiler_Attribute__array *ASE_Compiler_SIDL_Package_getAttributes(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttributes))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Package_setAttributes(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_Compiler_Attribute__array *attributes, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setAttributes))(self->d_object, attributes, _exception);
}

int ASE_Compiler_SIDL_Package_hasAttribute(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->hasAttribute))(self->d_object, name, _exception);
}

void ASE_Compiler_SIDL_Package_addAttribute(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_Compiler_Attribute__object *attribute, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addAttribute))(self->d_object, attribute, _exception);
}

void ASE_Compiler_SIDL_Package_deleteAttribute(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Attribute__object *ASE_Compiler_SIDL_Package_getAttribute(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Package_getParent(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getParent))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Package_setParent(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_Compiler_Vertex__object *parent, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setParent))(self->d_object, parent, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_SIDL_Package_getChildren(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getChildren))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Package_setChildren(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_SIDL_Package_addChildren(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_SIDL_Package_removeChildren(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeChildren))(self->d_object, children, _exception);
}

int32_t ASE_Compiler_SIDL_Package_getLineNumber(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getLineNumber))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Package_setLineNumber(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ int32_t lineNumber, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setLineNumber))(self->d_object, lineNumber, _exception);
}

struct ASE_Compiler_Comment__array *ASE_Compiler_SIDL_Package_getComments(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getComments))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Package_setComments(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_SIDL_Package_addComments(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_SIDL_Package_removeComments(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeComments))(self->d_object, comments, _exception);
}

int32_t ASE_Compiler_SIDL_Package_getReferenceCount(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Package_addReference(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Package_deleteReference(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_SIDL_Package_isSame(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_SIDL_Package_getClassName(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_SIDL_Package_getName(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Package_setName(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_SIDL_Package_isInstanceOf(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_SIDL_Package_getSuper(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}

struct ASE_Compiler_SIDL_Vertex__array *ASE_Compiler_SIDL_Package_getDependencies(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getDependencies))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Package_setDependencies(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setDependencies))(self->d_object, dependencies, _exception);
}

void ASE_Compiler_SIDL_Package_addDependencies(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addDependencies))(self->d_object, dependencies, _exception);
}

void ASE_Compiler_SIDL_Package_removeDependencies(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeDependencies))(self->d_object, dependencies, _exception);
}

void ASE_Compiler_SIDL_Package_accept(struct ASE_Compiler_SIDL_Package__object *self, /*in*/ struct ASE_Compiler_SIDL_Visitor__object *visitor, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->accept))(self->d_object, visitor, _exception);
}

const char *ASE_Compiler_SIDL_Package_getFullIdentifier(struct ASE_Compiler_SIDL_Package__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getFullIdentifier))(self->d_object, _exception);
}
