#include <stdlib.h>

#ifndef included_ASE_Compiler_SIDL_Parser_stub
#include <ASE/Compiler/SIDL/Parser_Stub.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_SIDL_Parser_Parser(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (obj)
  {
    return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.SIDL.Parser", _exception);
  }
  else
  {
    const struct ASE_Compiler_SIDL_Parser__external *(*_extFunc)(void);
    
    _extFunc = (const struct ASE_Compiler_SIDL_Parser__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.SIDL.Parser", &_exception);
    return (*((*_extFunc)()->createObject))(_exception);
  }
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Parser_parse(struct ASE_Compiler_SIDL_Parser__object *self, /*in*/ const char *buf, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->parse))(self->d_object, buf, _exception);
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Parser_parseFile(struct ASE_Compiler_SIDL_Parser__object *self, /*in*/ const char *filename, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->parseFile))(self->d_object, filename, _exception);
}

int32_t ASE_Compiler_SIDL_Parser_getReferenceCount(struct ASE_Compiler_SIDL_Parser__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Parser_addReference(struct ASE_Compiler_SIDL_Parser__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Parser_deleteReference(struct ASE_Compiler_SIDL_Parser__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_SIDL_Parser_isSame(struct ASE_Compiler_SIDL_Parser__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_SIDL_Parser_getClassName(struct ASE_Compiler_SIDL_Parser__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_SIDL_Parser_getName(struct ASE_Compiler_SIDL_Parser__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_SIDL_Parser_setName(struct ASE_Compiler_SIDL_Parser__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_SIDL_Parser_isInstanceOf(struct ASE_Compiler_SIDL_Parser__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_SIDL_Parser_getSuper(struct ASE_Compiler_SIDL_Parser__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}
