#include <stdlib.h>

#ifndef included_ASE_Compiler_StubGenerator_stub
#include <ASE/Compiler/StubGenerator_Stub.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_StubGenerator_StubGenerator(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_StubGenerator__object *_result = NULL;
  
  if (!obj)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Interfaces require an argument for the constructor", _exception);
    if (!(*_exception))
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return _result;
  }
  return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.StubGenerator", _exception);
}

int32_t ASE_Compiler_StubGenerator_getReferenceCount(struct ASE_Compiler_StubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_StubGenerator_addReference(struct ASE_Compiler_StubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_StubGenerator_deleteReference(struct ASE_Compiler_StubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_StubGenerator_isSame(struct ASE_Compiler_StubGenerator__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_StubGenerator_getClassName(struct ASE_Compiler_StubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_StubGenerator_getName(struct ASE_Compiler_StubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_StubGenerator_setName(struct ASE_Compiler_StubGenerator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_StubGenerator_isInstanceOf(struct ASE_Compiler_StubGenerator__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_StubGenerator_getSuper(struct ASE_Compiler_StubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_StubGenerator_getRepository(struct ASE_Compiler_StubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getRepository))(self->d_object, _exception);
}

void ASE_Compiler_StubGenerator_setRepository(struct ASE_Compiler_StubGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setRepository))(self->d_object, repository, _exception);
}

void ASE_Compiler_StubGenerator_visitVertex(struct ASE_Compiler_StubGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitVertex))(self->d_object, vertex, _exception);
}

struct string__array *ASE_Compiler_StubGenerator_getSourceLanguages(struct ASE_Compiler_StubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSourceLanguages))(self->d_object, _exception);
}

void ASE_Compiler_StubGenerator_setSourceLanguages(struct ASE_Compiler_StubGenerator__object *self, /*in*/ struct string__array *outputLanguages, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setSourceLanguages))(self->d_object, outputLanguages, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_StubGenerator_getSource(struct ASE_Compiler_StubGenerator__object *self, /*in*/ const char *language, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSource))(self->d_object, language, _exception);
}

void ASE_Compiler_StubGenerator_setSource(struct ASE_Compiler_StubGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setSource))(self->d_object, language, vertices, _exception);
}

void ASE_Compiler_StubGenerator_addSource(struct ASE_Compiler_StubGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addSource))(self->d_object, language, vertices, _exception);
}

void ASE_Compiler_StubGenerator_removeSource(struct ASE_Compiler_StubGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeSource))(self->d_object, language, vertices, _exception);
}
