#ifndef included_ASE_Compiler_Bootstrap_BootstrapStubGenerator
#define included_ASE_Compiler_Bootstrap_BootstrapStubGenerator

#ifdef __cplusplus
extern "C" {
#endif

#include <sys/types.h>

/* These structures are used in this header */
struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object;

struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__array;

struct ASE_BaseException__object;

struct ASE_BaseException__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Enumerator__object;

struct ASE_Compiler_SIDL_Enumerator__array;

/* These structures are used in this header */
struct ASE_Compiler_Vertex__object;

struct ASE_Compiler_Vertex__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Specification__object;

struct ASE_Compiler_SIDL_Specification__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_DepthFirstVisitor__object;

struct ASE_Compiler_SIDL_DepthFirstVisitor__array;

#ifndef included_bool
#include "bool_IOR.h"
#endif

/* These structures are used in this header */
struct ASE_Compiler_StubGenerator__object;

struct ASE_Compiler_StubGenerator__array;

/* These structures are used in this header */
struct ASE_BaseException__object;

struct ASE_BaseException__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Interface__object;

struct ASE_Compiler_SIDL_Interface__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Class__object;

struct ASE_Compiler_SIDL_Class__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_TypeUniverse__object;

struct ASE_Compiler_SIDL_TypeUniverse__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Enumeration__object;

struct ASE_Compiler_SIDL_Enumeration__array;

#ifndef included_int
#include "int_IOR.h"
#endif

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Method__object;

struct ASE_Compiler_SIDL_Method__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Parameter__object;

struct ASE_Compiler_SIDL_Parameter__array;

/* These structures are used in this header */
struct ASE_Compiler_CompilerException__object;

struct ASE_Compiler_CompilerException__array;

/* These structures are used in this header */
struct ASE_BaseInterface__object;

struct ASE_BaseInterface__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Package__object;

struct ASE_Compiler_SIDL_Package__array;

#ifndef included_string
#include "string_IOR.h"
#endif

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Type__object;

struct ASE_Compiler_SIDL_Type__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Array__object;

struct ASE_Compiler_SIDL_Array__array;

#ifndef included_ASE_Compiler_SIDL_DepthFirstVisitor
#include "ASE/Compiler/SIDL/DepthFirstVisitor_IOR.h"
#endif

#ifndef included_ASE_Compiler_StubGenerator
#include "ASE/Compiler/StubGenerator_IOR.h"
#endif

/* The entry point vector (EPV) is the virtual function table for this interface */
struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__epv {
  /* ASE.Compiler.Bootstrap.BootstrapStubGenerator.castObject: Builtin method */
  void *(*castObject)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Bootstrap.BootstrapStubGenerator.destroyObject: Builtin method */
  void (*destroyObject)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Bootstrap.BootstrapStubGenerator.strObject: Builtin method */
  const char *(*strObject)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Bootstrap.BootstrapStubGenerator.BootstrapStubGenerator: Builtin method */
  void (*BootstrapStubGenerator)(/*in*/ struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *obj, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Bootstrap.BootstrapStubGenerator.BootstrapStubGenerator_: Builtin method */
  void (*BootstrapStubGenerator_)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Generator.getSourceLanguages:  Retrieve the list of the languages in which ASTs are produced */
  struct string__array *(*getSourceLanguages)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Generator.setSourceLanguages:  Set the list of the languages in which ASTs are produced */
  void (*setSourceLanguages)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct string__array *outputLanguages, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Generator.getSource:  Retrieve the list of source ASTs for the given language
   Throw an exception if the language does not exist */
  struct ASE_Compiler_Vertex__array *(*getSource)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ const char *language, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Generator.setSource:  Set the list of source ASTs for the given language
   Throw an exception if the language does not exist */
  void (*setSource)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Generator.addSource:  Add to the list of source ASTs for the given language
   Throw an exception if the language does not exist */
  void (*addSource)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Generator.removeSource:  Remove to the list of source ASTs for the given language
   Throw an exception if a vertex or language does not exist */
  void (*removeSource)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
  struct ASE_Compiler_Vertex__array *(*getRepository)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
  void (*setRepository)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Visitor.visitVertex:  */
  void (*visitVertex)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Visitor.visitSpecification:  */
  void (*visitSpecification)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Specification__object *node, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Visitor.visitType:  */
  void (*visitType)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Type__object *node, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Visitor.visitTypeUniverse:  */
  void (*visitTypeUniverse)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_TypeUniverse__object *node, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Visitor.visitEnumeration:  */
  void (*visitEnumeration)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumeration__object *node, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Visitor.visitEnumerator:  */
  void (*visitEnumerator)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumerator__object *node, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Visitor.visitArray:  */
  void (*visitArray)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Array__object *node, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Visitor.visitParameter:  */
  void (*visitParameter)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Parameter__object *node, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Search.getReverseEdges:  Retrieve the flag for reversing the orientation of edges in the traversal */
  int (*getReverseEdges)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Search.setReverseEdges:  Set the flag for reversing the orientation of edges in the traversal */
  void (*setReverseEdges)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Search.traverseVertex:  Traverse each edge of this vertex */
  void (*traverseVertex)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Search.resetVertexNumbering:  Reset the vertex discovery and finish numbering */
  void (*resetVertexNumbering)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Search.discoverVertex:  Mark a vertex as discovered and increment the count */
  void (*discoverVertex)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Search.finishVertex:  Mark a vertex as finished and increment the count */
  void (*finishVertex)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Search.getVerticesSeen:  Retrieve the list of vertices discovered */
  struct ASE_Compiler_Vertex__array *(*getVerticesSeen)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Search.setVerticesSeen:  Set the list of vertices discovered */
  void (*setVerticesSeen)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Search.getVertexSeen:  Retrieve the vertex discovery state */
  int (*getVertexSeen)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Search.setVertexSeen:  Set the vertex discovery state */
  void (*setVertexSeen)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
  int32_t (*getReferenceCount)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
  void (*addReference)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
  void (*deleteReference)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
  int (*isSame)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
  const char *(*getClassName)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getName:  Retrieve the object name */
  const char *(*getName)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.setName:  Set the object name */
  void (*setName)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
  int (*isInstanceOf)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
  struct ASE_BaseInterface__object *(*getSuper)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Bootstrap.BootstrapStubGenerator.visitPackage:  Each package has an associated __init__.py module */
  void (*visitPackage)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Package__object *node, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Bootstrap.BootstrapStubGenerator.visitInterface:  Interfaces merely wrap up classes */
  void (*visitInterface)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__object *node, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Bootstrap.BootstrapStubGenerator.visitClass:  Classes wrap up implementation classes */
  void (*visitClass)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Bootstrap.BootstrapStubGenerator.visitMethod:  Methods delegate directly to the contained object */
  void (*visitMethod)(struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__object *node, /*out*/ struct ASE_BaseException__object **_exception);
};

/* The IOR object structure for this type */
struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object {
  struct ASE_Compiler_SIDL_DepthFirstVisitor__object ase_compiler_sidl_depthfirstvisitor;
  struct ASE_Compiler_StubGenerator__object ase_compiler_stubgenerator;
  struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__epv *d_epv;
  struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__epv *d_oldEpv;
  void *d_object;
  void *d_data;
};

/* The IOR array structure for this type */
struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__array {
  struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object **d_firstElement;
  int32_t *d_lower;
  int32_t *d_upper;
  int32_t *d_stride;
  int d_borrowed;
  int32_t d_dimen;
};

/* The entry points into the DLL containing this type */
struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__external {
  /* ASE.Compiler.Bootstrap.BootstrapStubGenerator.createObject: Builtin method */
  struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *(*createObject)(/*out*/ struct ASE_BaseException__object **_exception);
  /* initObject:  */
  void (*initObject)(/*in*/ struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception);
  /* finiObject:  */
  void (*finiObject)(/*in*/ struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* createArray: Create a dense array of the given dimension with specified index bounds
This array owns and manages its data
All object pointers are initialized to NULL */
  struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__array *(*createArray)(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*out*/ struct ASE_BaseException__object **_exception);
  /* borrowArray: Create an array using user-provided memory */
  struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__array *(*borrowArray)(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*in*/ struct int__array *stride, /*in*/ void *first, /*out*/ struct ASE_BaseException__object **_exception);
  /* destroyArray: Destroy the array (NULL arrays are ignored) */
  void (*destroyArray)(/*in*/ struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__array *array, /*out*/ struct ASE_BaseException__object **_exception);
  /* getDimen: Return the number of dimensions in the array
If the array pointer is NULL, zero is returned */
  int32_t (*getDimen)(/*in*/ struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__array *array, /*out*/ struct ASE_BaseException__object **_exception);
  /* getLower: Return the lower bound on dimension ind
If the array pointer is NULL or dimen is not a valid dimension, zero is returned */
  int32_t (*getLower)(/*in*/ struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception);
  /* getUpper: Return the upper bound on dimension ind
If the array pointer is NULL or dimen is not a valid dimension, -1 is returned */
  int32_t (*getUpper)(/*in*/ struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception);
  /* getElement: Get an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the return value is non-NULL, the client owns one reference to the object/interface
The client must decrement the reference count when done with the reference */
  struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *(*getElement)(/*in*/ struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__array *array, /*in*/ struct int__array *indices, /*out*/ struct ASE_BaseException__object **_exception);
  /* getElement4: Get an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the return value is non-NULL, the client owns one reference to the object/interface
The client must decrement the reference count when done with the reference */
  struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *(*getElement4)(/*in*/ struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*out*/ struct ASE_BaseException__object **_exception);
  /* setElement: Set an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the incoming value is non-NULL, this function will increment the reference code of the object/interface
If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
  void (*setElement)(/*in*/ struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__array *array, /*in*/ struct int__array *indices, /*in*/ struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *value, /*out*/ struct ASE_BaseException__object **_exception);
  /* setElement4: Set an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the incoming value is non-NULL, this function will increment the reference code of the object/interface
If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
  void (*setElement4)(/*in*/ struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*in*/ struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__object *value, /*out*/ struct ASE_BaseException__object **_exception);
};

/* This function, called upon loading the DLL, returns a pointer to the static structure of DLL entry points */
const struct ASE_Compiler_Bootstrap_BootstrapStubGenerator__external *ASE_Compiler_Bootstrap_BootstrapStubGenerator__externals(void);

#ifdef __cplusplus
}
#endif
#endif
