# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Python.Vertex
import ASE.Compiler.Python.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Const:
  '''
  A Python constant
  This will be templated later
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.value = 0
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitConst(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.Const.Const()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    if isinstance(self.value, str):
      root.setValue_string(self.value)
    elif isinstance(self.value, char):
      root.setValue_char(self.value)
    elif isinstance(self.value, int):
      root.setValue_int(self.value)
    elif isinstance(self.value, float):
      root.setValue_double(self.value)
    elif isinstance(self.value, complex):
      root.setValue_dcomplex(self.value)
    return root
  
  def getValue_bool(self):
    '''
    Retrieve the constant value
    '''
    return bool(self.value)
  
  def getValue_char(self):
    '''
    Retrieve the constant value
    '''
    return chr(self.value)
  
  def getValue_dcomplex(self):
    '''
    Retrieve the constant value
    '''
    return complex(self.value)
  
  def getValue_double(self):
    '''
    Retrieve the constant value
    '''
    return float(self.value)
  
  def getValue_int(self):
    '''
    Retrieve the constant value
    '''
    return int(self.value)
  
  def getValue_string(self):
    '''
    Retrieve the constant value
    '''
    return str(self.value)
  
  def setValue_bool(self, value):
    '''
    Set the constant value
    '''
    self.value = value
  
  def setValue_char(self, value):
    '''
    Set the constant value
    '''
    self.value = value
  
  def setValue_dcomplex(self, value):
    '''
    Set the constant value
    '''
    self.value = value
  
  def setValue_double(self, value):
    '''
    Set the constant value
    '''
    self.value = value
  
  def setValue_int(self, value):
    '''
    Set the constant value
    '''
    self.value = value
  
  def setValue_string(self, value):
    '''
    Set the constant value
    '''
    self.value = value
  # Ending class methods section
  pass
