# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Python.Vertex
import ASE.Compiler.Python.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Global:
  '''
  A Python global statement
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.names = []
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitGlobal(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.Global.Global()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    root.setNames([name for name in self.__IORself.getNames()])
    return root
  
  def getNames(self):
    '''
    Retrieve the variable names
    '''
    return self.names
  
  def setNames(self, names):
    '''
    Set the variable names
    '''
    self.names = list(names)
  # Ending class methods section
  pass
