# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Python.Vertex
import ASE.Compiler.Python.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class ListComp:
  '''
  A Python list comprehension
  The child is the expression which generates the elements
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.qualifiers = []
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitListComp(self.__IORself)
  
  def getQualifiers(self):
    '''
    Retrieve the qualifiers for the iteration
    '''
    return self.qualifiers
  
  def setQualifiers(self, qualifiers):
    '''
    Set the qualifiers for the iteration
    '''
    self.qualifiers = list(qualifiers)
  
  def addQualifiers(self, qualifiers):
    '''
    Add qualifiers to the iteration
    '''
    self.qualifiers.extend(qualifiers)
  
  def removeQualifiers(self, qualifiers):
    '''
    Remove qualifiers from the iteration
    Throws an exception if a qualifier does not exist
    '''
    for qualifier in qualifiers:
      if qualifier in self.qualifiers:
        self.qualifiers.remove(qualifier)
      else:
        e = ASE.Compiler.CompilerException.CompilerException()
        e.setMessage('Qualifier does not exist: ' + qualifier.getIdentifier())
        raise e
  # Ending class methods section
  pass
