# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Python.Vertex
import ASE.Compiler.Python.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Print:
  '''
  A Python print statement ending with a comma
  The children are the expressions
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.dest = None
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitPrint(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.Vertex.Vertex()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    root.setDest(self.__IORself.getDest().copy())
    return root
  
  def getDest(self):
    '''
    Retrieve the destination, null if stdout
    '''
    return self.dest
  
  def setDest(self, dest):
    '''
    Set the destination, null for stdout
    '''
    self.dest = dest
  # Ending class methods section
  pass
