# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.SIDL.Type
import ASE.Compiler.SIDL.Vertex
import ASE.Compiler.SIDL.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Enumeration:
  '''
  A SIDL enumeration
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.__IORself.setBaseType(0)
    self.initialized = 0
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitEnumeration(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.SIDL.Enumeration.Enumeration()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    root.setInitialized(self.__IORself.getInitialized())
    return root
  
  def getInitialized(self):
    '''
    Retrieve the flag indicating whether the enumeration values are specified
    '''
    return self.initialized
  
  def setInitialized(self, initialized):
    '''
    Set the flag indicating whether the enumeration values are specified
    '''
    self.initialized = initialized
  # Ending class methods section
  pass
