
class SkeletonGenerator:
  '''
  This is merely a tagging interface to indicate that skeleton code is generated
  '''
  
  def __init__(self, obj):
    '''
    This is merely a tagging interface to indicate that skeleton code is generated
    '''
    self.obj = obj
  
  def __eq__(self, obj):
    if not hasattr(obj, 'obj'):
      return 0
    return self.isSame(obj)
  
  def __getattr__(self, attr):
    '''
    Every call to the interface is dispatched to the underlying class
    '''
    return getattr(self.obj, attr)
  
  def weakReference(self):
    return self
