#include <stdlib.h>

#ifndef included_ASE_Compiler_Cxx_Enumeration_stub
#include <ASE/Compiler/Cxx/Enumeration_Stub.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_Cxx_Enumeration_Enumeration(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (obj)
  {
    return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.Cxx.Enumeration", _exception);
  }
  else
  {
    const struct ASE_Compiler_Cxx_Enumeration__external *(*_extFunc)(void);
    
    _extFunc = (const struct ASE_Compiler_Cxx_Enumeration__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.Cxx.Enumeration", &_exception);
    return (*((*_extFunc)()->createObject))(_exception);
  }
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_Cxx_Enumeration_clone(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->clone))(self->d_object, _exception);
}

const char *ASE_Compiler_Cxx_Enumeration_getIdentifier(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getIdentifier))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Enumeration_setIdentifier(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ const char *identifier, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setIdentifier))(self->d_object, identifier, _exception);
}

struct ASE_Compiler_Attribute__array *ASE_Compiler_Cxx_Enumeration_getAttributes(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttributes))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Enumeration_setAttributes(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ struct ASE_Compiler_Attribute__array *attributes, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setAttributes))(self->d_object, attributes, _exception);
}

int ASE_Compiler_Cxx_Enumeration_hasAttribute(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->hasAttribute))(self->d_object, name, _exception);
}

void ASE_Compiler_Cxx_Enumeration_addAttribute(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ struct ASE_Compiler_Attribute__object *attribute, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addAttribute))(self->d_object, attribute, _exception);
}

void ASE_Compiler_Cxx_Enumeration_deleteAttribute(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Attribute__object *ASE_Compiler_Cxx_Enumeration_getAttribute(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_Cxx_Enumeration_getParent(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getParent))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Enumeration_setParent(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ struct ASE_Compiler_Vertex__object *parent, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setParent))(self->d_object, parent, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_Enumeration_getChildren(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getChildren))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Enumeration_setChildren(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_Cxx_Enumeration_addChildren(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_Cxx_Enumeration_removeChildren(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeChildren))(self->d_object, children, _exception);
}

int32_t ASE_Compiler_Cxx_Enumeration_getLineNumber(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getLineNumber))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Enumeration_setLineNumber(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ int32_t lineNumber, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setLineNumber))(self->d_object, lineNumber, _exception);
}

struct ASE_Compiler_Comment__array *ASE_Compiler_Cxx_Enumeration_getComments(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getComments))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Enumeration_setComments(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_Cxx_Enumeration_addComments(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_Cxx_Enumeration_removeComments(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeComments))(self->d_object, comments, _exception);
}

int32_t ASE_Compiler_Cxx_Enumeration_getReferenceCount(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Enumeration_addReference(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Enumeration_deleteReference(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_Cxx_Enumeration_isSame(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_Cxx_Enumeration_getClassName(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_Cxx_Enumeration_getName(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Enumeration_setName(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_Cxx_Enumeration_isInstanceOf(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_Cxx_Enumeration_getSuper(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}

int ASE_Compiler_Cxx_Enumeration_getBaseType(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getBaseType))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Enumeration_setBaseType(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ int baseType, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setBaseType))(self->d_object, baseType, _exception);
}

int ASE_Compiler_Cxx_Enumeration_getConst(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getConst))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Enumeration_setConst(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ int isConst, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setConst))(self->d_object, isConst, _exception);
}

int ASE_Compiler_Cxx_Enumeration_getVolatile(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getVolatile))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Enumeration_setVolatile(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ int isVolatile, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setVolatile))(self->d_object, isVolatile, _exception);
}

void ASE_Compiler_Cxx_Enumeration_accept(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ struct ASE_Compiler_Cxx_Visitor__object *visitor, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->accept))(self->d_object, visitor, _exception);
}

struct ASE_Compiler_Cxx_Vertex__object *ASE_Compiler_Cxx_Enumeration_copy(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->copy))(self->d_object, _exception);
}

int ASE_Compiler_Cxx_Enumeration_getInitialized(struct ASE_Compiler_Cxx_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getInitialized))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Enumeration_setInitialized(struct ASE_Compiler_Cxx_Enumeration__object *self, /*in*/ int initialized, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setInitialized))(self->d_object, initialized, _exception);
}
