#include <stdlib.h>

#ifndef included_ASE_Compiler_Cxx_Printer_stub
#include <ASE/Compiler/Cxx/Printer_Stub.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_Cxx_Printer_Printer(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (obj)
  {
    return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.Cxx.Printer", _exception);
  }
  else
  {
    const struct ASE_Compiler_Cxx_Printer__external *(*_extFunc)(void);
    
    _extFunc = (const struct ASE_Compiler_Cxx_Printer__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.Cxx.Printer", &_exception);
    return (*((*_extFunc)()->createObject))(_exception);
  }
}

const char *ASE_Compiler_Cxx_Printer_getTab(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getTab))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Printer_setTab(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ const char *tab, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setTab))(self->d_object, tab, _exception);
}

int32_t ASE_Compiler_Cxx_Printer_getIndentSize(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getIndentSize))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Printer_setIndentSize(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ int32_t indentSize, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setIndentSize))(self->d_object, indentSize, _exception);
}

void ASE_Compiler_Cxx_Printer_increaseIndent(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->increaseIndent))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Printer_decreaseIndent(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->decreaseIndent))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Printer_indent(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->indent))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Printer_write(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->write))(self->d_object, s, _exception);
}

void ASE_Compiler_Cxx_Printer_println(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->println))(self->d_object, s, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_Printer_getRepository(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getRepository))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Printer_setRepository(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setRepository))(self->d_object, repository, _exception);
}

void ASE_Compiler_Cxx_Printer_visitVertex(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitVertex))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitSource(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Source__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitSource))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitHeader(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Header__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitHeader))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitPythonModule(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_PythonModule__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPythonModule))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitExpression(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Expression__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitExpression))(self->d_object, vertex, _exception);
}

int ASE_Compiler_Cxx_Printer_getReverseEdges(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReverseEdges))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Printer_setReverseEdges(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setReverseEdges))(self->d_object, reverseEdges, _exception);
}

void ASE_Compiler_Cxx_Printer_traverseVertex(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->traverseVertex))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_resetVertexNumbering(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->resetVertexNumbering))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Printer_discoverVertex(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->discoverVertex))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_finishVertex(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->finishVertex))(self->d_object, vertex, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_Printer_getVerticesSeen(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getVerticesSeen))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Printer_setVerticesSeen(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setVerticesSeen))(self->d_object, seen, _exception);
}

int ASE_Compiler_Cxx_Printer_getVertexSeen(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getVertexSeen))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_setVertexSeen(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setVertexSeen))(self->d_object, vertex, state, _exception);
}

int32_t ASE_Compiler_Cxx_Printer_getReferenceCount(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Printer_addReference(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Printer_deleteReference(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_Cxx_Printer_isSame(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_Cxx_Printer_getClassName(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_Cxx_Printer_getName(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Printer_setName(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_Cxx_Printer_isInstanceOf(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_Cxx_Printer_getSuper(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}

void ASE_Compiler_Cxx_Printer_visitInclude(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Include__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitInclude))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitDefine(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Define__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitDefine))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitMacro(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Macro__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitMacro))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitPreprocessorConditional(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_PreprocessorConditional__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPreprocessorConditional))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitType(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Type__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitType))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitPointer(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Pointer__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitPointer))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitStruct(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Struct__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitStruct))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitBitField(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_BitField__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitBitField))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitEnumeration(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Enumeration__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitEnumeration))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitEnumerator(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Enumerator__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitEnumerator))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitTypedef(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Typedef__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitTypedef))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitGroup(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Group__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitGroup))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitDeclarator(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Declarator__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitDeclarator))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitDeclaratorGroup(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_DeclaratorGroup__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitDeclaratorGroup))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitArray(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Array__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitArray))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitFunction(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Function__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitFunction))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitParameter(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Parameter__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitParameter))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitDeclaration(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Declaration__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitDeclaration))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitStatement(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Statement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitStatement))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitExpressionStatement(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_ExpressionStatement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitExpressionStatement))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitCompoundStatement(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_CompoundStatement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitCompoundStatement))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitIf(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_If__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitIf))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitSwitch(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Switch__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitSwitch))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitWhile(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_While__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitWhile))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitFor(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_For__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitFor))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitGoto(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Goto__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitGoto))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitContinue(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Continue__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitContinue))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitBreak(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Break__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitBreak))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitReturn(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Return__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitReturn))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitInitializer(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Initializer__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitInitializer))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Assignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAssignment))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitInclusiveOrAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_InclusiveOrAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitInclusiveOrAssignment))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitExclusiveOrAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_ExclusiveOrAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitExclusiveOrAssignment))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitAndAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_AndAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAndAssignment))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitLeftShiftAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_LeftShiftAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitLeftShiftAssignment))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitRightShiftAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_RightShiftAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitRightShiftAssignment))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitAdditionAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_AdditionAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAdditionAssignment))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitSubtractionAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_SubtractionAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitSubtractionAssignment))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitMultiplicationAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_MultiplicationAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitMultiplicationAssignment))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitDivisionAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_DivisionAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitDivisionAssignment))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitModuloAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_ModuloAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitModuloAssignment))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitLogicalOr(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_LogicalOr__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitLogicalOr))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitLogicalAnd(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_LogicalAnd__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitLogicalAnd))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitInclusiveOr(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_InclusiveOr__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitInclusiveOr))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitExclusiveOr(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_ExclusiveOr__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitExclusiveOr))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitAnd(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_And__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAnd))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitEquality(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Equality__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitEquality))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitInequality(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Inequality__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitInequality))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitLessThan(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_LessThan__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitLessThan))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitGreaterThan(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_GreaterThan__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitGreaterThan))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitLessThanOrEqual(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_LessThanOrEqual__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitLessThanOrEqual))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitGreaterThanOrEqual(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_GreaterThanOrEqual__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitGreaterThanOrEqual))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitLeftShift(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_LeftShift__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitLeftShift))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitRightShift(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_RightShift__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitRightShift))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitAddition(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Addition__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAddition))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitSubtraction(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Subtraction__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitSubtraction))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitMultiplication(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Multiplication__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitMultiplication))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitDivision(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Division__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitDivision))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitModulo(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Modulo__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitModulo))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitCast(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Cast__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitCast))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitSizeof(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Sizeof__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitSizeof))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitAddress(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Address__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitAddress))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitIndirection(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Indirection__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitIndirection))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitUnaryPlus(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_UnaryPlus__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitUnaryPlus))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitUnaryMinus(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_UnaryMinus__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitUnaryMinus))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitComplement(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Complement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitComplement))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitNegation(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Negation__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitNegation))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitIncrement(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Increment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitIncrement))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitStructReference(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_StructReference__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitStructReference))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitArrayReference(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_ArrayReference__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitArrayReference))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitFunctionCall(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_FunctionCall__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitFunctionCall))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitVariable(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Variable__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitVariable))(self->d_object, vertex, _exception);
}

void ASE_Compiler_Cxx_Printer_visitConstant(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Constant__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitConstant))(self->d_object, vertex, _exception);
}
