#include <stdlib.h>

#ifndef included_ASE_Compiler_Output_stub
#include <ASE/Compiler/Output_Stub.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_Output_Output(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Output__object *_result = NULL;
  
  if (!obj)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Interfaces require an argument for the constructor", _exception);
    if (!(*_exception))
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return _result;
  }
  return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.Output", _exception);
}

int32_t ASE_Compiler_Output_getReferenceCount(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_Output_addReference(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_Output_deleteReference(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_Output_isSame(struct ASE_Compiler_Output__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_Output_getClassName(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_Output_getName(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_Output_setName(struct ASE_Compiler_Output__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_Output_isInstanceOf(struct ASE_Compiler_Output__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_Output_getSuper(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Output_getRepository(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getRepository))(self->d_object, _exception);
}

void ASE_Compiler_Output_setRepository(struct ASE_Compiler_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setRepository))(self->d_object, repository, _exception);
}

void ASE_Compiler_Output_visitVertex(struct ASE_Compiler_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->visitVertex))(self->d_object, vertex, _exception);
}

int ASE_Compiler_Output_getDisableOutput(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getDisableOutput))(self->d_object, _exception);
}

void ASE_Compiler_Output_setDisableOutput(struct ASE_Compiler_Output__object *self, /*in*/ int disableOutput, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setDisableOutput))(self->d_object, disableOutput, _exception);
}

int ASE_Compiler_Output_getDisableSource(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getDisableSource))(self->d_object, _exception);
}

void ASE_Compiler_Output_setDisableSource(struct ASE_Compiler_Output__object *self, /*in*/ int disableSource, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setDisableSource))(self->d_object, disableSource, _exception);
}

const char *ASE_Compiler_Output_getRoot(struct ASE_Compiler_Output__object *self, /*in*/ enum ASE_Compiler_CodePurpose__enum purpose, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getRoot))(self->d_object, purpose, _exception);
}

void ASE_Compiler_Output_setRoot(struct ASE_Compiler_Output__object *self, /*in*/ enum ASE_Compiler_CodePurpose__enum purpose, /*in*/ const char *root, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setRoot))(self->d_object, purpose, root, _exception);
}

struct string__array *ASE_Compiler_Output_getIncludeDirectories(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getIncludeDirectories))(self->d_object, _exception);
}

void ASE_Compiler_Output_setIncludeDirectories(struct ASE_Compiler_Output__object *self, /*in*/ struct string__array *dirs, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setIncludeDirectories))(self->d_object, dirs, _exception);
}

struct string__array *ASE_Compiler_Output_getSystemIncludeDirectories(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSystemIncludeDirectories))(self->d_object, _exception);
}

void ASE_Compiler_Output_setSystemIncludeDirectories(struct ASE_Compiler_Output__object *self, /*in*/ struct string__array *dirs, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setSystemIncludeDirectories))(self->d_object, dirs, _exception);
}

struct string__array *ASE_Compiler_Output_getFiles(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getFiles))(self->d_object, _exception);
}

void ASE_Compiler_Output_setFiles(struct ASE_Compiler_Output__object *self, /*in*/ struct string__array *files, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setFiles))(self->d_object, files, _exception);
}
