#ifndef included_ASE_Compiler_SIDL_Enumeration
#define included_ASE_Compiler_SIDL_Enumeration

#ifdef __cplusplus
extern "C" {
#endif

#include <sys/types.h>

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Enumeration__object;

struct ASE_Compiler_SIDL_Enumeration__array;

struct ASE_BaseException__object;

struct ASE_BaseException__array;

/* These structures are used in this header */
struct ASE_Compiler_Comment__object;

struct ASE_Compiler_Comment__array;

/* These structures are used in this header */
struct ASE_BaseInterface__object;

struct ASE_BaseInterface__array;

#ifndef included_bool
#include "bool_IOR.h"
#endif

/* These structures are used in this header */
struct ASE_Compiler_CompilerException__object;

struct ASE_Compiler_CompilerException__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Vertex__object;

struct ASE_Compiler_SIDL_Vertex__array;

/* These structures are used in this header */
struct ASE_BaseException__object;

struct ASE_BaseException__array;

#ifndef included_int
#include "int_IOR.h"
#endif

/* These structures are used in this header */
struct ASE_Compiler_Vertex__object;

struct ASE_Compiler_Vertex__array;

/* These structures are used in this header */
struct ASE_Compiler_Attribute__object;

struct ASE_Compiler_Attribute__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Visitor__object;

struct ASE_Compiler_SIDL_Visitor__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Type__object;

struct ASE_Compiler_SIDL_Type__array;

#ifndef included_string
#include "string_IOR.h"
#endif

#ifndef included_ASE_Compiler_SIDL_Type
#include "ASE/Compiler/SIDL/Type_IOR.h"
#endif

/* The entry point vector (EPV) is the virtual function table for this interface */
struct ASE_Compiler_SIDL_Enumeration__epv {
  /* ASE.Compiler.SIDL.Enumeration.castObject: Builtin method */
  void *(*castObject)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Enumeration.destroyObject: Builtin method */
  void (*destroyObject)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Enumeration.strObject: Builtin method */
  const char *(*strObject)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Enumeration.Enumeration: Builtin method */
  void (*Enumeration)(/*in*/ struct ASE_Compiler_SIDL_Enumeration__object *obj, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Enumeration.Enumeration_: Builtin method */
  void (*Enumeration_)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.clone:  Return an empty object of the same type */
  struct ASE_Compiler_Vertex__object *(*clone)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getIdentifier:  Retrieve the identifier associated with this vertex */
  const char *(*getIdentifier)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.setIdentifier:  Assign the identifier associated with this vertex */
  void (*setIdentifier)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ const char *identifier, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getAttributes:  Get attribute list for this element */
  struct ASE_Compiler_Attribute__array *(*getAttributes)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.setAttributes:  Set attribute list for this element */
  void (*setAttributes)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_Compiler_Attribute__array *attributes, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.hasAttribute:  Determine whether an attribute is present on this vertex */
  int (*hasAttribute)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.addAttribute:  Add attribute to this vertex */
  void (*addAttribute)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_Compiler_Attribute__object *attribute, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.deleteAttribute:  Remove an attribute on this vertex
   Throws an exception if the attribute does not exist */
  void (*deleteAttribute)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getAttribute:  Get an attribute on this vertex
   Throws an exception if the attribute does not exist */
  struct ASE_Compiler_Attribute__object *(*getAttribute)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getParent:  Retrieve the parent of this vertex */
  struct ASE_Compiler_Vertex__object *(*getParent)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.setParent:  Assign the parent of this vertex */
  void (*setParent)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_Compiler_Vertex__object *parent, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getChildren:  Retrieve the children of this vertex */
  struct ASE_Compiler_Vertex__array *(*getChildren)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.setChildren:  Set the children of this vertex */
  void (*setChildren)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.addChildren:  Add children to this vertex (duplicates allowed) */
  void (*addChildren)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.removeChildren:  Remove children from this vertex
   Throws an exception if any child does not exist */
  void (*removeChildren)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getLineNumber:  Retrieve the line number associated with this vertex */
  int32_t (*getLineNumber)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.setLineNumber:  Set the line number associated with this vertex */
  void (*setLineNumber)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ int32_t lineNumber, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getComments:  Retrieve the comments of this vertex */
  struct ASE_Compiler_Comment__array *(*getComments)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.setComments:  Set the children of this vertex */
  void (*setComments)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.addComments:  Add comments to this vertex (duplicates allowed) */
  void (*addComments)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.removeComments:  Remove comments from this vertex
   Throws an exception if a comment does not exist */
  void (*removeComments)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
  int32_t (*getReferenceCount)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
  void (*addReference)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
  void (*deleteReference)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
  int (*isSame)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
  const char *(*getClassName)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getName:  Retrieve the object name */
  const char *(*getName)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.setName:  Set the object name */
  void (*setName)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
  int (*isInstanceOf)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
  struct ASE_BaseInterface__object *(*getSuper)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Vertex.getDependencies:  Retrieve nodes on which this node depends */
  struct ASE_Compiler_SIDL_Vertex__array *(*getDependencies)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Vertex.setDependencies:  Set nodes on which this node depends */
  void (*setDependencies)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Vertex.addDependencies:  Add nodes on which this node depends */
  void (*addDependencies)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Vertex.removeDependencies:  Remove nodes on which this node depends
   Throws an exception if a dependency does not exist */
  void (*removeDependencies)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Type.getFullIdentifier:  Need to override this to calculate the fully qualified type name */
  const char *(*getFullIdentifier)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Type.getBaseType:  Get flag indicating whether this is a base type */
  int (*getBaseType)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Type.setBaseType:  Set flag indicating whether this is a base type */
  void (*setBaseType)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ int baseType, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Enumeration.accept:  Overridden to dispatch correctly */
  void (*accept)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ struct ASE_Compiler_SIDL_Visitor__object *visitor, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Enumeration.copy:  Need to override this */
  struct ASE_Compiler_SIDL_Vertex__object *(*copy)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Enumeration.getInitialized:  Retrieve the flag indicating whether the enumeration values are specified */
  int (*getInitialized)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Enumeration.setInitialized:  Set the flag indicating whether the enumeration values are specified */
  void (*setInitialized)(struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ int initialized, /*out*/ struct ASE_BaseException__object **_exception);
};

/* The IOR object structure for this type */
struct ASE_Compiler_SIDL_Enumeration__object {
  struct ASE_Compiler_SIDL_Type__object ase_compiler_sidl_type;
  struct ASE_Compiler_SIDL_Enumeration__epv *d_epv;
  struct ASE_Compiler_SIDL_Enumeration__epv *d_oldEpv;
  void *d_object;
  void *d_data;
};

/* The IOR array structure for this type */
struct ASE_Compiler_SIDL_Enumeration__array {
  struct ASE_Compiler_SIDL_Enumeration__object **d_firstElement;
  int32_t *d_lower;
  int32_t *d_upper;
  int32_t *d_stride;
  int d_borrowed;
  int32_t d_dimen;
};

/* The entry points into the DLL containing this type */
struct ASE_Compiler_SIDL_Enumeration__external {
  /* ASE.Compiler.SIDL.Enumeration.createObject: Builtin method */
  struct ASE_Compiler_SIDL_Enumeration__object *(*createObject)(/*out*/ struct ASE_BaseException__object **_exception);
  /* initObject:  */
  void (*initObject)(/*in*/ struct ASE_Compiler_SIDL_Enumeration__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception);
  /* finiObject:  */
  void (*finiObject)(/*in*/ struct ASE_Compiler_SIDL_Enumeration__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* createArray: Create a dense array of the given dimension with specified index bounds
This array owns and manages its data
All object pointers are initialized to NULL */
  struct ASE_Compiler_SIDL_Enumeration__array *(*createArray)(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*out*/ struct ASE_BaseException__object **_exception);
  /* borrowArray: Create an array using user-provided memory */
  struct ASE_Compiler_SIDL_Enumeration__array *(*borrowArray)(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*in*/ struct int__array *stride, /*in*/ void *first, /*out*/ struct ASE_BaseException__object **_exception);
  /* destroyArray: Destroy the array (NULL arrays are ignored) */
  void (*destroyArray)(/*in*/ struct ASE_Compiler_SIDL_Enumeration__array *array, /*out*/ struct ASE_BaseException__object **_exception);
  /* getDimen: Return the number of dimensions in the array
If the array pointer is NULL, zero is returned */
  int32_t (*getDimen)(/*in*/ struct ASE_Compiler_SIDL_Enumeration__array *array, /*out*/ struct ASE_BaseException__object **_exception);
  /* getLower: Return the lower bound on dimension ind
If the array pointer is NULL or dimen is not a valid dimension, zero is returned */
  int32_t (*getLower)(/*in*/ struct ASE_Compiler_SIDL_Enumeration__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception);
  /* getUpper: Return the upper bound on dimension ind
If the array pointer is NULL or dimen is not a valid dimension, -1 is returned */
  int32_t (*getUpper)(/*in*/ struct ASE_Compiler_SIDL_Enumeration__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception);
  /* getElement: Get an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the return value is non-NULL, the client owns one reference to the object/interface
The client must decrement the reference count when done with the reference */
  struct ASE_Compiler_SIDL_Enumeration__object *(*getElement)(/*in*/ struct ASE_Compiler_SIDL_Enumeration__array *array, /*in*/ struct int__array *indices, /*out*/ struct ASE_BaseException__object **_exception);
  /* getElement4: Get an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the return value is non-NULL, the client owns one reference to the object/interface
The client must decrement the reference count when done with the reference */
  struct ASE_Compiler_SIDL_Enumeration__object *(*getElement4)(/*in*/ struct ASE_Compiler_SIDL_Enumeration__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*out*/ struct ASE_BaseException__object **_exception);
  /* setElement: Set an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the incoming value is non-NULL, this function will increment the reference code of the object/interface
If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
  void (*setElement)(/*in*/ struct ASE_Compiler_SIDL_Enumeration__array *array, /*in*/ struct int__array *indices, /*in*/ struct ASE_Compiler_SIDL_Enumeration__object *value, /*out*/ struct ASE_BaseException__object **_exception);
  /* setElement4: Set an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the incoming value is non-NULL, this function will increment the reference code of the object/interface
If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
  void (*setElement4)(/*in*/ struct ASE_Compiler_SIDL_Enumeration__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*in*/ struct ASE_Compiler_SIDL_Enumeration__object *value, /*out*/ struct ASE_BaseException__object **_exception);
};

/* This function, called upon loading the DLL, returns a pointer to the static structure of DLL entry points */
const struct ASE_Compiler_SIDL_Enumeration__external *ASE_Compiler_SIDL_Enumeration__externals(void);

#ifdef __cplusplus
}
#endif
#endif
