#ifndef included_ASE_Compiler_SIDL_Method
#define included_ASE_Compiler_SIDL_Method

#ifdef __cplusplus
extern "C" {
#endif

#include <sys/types.h>

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Method__object;

struct ASE_Compiler_SIDL_Method__array;

struct ASE_BaseException__object;

struct ASE_BaseException__array;

/* These structures are used in this header */
struct ASE_Compiler_Comment__object;

struct ASE_Compiler_Comment__array;

/* These structures are used in this header */
struct ASE_BaseInterface__object;

struct ASE_BaseInterface__array;

#ifndef included_bool
#include "bool_IOR.h"
#endif

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Vertex__object;

struct ASE_Compiler_SIDL_Vertex__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Templated__object;

struct ASE_Compiler_SIDL_Templated__array;

/* These structures are used in this header */
struct ASE_BaseException__object;

struct ASE_BaseException__array;

#ifndef included_string
#include "string_IOR.h"
#endif

/* These structures are used in this header */
struct ASE_Compiler_Attribute__object;

struct ASE_Compiler_Attribute__array;

/* These structures are used in this header */
struct ASE_Compiler_Vertex__object;

struct ASE_Compiler_Vertex__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Visitor__object;

struct ASE_Compiler_SIDL_Visitor__array;

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Parameter__object;

struct ASE_Compiler_SIDL_Parameter__array;

/* These structures are used in this header */
struct ASE_Compiler_CompilerException__object;

struct ASE_Compiler_CompilerException__array;

#ifndef included_int
#include "int_IOR.h"
#endif

/* These structures are used in this header */
struct ASE_Compiler_SIDL_Interface__object;

struct ASE_Compiler_SIDL_Interface__array;

#ifndef included_ASE_Compiler_SIDL_Vertex
#include "ASE/Compiler/SIDL/Vertex_IOR.h"
#endif

#ifndef included_ASE_Compiler_SIDL_Templated
#include "ASE/Compiler/SIDL/Templated_IOR.h"
#endif

/* The entry point vector (EPV) is the virtual function table for this interface */
struct ASE_Compiler_SIDL_Method__epv {
  /* ASE.Compiler.SIDL.Method.castObject: Builtin method */
  void *(*castObject)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.destroyObject: Builtin method */
  void (*destroyObject)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.strObject: Builtin method */
  const char *(*strObject)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.Method: Builtin method */
  void (*Method)(/*in*/ struct ASE_Compiler_SIDL_Method__object *obj, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.Method_: Builtin method */
  void (*Method_)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Templated.getTemplateIdentifiers:  Get the identifiers which are quantified over types */
  struct string__array *(*getTemplateIdentifiers)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Templated.setTemplateIdentifiers:  Set the identifiers which are quantified over types */
  void (*setTemplateIdentifiers)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct string__array *templateIds, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.clone:  Return an empty object of the same type */
  struct ASE_Compiler_Vertex__object *(*clone)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.copy:  Return a deep copy of this subtree */
  struct ASE_Compiler_Vertex__object *(*copy)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getIdentifier:  Retrieve the identifier associated with this vertex */
  const char *(*getIdentifier)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.setIdentifier:  Assign the identifier associated with this vertex */
  void (*setIdentifier)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ const char *identifier, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getAttributes:  Get attribute list for this element */
  struct ASE_Compiler_Attribute__array *(*getAttributes)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.setAttributes:  Set attribute list for this element */
  void (*setAttributes)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Attribute__array *attributes, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.hasAttribute:  Determine whether an attribute is present on this vertex */
  int (*hasAttribute)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.addAttribute:  Add attribute to this vertex */
  void (*addAttribute)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Attribute__object *attribute, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.deleteAttribute:  Remove an attribute on this vertex
   Throws an exception if the attribute does not exist */
  void (*deleteAttribute)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getAttribute:  Get an attribute on this vertex
   Throws an exception if the attribute does not exist */
  struct ASE_Compiler_Attribute__object *(*getAttribute)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getParent:  Retrieve the parent of this vertex */
  struct ASE_Compiler_Vertex__object *(*getParent)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.setParent:  Assign the parent of this vertex */
  void (*setParent)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Vertex__object *parent, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getChildren:  Retrieve the children of this vertex */
  struct ASE_Compiler_Vertex__array *(*getChildren)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.setChildren:  Set the children of this vertex */
  void (*setChildren)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.addChildren:  Add children to this vertex (duplicates allowed) */
  void (*addChildren)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.removeChildren:  Remove children from this vertex
   Throws an exception if any child does not exist */
  void (*removeChildren)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getLineNumber:  Retrieve the line number associated with this vertex */
  int32_t (*getLineNumber)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.setLineNumber:  Set the line number associated with this vertex */
  void (*setLineNumber)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ int32_t lineNumber, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.getComments:  Retrieve the comments of this vertex */
  struct ASE_Compiler_Comment__array *(*getComments)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.setComments:  Set the children of this vertex */
  void (*setComments)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.addComments:  Add comments to this vertex (duplicates allowed) */
  void (*addComments)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Vertex.removeComments:  Remove comments from this vertex
   Throws an exception if a comment does not exist */
  void (*removeComments)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
  int32_t (*getReferenceCount)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
  void (*addReference)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
  void (*deleteReference)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
  int (*isSame)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
  const char *(*getClassName)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getName:  Retrieve the object name */
  const char *(*getName)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.setName:  Set the object name */
  void (*setName)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
  int (*isInstanceOf)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
  struct ASE_BaseInterface__object *(*getSuper)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Vertex.getDependencies:  Retrieve nodes on which this node depends */
  struct ASE_Compiler_SIDL_Vertex__array *(*getDependencies)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Vertex.setDependencies:  Set nodes on which this node depends */
  void (*setDependencies)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Vertex.addDependencies:  Add nodes on which this node depends */
  void (*addDependencies)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Vertex.removeDependencies:  Remove nodes on which this node depends
   Throws an exception if a dependency does not exist */
  void (*removeDependencies)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.accept:  Overridden to dispatch correctly */
  void (*accept)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Visitor__object *visitor, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.getFullIdentifier:  Need to override this to calculate the fully qualified method name */
  const char *(*getFullIdentifier)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.getReturnParameter:  Retrieve the return parameter */
  struct ASE_Compiler_SIDL_Parameter__object *(*getReturnParameter)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.setReturnParameter:  Set the return parameter */
  void (*setReturnParameter)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Parameter__object *parameter, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.getExceptions:  Retrieve the exceptions thrown by the method */
  struct ASE_Compiler_SIDL_Interface__array *(*getExceptions)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.setExceptions:  Set the exceptions thrown by the method */
  void (*setExceptions)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *exceptions, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.addExceptions:  Add to the exceptions thrown by the method */
  void (*addExceptions)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *exceptions, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.removeExceptions:  Remove from the exceptions thrown by the method
   Throws an exception if an exception does not exist */
  void (*removeExceptions)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *exceptions, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.getStatic:  Retrieve the flag indicating whether the method is static */
  int (*getStatic)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.setStatic:  Set the flag indicating whether the method is static */
  void (*setStatic)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ int isStatic, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.getInternal:  Retrieve the flag indicating whether the method is not present in the SIDL interface */
  int (*getInternal)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.setInternal:  Set the flag indicating whether the method is not present in the SIDL interface */
  void (*setInternal)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ int isInternal, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.getVirtual:  Retrieve the flag indicating whether this method may be inherited, or must be implemented by every class */
  int (*getVirtual)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.setVirtual:  Set the flag indicating whether this method may be inherited, or must be implemented by every class */
  void (*setVirtual)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ int isVirtual, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.getPurpose:  NOTICE: These should be ASE.Compiler.CodePurpose when this gets fixed
 Retrieve the list of purposes for which this method is defined */
  struct int__array *(*getPurpose)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.setPurpose:  Set the list of purposes for which this method is defined */
  void (*setPurpose)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct int__array *purpose, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.addPurpose:  Add purposes in which the method is defined */
  void (*addPurpose)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct int__array *purpose, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.removePurpose:  Remove purposes in which the method is defined
   Throws an exception if a purpose does not exist */
  void (*removePurpose)(struct ASE_Compiler_SIDL_Method__object *self, /*in*/ struct int__array *purpose, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.getInParameters:  Retrieve the parameters whose values will be read on input */
  struct ASE_Compiler_SIDL_Parameter__array *(*getInParameters)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.SIDL.Method.getOutParameters:  Retrieve the parameters which will return values, including the return value */
  struct ASE_Compiler_SIDL_Parameter__array *(*getOutParameters)(struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
};

/* The IOR object structure for this type */
struct ASE_Compiler_SIDL_Method__object {
  struct ASE_Compiler_SIDL_Vertex__object ase_compiler_sidl_vertex;
  struct ASE_Compiler_SIDL_Templated__object ase_compiler_sidl_templated;
  struct ASE_Compiler_SIDL_Method__epv *d_epv;
  struct ASE_Compiler_SIDL_Method__epv *d_oldEpv;
  void *d_object;
  void *d_data;
};

/* The IOR array structure for this type */
struct ASE_Compiler_SIDL_Method__array {
  struct ASE_Compiler_SIDL_Method__object **d_firstElement;
  int32_t *d_lower;
  int32_t *d_upper;
  int32_t *d_stride;
  int d_borrowed;
  int32_t d_dimen;
};

/* The entry points into the DLL containing this type */
struct ASE_Compiler_SIDL_Method__external {
  /* ASE.Compiler.SIDL.Method.createObject: Builtin method */
  struct ASE_Compiler_SIDL_Method__object *(*createObject)(/*out*/ struct ASE_BaseException__object **_exception);
  /* initObject:  */
  void (*initObject)(/*in*/ struct ASE_Compiler_SIDL_Method__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception);
  /* finiObject:  */
  void (*finiObject)(/*in*/ struct ASE_Compiler_SIDL_Method__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* createArray: Create a dense array of the given dimension with specified index bounds
This array owns and manages its data
All object pointers are initialized to NULL */
  struct ASE_Compiler_SIDL_Method__array *(*createArray)(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*out*/ struct ASE_BaseException__object **_exception);
  /* borrowArray: Create an array using user-provided memory */
  struct ASE_Compiler_SIDL_Method__array *(*borrowArray)(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*in*/ struct int__array *stride, /*in*/ void *first, /*out*/ struct ASE_BaseException__object **_exception);
  /* destroyArray: Destroy the array (NULL arrays are ignored) */
  void (*destroyArray)(/*in*/ struct ASE_Compiler_SIDL_Method__array *array, /*out*/ struct ASE_BaseException__object **_exception);
  /* getDimen: Return the number of dimensions in the array
If the array pointer is NULL, zero is returned */
  int32_t (*getDimen)(/*in*/ struct ASE_Compiler_SIDL_Method__array *array, /*out*/ struct ASE_BaseException__object **_exception);
  /* getLower: Return the lower bound on dimension ind
If the array pointer is NULL or dimen is not a valid dimension, zero is returned */
  int32_t (*getLower)(/*in*/ struct ASE_Compiler_SIDL_Method__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception);
  /* getUpper: Return the upper bound on dimension ind
If the array pointer is NULL or dimen is not a valid dimension, -1 is returned */
  int32_t (*getUpper)(/*in*/ struct ASE_Compiler_SIDL_Method__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception);
  /* getElement: Get an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the return value is non-NULL, the client owns one reference to the object/interface
The client must decrement the reference count when done with the reference */
  struct ASE_Compiler_SIDL_Method__object *(*getElement)(/*in*/ struct ASE_Compiler_SIDL_Method__array *array, /*in*/ struct int__array *indices, /*out*/ struct ASE_BaseException__object **_exception);
  /* getElement4: Get an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the return value is non-NULL, the client owns one reference to the object/interface
The client must decrement the reference count when done with the reference */
  struct ASE_Compiler_SIDL_Method__object *(*getElement4)(/*in*/ struct ASE_Compiler_SIDL_Method__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*out*/ struct ASE_BaseException__object **_exception);
  /* setElement: Set an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the incoming value is non-NULL, this function will increment the reference code of the object/interface
If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
  void (*setElement)(/*in*/ struct ASE_Compiler_SIDL_Method__array *array, /*in*/ struct int__array *indices, /*in*/ struct ASE_Compiler_SIDL_Method__object *value, /*out*/ struct ASE_BaseException__object **_exception);
  /* setElement4: Set an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the incoming value is non-NULL, this function will increment the reference code of the object/interface
If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
  void (*setElement4)(/*in*/ struct ASE_Compiler_SIDL_Method__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*in*/ struct ASE_Compiler_SIDL_Method__object *value, /*out*/ struct ASE_BaseException__object **_exception);
};

/* This function, called upon loading the DLL, returns a pointer to the static structure of DLL entry points */
const struct ASE_Compiler_SIDL_Method__external *ASE_Compiler_SIDL_Method__externals(void);

#ifdef __cplusplus
}
#endif
#endif
