#ifndef included_ASE_Compiler_SIDL_Validator_stub
#define included_ASE_Compiler_SIDL_Validator_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_SIDL_Validator
#include <ASE/Compiler/SIDL/Validator_IOR.h>
#endif

/* ASE.Compiler.SIDL.Validator.Validator: Constructor and cast method */
void *ASE_Compiler_SIDL_Validator_Validator(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
struct ASE_Compiler_Vertex__array *ASE_Compiler_SIDL_Validator_getRepository(struct ASE_Compiler_SIDL_Validator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
void ASE_Compiler_SIDL_Validator_setRepository(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.visitVertex:  */
void ASE_Compiler_SIDL_Validator_visitVertex(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitSpecification:  */
void ASE_Compiler_SIDL_Validator_visitSpecification(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_SIDL_Specification__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitPackage:  */
void ASE_Compiler_SIDL_Validator_visitPackage(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_SIDL_Package__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitType:  */
void ASE_Compiler_SIDL_Validator_visitType(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_SIDL_Type__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitTypeUniverse:  */
void ASE_Compiler_SIDL_Validator_visitTypeUniverse(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_SIDL_TypeUniverse__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitEnumerator:  */
void ASE_Compiler_SIDL_Validator_visitEnumerator(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumerator__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitParameter:  */
void ASE_Compiler_SIDL_Validator_visitParameter(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_SIDL_Parameter__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getReverseEdges:  Retrieve the flag for reversing the orientation of edges in the traversal */
int ASE_Compiler_SIDL_Validator_getReverseEdges(struct ASE_Compiler_SIDL_Validator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setReverseEdges:  Set the flag for reversing the orientation of edges in the traversal */
void ASE_Compiler_SIDL_Validator_setReverseEdges(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.traverseVertex:  Traverse each edge of this vertex */
void ASE_Compiler_SIDL_Validator_traverseVertex(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.resetVertexNumbering:  Reset the vertex discovery and finish numbering */
void ASE_Compiler_SIDL_Validator_resetVertexNumbering(struct ASE_Compiler_SIDL_Validator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.discoverVertex:  Mark a vertex as discovered and increment the count */
void ASE_Compiler_SIDL_Validator_discoverVertex(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.finishVertex:  Mark a vertex as finished and increment the count */
void ASE_Compiler_SIDL_Validator_finishVertex(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getVerticesSeen:  Retrieve the list of vertices discovered */
struct ASE_Compiler_Vertex__array *ASE_Compiler_SIDL_Validator_getVerticesSeen(struct ASE_Compiler_SIDL_Validator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setVerticesSeen:  Set the list of vertices discovered */
void ASE_Compiler_SIDL_Validator_setVerticesSeen(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getVertexSeen:  Retrieve the vertex discovery state */
int ASE_Compiler_SIDL_Validator_getVertexSeen(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setVertexSeen:  Set the vertex discovery state */
void ASE_Compiler_SIDL_Validator_setVertexSeen(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_SIDL_Validator_getReferenceCount(struct ASE_Compiler_SIDL_Validator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_SIDL_Validator_addReference(struct ASE_Compiler_SIDL_Validator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_SIDL_Validator_deleteReference(struct ASE_Compiler_SIDL_Validator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_SIDL_Validator_isSame(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_SIDL_Validator_getClassName(struct ASE_Compiler_SIDL_Validator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_SIDL_Validator_getName(struct ASE_Compiler_SIDL_Validator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_SIDL_Validator_setName(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_SIDL_Validator_isInstanceOf(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_SIDL_Validator_getSuper(struct ASE_Compiler_SIDL_Validator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Validator.visitArray:  Check that array is not nested */
void ASE_Compiler_SIDL_Validator_visitArray(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_SIDL_Array__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Validator.visitEnumeration:  Check that children are enumerators */
void ASE_Compiler_SIDL_Validator_visitEnumeration(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumeration__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Validator.visitInterface:  Check that parents are interfaces */
void ASE_Compiler_SIDL_Validator_visitInterface(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Validator.visitClass:  Check that parents are classes
 Check that it only implements interfaces */
void ASE_Compiler_SIDL_Validator_visitClass(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_SIDL_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Validator.visitMethod:  Check that parent is an interface
 Check that children are parameters */
void ASE_Compiler_SIDL_Validator_visitMethod(struct ASE_Compiler_SIDL_Validator__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__object *node, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
