#include <stdlib.h>

#include <string.h>

#ifndef included_ASE_Compiler_Cxx_Pointer
#include "ASE/Compiler/Cxx/Pointer_IOR.h"
#endif

static const char *getClassName(struct ASE_Compiler_Cxx_Pointer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return strdup("ASE.Compiler.Cxx.Pointer");
}

#ifndef included_ASE_Loader
#include "ASE/Loader_IOR.h"
#endif

#ifndef included_ASE_ASEException
#include "ASE/ASEException_IOR.h"
#endif

static void *castObject(struct ASE_Compiler_Cxx_Pointer__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  /* We are guaranteed here that the first member in any IOR is a ASE.BaseInterface object */
  struct ASE_Compiler_Cxx_Pointer__object *obj = ((struct ASE_BaseInterface__object *) self)->d_object;
  void *cast = NULL;
  
  if (!strcmp(name, "ASE.Compiler.Cxx.Pointer"))
  {
    cast = obj;
  }
  else
  if (!strcmp(name, "ASE.Compiler.Cxx.Type"))
  {
    cast = (&obj->ase_compiler_cxx_type);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Cxx.Vertex"))
  {
    cast = (&(&obj->ase_compiler_cxx_type)->ase_compiler_cxx_vertex);
  }
  else
  if (!strcmp(name, "ASE.BaseClass"))
  {
    cast = (&(&(&obj->ase_compiler_cxx_type)->ase_compiler_cxx_vertex)->ase_baseclass);
  }
  else
  if (!strcmp(name, "ASE.BaseInterface"))
  {
    cast = (&(&(&(&obj->ase_compiler_cxx_type)->ase_compiler_cxx_vertex)->ase_baseclass)->ase_baseinterface);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Vertex"))
  {
    cast = (&(&(&obj->ase_compiler_cxx_type)->ase_compiler_cxx_vertex)->ase_compiler_vertex);
  }
  return cast;
}

static const char *strObject(struct ASE_Compiler_Cxx_Pointer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return "ASE.Compiler.Cxx.Pointer";
}

static void finiObject(/*in*/ struct ASE_Compiler_Cxx_Pointer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_Type__object *parent = &self->ase_compiler_cxx_type;
  const struct ASE_Compiler_Cxx_Type__external *(*extFunc)(void) = (const struct ASE_Compiler_Cxx_Type__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.Compiler.Cxx.Type", _exception);
  void (*parentFini)(/*in*/ struct ASE_Compiler_Cxx_Type__object *self, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->finiObject;
  
  self->ase_compiler_cxx_type.d_epv = self->ase_compiler_cxx_type.d_oldEpv;
  (*(self->d_epv->Pointer_))(self, _exception);
  if (!parentFini)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find finalizer for ASE.Compiler.Cxx.Type", _exception);
    if (!(*_exception))
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentFini)(parent, _exception);
}

static void destroyObject(struct ASE_Compiler_Cxx_Pointer__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  finiObject(self->d_object, _exception);
  memset(self->d_object, 0, sizeof(struct ASE_Compiler_Cxx_Pointer__object));
  free(self->d_object);
}

static void initObject(/*in*/ struct ASE_Compiler_Cxx_Pointer__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_Type__object *parent = &self->ase_compiler_cxx_type;
  const struct ASE_Compiler_Cxx_Type__external *(*extFunc)(void) = (const struct ASE_Compiler_Cxx_Type__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.Compiler.Cxx.Type", _exception);
  void (*parentInit)(/*in*/ struct ASE_Compiler_Cxx_Type__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->initObject;
  int epvInitialized = 0;
  static struct ASE_Compiler_Cxx_Pointer__epv ASE_Compiler_Cxx_Pointer_epv;
  static struct ASE_Compiler_Cxx_Type__epv ASE_Compiler_Cxx_Type_epv;
  static struct ASE_Compiler_Cxx_Vertex__epv ASE_Compiler_Cxx_Vertex_epv;
  static struct ASE_BaseClass__epv ASE_BaseClass_epv;
  static struct ASE_BaseInterface__epv ASE_BaseInterface_epv;
  static struct ASE_Compiler_Vertex__epv ASE_Compiler_Vertex_epv;
  
  if (!parentInit)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find initializer for ASE.Compiler.Cxx.Type", _exception);
    if (!(*_exception))
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentInit)(parent, obj, _exception);
  if (!epvInitialized)
  {
    ASE_Compiler_Cxx_Pointer_epv.castObject = castObject;
    ASE_Compiler_Cxx_Pointer_epv.destroyObject = destroyObject;
    ASE_Compiler_Cxx_Pointer_epv.strObject = strObject;
    ASE_Compiler_Cxx_Pointer_epv.getClassName = getClassName;
    ASE_Compiler_Cxx_Pointer__set_epv(&ASE_Compiler_Cxx_Pointer_epv, _exception);
    /* Override class ASE.Compiler.Cxx.Pointer methods with those of superclass ASE.Compiler.Cxx.Type */
    ASE_Compiler_Cxx_Pointer_epv.clone = self->ase_compiler_cxx_type.d_epv->clone;
    ASE_Compiler_Cxx_Pointer_epv.getIdentifier = self->ase_compiler_cxx_type.d_epv->getIdentifier;
    ASE_Compiler_Cxx_Pointer_epv.setIdentifier = self->ase_compiler_cxx_type.d_epv->setIdentifier;
    ASE_Compiler_Cxx_Pointer_epv.getAttributes = self->ase_compiler_cxx_type.d_epv->getAttributes;
    ASE_Compiler_Cxx_Pointer_epv.setAttributes = self->ase_compiler_cxx_type.d_epv->setAttributes;
    ASE_Compiler_Cxx_Pointer_epv.hasAttribute = self->ase_compiler_cxx_type.d_epv->hasAttribute;
    ASE_Compiler_Cxx_Pointer_epv.addAttribute = self->ase_compiler_cxx_type.d_epv->addAttribute;
    ASE_Compiler_Cxx_Pointer_epv.deleteAttribute = self->ase_compiler_cxx_type.d_epv->deleteAttribute;
    ASE_Compiler_Cxx_Pointer_epv.getAttribute = self->ase_compiler_cxx_type.d_epv->getAttribute;
    ASE_Compiler_Cxx_Pointer_epv.getParent = self->ase_compiler_cxx_type.d_epv->getParent;
    ASE_Compiler_Cxx_Pointer_epv.setParent = self->ase_compiler_cxx_type.d_epv->setParent;
    ASE_Compiler_Cxx_Pointer_epv.getChildren = self->ase_compiler_cxx_type.d_epv->getChildren;
    ASE_Compiler_Cxx_Pointer_epv.setChildren = self->ase_compiler_cxx_type.d_epv->setChildren;
    ASE_Compiler_Cxx_Pointer_epv.addChildren = self->ase_compiler_cxx_type.d_epv->addChildren;
    ASE_Compiler_Cxx_Pointer_epv.removeChildren = self->ase_compiler_cxx_type.d_epv->removeChildren;
    ASE_Compiler_Cxx_Pointer_epv.getLineNumber = self->ase_compiler_cxx_type.d_epv->getLineNumber;
    ASE_Compiler_Cxx_Pointer_epv.setLineNumber = self->ase_compiler_cxx_type.d_epv->setLineNumber;
    ASE_Compiler_Cxx_Pointer_epv.getComments = self->ase_compiler_cxx_type.d_epv->getComments;
    ASE_Compiler_Cxx_Pointer_epv.setComments = self->ase_compiler_cxx_type.d_epv->setComments;
    ASE_Compiler_Cxx_Pointer_epv.addComments = self->ase_compiler_cxx_type.d_epv->addComments;
    ASE_Compiler_Cxx_Pointer_epv.removeComments = self->ase_compiler_cxx_type.d_epv->removeComments;
    ASE_Compiler_Cxx_Pointer_epv.getReferenceCount = self->ase_compiler_cxx_type.d_epv->getReferenceCount;
    ASE_Compiler_Cxx_Pointer_epv.addReference = self->ase_compiler_cxx_type.d_epv->addReference;
    ASE_Compiler_Cxx_Pointer_epv.deleteReference = self->ase_compiler_cxx_type.d_epv->deleteReference;
    ASE_Compiler_Cxx_Pointer_epv.isSame = self->ase_compiler_cxx_type.d_epv->isSame;
    ASE_Compiler_Cxx_Pointer_epv.getName = self->ase_compiler_cxx_type.d_epv->getName;
    ASE_Compiler_Cxx_Pointer_epv.setName = self->ase_compiler_cxx_type.d_epv->setName;
    ASE_Compiler_Cxx_Pointer_epv.isInstanceOf = self->ase_compiler_cxx_type.d_epv->isInstanceOf;
    ASE_Compiler_Cxx_Pointer_epv.getSuper = self->ase_compiler_cxx_type.d_epv->getSuper;
    ASE_Compiler_Cxx_Pointer_epv.getBaseType = self->ase_compiler_cxx_type.d_epv->getBaseType;
    ASE_Compiler_Cxx_Pointer_epv.setBaseType = self->ase_compiler_cxx_type.d_epv->setBaseType;
    ASE_Compiler_Cxx_Pointer_epv.getConst = self->ase_compiler_cxx_type.d_epv->getConst;
    ASE_Compiler_Cxx_Pointer_epv.setConst = self->ase_compiler_cxx_type.d_epv->setConst;
    ASE_Compiler_Cxx_Pointer_epv.getVolatile = self->ase_compiler_cxx_type.d_epv->getVolatile;
    ASE_Compiler_Cxx_Pointer_epv.setVolatile = self->ase_compiler_cxx_type.d_epv->setVolatile;
    /* Virtualize superclass ASE.Compiler.Cxx.Type methods with those of class ASE.Compiler.Cxx.Pointer */
    ASE_Compiler_Cxx_Type_epv.castObject = ASE_Compiler_Cxx_Pointer_epv.castObject;
    ASE_Compiler_Cxx_Type_epv.destroyObject = ASE_Compiler_Cxx_Pointer_epv.destroyObject;
    ASE_Compiler_Cxx_Type_epv.strObject = ASE_Compiler_Cxx_Pointer_epv.strObject;
    ASE_Compiler_Cxx_Type_epv.clone = ASE_Compiler_Cxx_Pointer_epv.clone;
    ASE_Compiler_Cxx_Type_epv.getIdentifier = ASE_Compiler_Cxx_Pointer_epv.getIdentifier;
    ASE_Compiler_Cxx_Type_epv.setIdentifier = ASE_Compiler_Cxx_Pointer_epv.setIdentifier;
    ASE_Compiler_Cxx_Type_epv.getAttributes = ASE_Compiler_Cxx_Pointer_epv.getAttributes;
    ASE_Compiler_Cxx_Type_epv.setAttributes = ASE_Compiler_Cxx_Pointer_epv.setAttributes;
    ASE_Compiler_Cxx_Type_epv.hasAttribute = ASE_Compiler_Cxx_Pointer_epv.hasAttribute;
    ASE_Compiler_Cxx_Type_epv.addAttribute = ASE_Compiler_Cxx_Pointer_epv.addAttribute;
    ASE_Compiler_Cxx_Type_epv.deleteAttribute = ASE_Compiler_Cxx_Pointer_epv.deleteAttribute;
    ASE_Compiler_Cxx_Type_epv.getAttribute = ASE_Compiler_Cxx_Pointer_epv.getAttribute;
    ASE_Compiler_Cxx_Type_epv.getParent = ASE_Compiler_Cxx_Pointer_epv.getParent;
    ASE_Compiler_Cxx_Type_epv.setParent = ASE_Compiler_Cxx_Pointer_epv.setParent;
    ASE_Compiler_Cxx_Type_epv.getChildren = ASE_Compiler_Cxx_Pointer_epv.getChildren;
    ASE_Compiler_Cxx_Type_epv.setChildren = ASE_Compiler_Cxx_Pointer_epv.setChildren;
    ASE_Compiler_Cxx_Type_epv.addChildren = ASE_Compiler_Cxx_Pointer_epv.addChildren;
    ASE_Compiler_Cxx_Type_epv.removeChildren = ASE_Compiler_Cxx_Pointer_epv.removeChildren;
    ASE_Compiler_Cxx_Type_epv.getLineNumber = ASE_Compiler_Cxx_Pointer_epv.getLineNumber;
    ASE_Compiler_Cxx_Type_epv.setLineNumber = ASE_Compiler_Cxx_Pointer_epv.setLineNumber;
    ASE_Compiler_Cxx_Type_epv.getComments = ASE_Compiler_Cxx_Pointer_epv.getComments;
    ASE_Compiler_Cxx_Type_epv.setComments = ASE_Compiler_Cxx_Pointer_epv.setComments;
    ASE_Compiler_Cxx_Type_epv.addComments = ASE_Compiler_Cxx_Pointer_epv.addComments;
    ASE_Compiler_Cxx_Type_epv.removeComments = ASE_Compiler_Cxx_Pointer_epv.removeComments;
    ASE_Compiler_Cxx_Type_epv.getReferenceCount = ASE_Compiler_Cxx_Pointer_epv.getReferenceCount;
    ASE_Compiler_Cxx_Type_epv.addReference = ASE_Compiler_Cxx_Pointer_epv.addReference;
    ASE_Compiler_Cxx_Type_epv.deleteReference = ASE_Compiler_Cxx_Pointer_epv.deleteReference;
    ASE_Compiler_Cxx_Type_epv.isSame = ASE_Compiler_Cxx_Pointer_epv.isSame;
    ASE_Compiler_Cxx_Type_epv.getClassName = ASE_Compiler_Cxx_Pointer_epv.getClassName;
    ASE_Compiler_Cxx_Type_epv.getName = ASE_Compiler_Cxx_Pointer_epv.getName;
    ASE_Compiler_Cxx_Type_epv.setName = ASE_Compiler_Cxx_Pointer_epv.setName;
    ASE_Compiler_Cxx_Type_epv.isInstanceOf = ASE_Compiler_Cxx_Pointer_epv.isInstanceOf;
    ASE_Compiler_Cxx_Type_epv.getSuper = ASE_Compiler_Cxx_Pointer_epv.getSuper;
    ASE_Compiler_Cxx_Type_epv.accept = ASE_Compiler_Cxx_Pointer_epv.accept;
    ASE_Compiler_Cxx_Type_epv.copy = ASE_Compiler_Cxx_Pointer_epv.copy;
    ASE_Compiler_Cxx_Type_epv.getBaseType = ASE_Compiler_Cxx_Pointer_epv.getBaseType;
    ASE_Compiler_Cxx_Type_epv.setBaseType = ASE_Compiler_Cxx_Pointer_epv.setBaseType;
    ASE_Compiler_Cxx_Type_epv.getConst = ASE_Compiler_Cxx_Pointer_epv.getConst;
    ASE_Compiler_Cxx_Type_epv.setConst = ASE_Compiler_Cxx_Pointer_epv.setConst;
    ASE_Compiler_Cxx_Type_epv.getVolatile = ASE_Compiler_Cxx_Pointer_epv.getVolatile;
    ASE_Compiler_Cxx_Type_epv.setVolatile = ASE_Compiler_Cxx_Pointer_epv.setVolatile;
    /* Override class ASE.Compiler.Cxx.Type methods with those of superclass ASE.Compiler.Cxx.Vertex */
    ASE_Compiler_Cxx_Type_epv.clone = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->clone;
    ASE_Compiler_Cxx_Type_epv.getIdentifier = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->getIdentifier;
    ASE_Compiler_Cxx_Type_epv.setIdentifier = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->setIdentifier;
    ASE_Compiler_Cxx_Type_epv.getAttributes = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->getAttributes;
    ASE_Compiler_Cxx_Type_epv.setAttributes = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->setAttributes;
    ASE_Compiler_Cxx_Type_epv.hasAttribute = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->hasAttribute;
    ASE_Compiler_Cxx_Type_epv.addAttribute = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->addAttribute;
    ASE_Compiler_Cxx_Type_epv.deleteAttribute = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->deleteAttribute;
    ASE_Compiler_Cxx_Type_epv.getAttribute = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->getAttribute;
    ASE_Compiler_Cxx_Type_epv.getParent = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->getParent;
    ASE_Compiler_Cxx_Type_epv.setParent = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->setParent;
    ASE_Compiler_Cxx_Type_epv.getChildren = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->getChildren;
    ASE_Compiler_Cxx_Type_epv.setChildren = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->setChildren;
    ASE_Compiler_Cxx_Type_epv.addChildren = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->addChildren;
    ASE_Compiler_Cxx_Type_epv.removeChildren = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->removeChildren;
    ASE_Compiler_Cxx_Type_epv.getLineNumber = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->getLineNumber;
    ASE_Compiler_Cxx_Type_epv.setLineNumber = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->setLineNumber;
    ASE_Compiler_Cxx_Type_epv.getComments = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->getComments;
    ASE_Compiler_Cxx_Type_epv.setComments = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->setComments;
    ASE_Compiler_Cxx_Type_epv.addComments = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->addComments;
    ASE_Compiler_Cxx_Type_epv.removeComments = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->removeComments;
    ASE_Compiler_Cxx_Type_epv.getReferenceCount = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->getReferenceCount;
    ASE_Compiler_Cxx_Type_epv.addReference = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->addReference;
    ASE_Compiler_Cxx_Type_epv.deleteReference = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->deleteReference;
    ASE_Compiler_Cxx_Type_epv.isSame = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->isSame;
    ASE_Compiler_Cxx_Type_epv.getName = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->getName;
    ASE_Compiler_Cxx_Type_epv.setName = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->setName;
    ASE_Compiler_Cxx_Type_epv.isInstanceOf = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->isInstanceOf;
    ASE_Compiler_Cxx_Type_epv.getSuper = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv->getSuper;
    /* Virtualize superclass ASE.Compiler.Cxx.Vertex methods with those of class ASE.Compiler.Cxx.Type */
    ASE_Compiler_Cxx_Vertex_epv.castObject = ASE_Compiler_Cxx_Type_epv.castObject;
    ASE_Compiler_Cxx_Vertex_epv.destroyObject = ASE_Compiler_Cxx_Type_epv.destroyObject;
    ASE_Compiler_Cxx_Vertex_epv.strObject = ASE_Compiler_Cxx_Type_epv.strObject;
    ASE_Compiler_Cxx_Vertex_epv.clone = ASE_Compiler_Cxx_Type_epv.clone;
    ASE_Compiler_Cxx_Vertex_epv.accept = ASE_Compiler_Cxx_Type_epv.accept;
    ASE_Compiler_Cxx_Vertex_epv.getIdentifier = ASE_Compiler_Cxx_Type_epv.getIdentifier;
    ASE_Compiler_Cxx_Vertex_epv.setIdentifier = ASE_Compiler_Cxx_Type_epv.setIdentifier;
    ASE_Compiler_Cxx_Vertex_epv.getAttributes = ASE_Compiler_Cxx_Type_epv.getAttributes;
    ASE_Compiler_Cxx_Vertex_epv.setAttributes = ASE_Compiler_Cxx_Type_epv.setAttributes;
    ASE_Compiler_Cxx_Vertex_epv.hasAttribute = ASE_Compiler_Cxx_Type_epv.hasAttribute;
    ASE_Compiler_Cxx_Vertex_epv.addAttribute = ASE_Compiler_Cxx_Type_epv.addAttribute;
    ASE_Compiler_Cxx_Vertex_epv.deleteAttribute = ASE_Compiler_Cxx_Type_epv.deleteAttribute;
    ASE_Compiler_Cxx_Vertex_epv.getAttribute = ASE_Compiler_Cxx_Type_epv.getAttribute;
    ASE_Compiler_Cxx_Vertex_epv.getParent = ASE_Compiler_Cxx_Type_epv.getParent;
    ASE_Compiler_Cxx_Vertex_epv.setParent = ASE_Compiler_Cxx_Type_epv.setParent;
    ASE_Compiler_Cxx_Vertex_epv.getChildren = ASE_Compiler_Cxx_Type_epv.getChildren;
    ASE_Compiler_Cxx_Vertex_epv.setChildren = ASE_Compiler_Cxx_Type_epv.setChildren;
    ASE_Compiler_Cxx_Vertex_epv.addChildren = ASE_Compiler_Cxx_Type_epv.addChildren;
    ASE_Compiler_Cxx_Vertex_epv.removeChildren = ASE_Compiler_Cxx_Type_epv.removeChildren;
    ASE_Compiler_Cxx_Vertex_epv.getLineNumber = ASE_Compiler_Cxx_Type_epv.getLineNumber;
    ASE_Compiler_Cxx_Vertex_epv.setLineNumber = ASE_Compiler_Cxx_Type_epv.setLineNumber;
    ASE_Compiler_Cxx_Vertex_epv.getComments = ASE_Compiler_Cxx_Type_epv.getComments;
    ASE_Compiler_Cxx_Vertex_epv.setComments = ASE_Compiler_Cxx_Type_epv.setComments;
    ASE_Compiler_Cxx_Vertex_epv.addComments = ASE_Compiler_Cxx_Type_epv.addComments;
    ASE_Compiler_Cxx_Vertex_epv.removeComments = ASE_Compiler_Cxx_Type_epv.removeComments;
    ASE_Compiler_Cxx_Vertex_epv.getReferenceCount = ASE_Compiler_Cxx_Type_epv.getReferenceCount;
    ASE_Compiler_Cxx_Vertex_epv.addReference = ASE_Compiler_Cxx_Type_epv.addReference;
    ASE_Compiler_Cxx_Vertex_epv.deleteReference = ASE_Compiler_Cxx_Type_epv.deleteReference;
    ASE_Compiler_Cxx_Vertex_epv.isSame = ASE_Compiler_Cxx_Type_epv.isSame;
    ASE_Compiler_Cxx_Vertex_epv.getClassName = ASE_Compiler_Cxx_Type_epv.getClassName;
    ASE_Compiler_Cxx_Vertex_epv.getName = ASE_Compiler_Cxx_Type_epv.getName;
    ASE_Compiler_Cxx_Vertex_epv.setName = ASE_Compiler_Cxx_Type_epv.setName;
    ASE_Compiler_Cxx_Vertex_epv.isInstanceOf = ASE_Compiler_Cxx_Type_epv.isInstanceOf;
    ASE_Compiler_Cxx_Vertex_epv.getSuper = ASE_Compiler_Cxx_Type_epv.getSuper;
    ASE_Compiler_Cxx_Vertex_epv.copy = ASE_Compiler_Cxx_Type_epv.copy;
    /* Override class ASE.Compiler.Cxx.Vertex methods with those of superclass ASE.BaseClass */
    ASE_Compiler_Cxx_Vertex_epv.getReferenceCount = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.ase_baseclass.d_epv->getReferenceCount;
    ASE_Compiler_Cxx_Vertex_epv.addReference = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.ase_baseclass.d_epv->addReference;
    ASE_Compiler_Cxx_Vertex_epv.deleteReference = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.ase_baseclass.d_epv->deleteReference;
    ASE_Compiler_Cxx_Vertex_epv.isSame = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.ase_baseclass.d_epv->isSame;
    ASE_Compiler_Cxx_Vertex_epv.getName = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.ase_baseclass.d_epv->getName;
    ASE_Compiler_Cxx_Vertex_epv.setName = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.ase_baseclass.d_epv->setName;
    ASE_Compiler_Cxx_Vertex_epv.isInstanceOf = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.ase_baseclass.d_epv->isInstanceOf;
    ASE_Compiler_Cxx_Vertex_epv.getSuper = self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.ase_baseclass.d_epv->getSuper;
    /* Virtualize superclass ASE.BaseClass methods with those of class ASE.Compiler.Cxx.Vertex */
    ASE_BaseClass_epv.castObject = ASE_Compiler_Cxx_Vertex_epv.castObject;
    ASE_BaseClass_epv.destroyObject = ASE_Compiler_Cxx_Vertex_epv.destroyObject;
    ASE_BaseClass_epv.strObject = ASE_Compiler_Cxx_Vertex_epv.strObject;
    ASE_BaseClass_epv.getReferenceCount = ASE_Compiler_Cxx_Vertex_epv.getReferenceCount;
    ASE_BaseClass_epv.addReference = ASE_Compiler_Cxx_Vertex_epv.addReference;
    ASE_BaseClass_epv.deleteReference = ASE_Compiler_Cxx_Vertex_epv.deleteReference;
    ASE_BaseClass_epv.isSame = ASE_Compiler_Cxx_Vertex_epv.isSame;
    ASE_BaseClass_epv.getClassName = ASE_Compiler_Cxx_Vertex_epv.getClassName;
    ASE_BaseClass_epv.getName = ASE_Compiler_Cxx_Vertex_epv.getName;
    ASE_BaseClass_epv.setName = ASE_Compiler_Cxx_Vertex_epv.setName;
    ASE_BaseClass_epv.isInstanceOf = ASE_Compiler_Cxx_Vertex_epv.isInstanceOf;
    ASE_BaseClass_epv.getSuper = ASE_Compiler_Cxx_Vertex_epv.getSuper;
    /* Initialize interface ASE.Compiler.Vertex methods with those of class ASE.Compiler.Cxx.Vertex */
    ASE_Compiler_Vertex_epv.castObject = ASE_Compiler_Cxx_Vertex_epv.castObject;
    ASE_Compiler_Vertex_epv.destroyObject = ASE_Compiler_Cxx_Vertex_epv.destroyObject;
    ASE_Compiler_Vertex_epv.strObject = ASE_Compiler_Cxx_Vertex_epv.strObject;
    ASE_Compiler_Vertex_epv.getReferenceCount = ASE_Compiler_Cxx_Vertex_epv.getReferenceCount;
    ASE_Compiler_Vertex_epv.addReference = ASE_Compiler_Cxx_Vertex_epv.addReference;
    ASE_Compiler_Vertex_epv.deleteReference = ASE_Compiler_Cxx_Vertex_epv.deleteReference;
    ASE_Compiler_Vertex_epv.isSame = ASE_Compiler_Cxx_Vertex_epv.isSame;
    ASE_Compiler_Vertex_epv.getClassName = ASE_Compiler_Cxx_Vertex_epv.getClassName;
    ASE_Compiler_Vertex_epv.getName = ASE_Compiler_Cxx_Vertex_epv.getName;
    ASE_Compiler_Vertex_epv.setName = ASE_Compiler_Cxx_Vertex_epv.setName;
    ASE_Compiler_Vertex_epv.isInstanceOf = ASE_Compiler_Cxx_Vertex_epv.isInstanceOf;
    ASE_Compiler_Vertex_epv.getSuper = ASE_Compiler_Cxx_Vertex_epv.getSuper;
    ASE_Compiler_Vertex_epv.clone = ASE_Compiler_Cxx_Vertex_epv.clone;
    ASE_Compiler_Vertex_epv.copy = ASE_Compiler_Cxx_Vertex_epv.copy;
    ASE_Compiler_Vertex_epv.accept = ASE_Compiler_Cxx_Vertex_epv.accept;
    ASE_Compiler_Vertex_epv.getIdentifier = ASE_Compiler_Cxx_Vertex_epv.getIdentifier;
    ASE_Compiler_Vertex_epv.setIdentifier = ASE_Compiler_Cxx_Vertex_epv.setIdentifier;
    ASE_Compiler_Vertex_epv.getAttributes = ASE_Compiler_Cxx_Vertex_epv.getAttributes;
    ASE_Compiler_Vertex_epv.setAttributes = ASE_Compiler_Cxx_Vertex_epv.setAttributes;
    ASE_Compiler_Vertex_epv.hasAttribute = ASE_Compiler_Cxx_Vertex_epv.hasAttribute;
    ASE_Compiler_Vertex_epv.addAttribute = ASE_Compiler_Cxx_Vertex_epv.addAttribute;
    ASE_Compiler_Vertex_epv.deleteAttribute = ASE_Compiler_Cxx_Vertex_epv.deleteAttribute;
    ASE_Compiler_Vertex_epv.getAttribute = ASE_Compiler_Cxx_Vertex_epv.getAttribute;
    ASE_Compiler_Vertex_epv.getParent = ASE_Compiler_Cxx_Vertex_epv.getParent;
    ASE_Compiler_Vertex_epv.setParent = ASE_Compiler_Cxx_Vertex_epv.setParent;
    ASE_Compiler_Vertex_epv.getChildren = ASE_Compiler_Cxx_Vertex_epv.getChildren;
    ASE_Compiler_Vertex_epv.setChildren = ASE_Compiler_Cxx_Vertex_epv.setChildren;
    ASE_Compiler_Vertex_epv.addChildren = ASE_Compiler_Cxx_Vertex_epv.addChildren;
    ASE_Compiler_Vertex_epv.removeChildren = ASE_Compiler_Cxx_Vertex_epv.removeChildren;
    ASE_Compiler_Vertex_epv.getLineNumber = ASE_Compiler_Cxx_Vertex_epv.getLineNumber;
    ASE_Compiler_Vertex_epv.setLineNumber = ASE_Compiler_Cxx_Vertex_epv.setLineNumber;
    ASE_Compiler_Vertex_epv.getComments = ASE_Compiler_Cxx_Vertex_epv.getComments;
    ASE_Compiler_Vertex_epv.setComments = ASE_Compiler_Cxx_Vertex_epv.setComments;
    ASE_Compiler_Vertex_epv.addComments = ASE_Compiler_Cxx_Vertex_epv.addComments;
    ASE_Compiler_Vertex_epv.removeComments = ASE_Compiler_Cxx_Vertex_epv.removeComments;
    /* Initialize interface ASE.BaseInterface methods with those of class ASE.Compiler.Cxx.Vertex */
    ASE_BaseInterface_epv.castObject = ASE_Compiler_Cxx_Vertex_epv.castObject;
    ASE_BaseInterface_epv.destroyObject = ASE_Compiler_Cxx_Vertex_epv.destroyObject;
    ASE_BaseInterface_epv.strObject = ASE_Compiler_Cxx_Vertex_epv.strObject;
    ASE_BaseInterface_epv.getReferenceCount = ASE_Compiler_Cxx_Vertex_epv.getReferenceCount;
    ASE_BaseInterface_epv.addReference = ASE_Compiler_Cxx_Vertex_epv.addReference;
    ASE_BaseInterface_epv.deleteReference = ASE_Compiler_Cxx_Vertex_epv.deleteReference;
    ASE_BaseInterface_epv.isSame = ASE_Compiler_Cxx_Vertex_epv.isSame;
    ASE_BaseInterface_epv.getClassName = ASE_Compiler_Cxx_Vertex_epv.getClassName;
    ASE_BaseInterface_epv.getName = ASE_Compiler_Cxx_Vertex_epv.getName;
    ASE_BaseInterface_epv.setName = ASE_Compiler_Cxx_Vertex_epv.setName;
    ASE_BaseInterface_epv.isInstanceOf = ASE_Compiler_Cxx_Vertex_epv.isInstanceOf;
    ASE_BaseInterface_epv.getSuper = ASE_Compiler_Cxx_Vertex_epv.getSuper;
    epvInitialized = 1;
  }
  self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.ase_baseclass.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.ase_baseclass.d_epv = &ASE_BaseClass_epv;
  self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.ase_compiler_vertex.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.ase_compiler_vertex.d_epv = &ASE_Compiler_Vertex_epv;
  self->ase_compiler_cxx_type.ase_compiler_cxx_vertex.d_epv = &ASE_Compiler_Cxx_Vertex_epv;
  self->ase_compiler_cxx_type.d_epv = &ASE_Compiler_Cxx_Type_epv;
  self->d_epv = &ASE_Compiler_Cxx_Pointer_epv;
  /* Save old EPV for getSuper() */
  self->d_oldEpv = self->d_epv;
  /* Initialize pointers to the original object */
  self->d_object = obj;
  /* Setup implementation data */
  self->d_data = NULL;
  (*(self->d_epv->Pointer))(self, _exception);
}

static struct ASE_Compiler_Cxx_Pointer__object *createObject(/*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_Pointer__object *self = (struct ASE_Compiler_Cxx_Pointer__object *) malloc(sizeof(struct ASE_Compiler_Cxx_Pointer__object));
  
  initObject(self, self, _exception);
  return self;
}

#ifndef included_ASE_ASEException
#include "ASE/ASEException_IOR.h"
#endif

static struct ASE_Compiler_Cxx_Pointer__array *createArray(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*out*/ struct ASE_BaseException__object **_exception)
{
  static int32_t arraySize = sizeof(struct ASE_Compiler_Cxx_Pointer__array) + (sizeof(int32_t) - (sizeof(struct ASE_Compiler_Cxx_Pointer__array)) % sizeof(int32_t)) % sizeof(int32_t);
  struct ASE_Compiler_Cxx_Pointer__array *_return_value = (struct ASE_Compiler_Cxx_Pointer__array *) malloc(arraySize + 3 * sizeof(int32_t) * (dimen ? dimen : 1));
  int32_t size = 1;
  int32_t d = 0;
  
  /* Initialize array structure */
  _return_value->d_dimen = dimen;
  _return_value->d_borrowed = 0;
  _return_value->d_lower = (int32_t *) ((char *) _return_value + arraySize);
  _return_value->d_upper = _return_value->d_lower + (dimen ? dimen : 1);
  _return_value->d_stride = _return_value->d_upper + (dimen ? dimen : 1);
  _return_value->d_lower[0] = 0;
  _return_value->d_upper[0] = 0;
  _return_value->d_stride[0] = 1;
  /* Determine array size and set bounds */
  for(d = 0; d < dimen; d++)
  {
    _return_value->d_lower[d] = lower->d_firstElement[d];
    _return_value->d_upper[d] = upper->d_firstElement[d];
    _return_value->d_stride[d] = size;
    size *= upper->d_firstElement[d] - lower->d_firstElement[d] + 1;
  }
  size *= sizeof(struct ASE_Compiler_Cxx_Pointer__object *);
  /* Allocate and initialize data */
  _return_value->d_firstElement = (struct ASE_Compiler_Cxx_Pointer__object **) malloc(size);
  memset(_return_value->d_firstElement, 0, size);
  return _return_value;
}

static struct ASE_Compiler_Cxx_Pointer__array *borrowArray(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*in*/ struct int__array *stride, /*in*/ void *first, /*out*/ struct ASE_BaseException__object **_exception)
{
  static int32_t arraySize = sizeof(struct ASE_Compiler_Cxx_Pointer__array) + (sizeof(int32_t) - (sizeof(struct ASE_Compiler_Cxx_Pointer__array)) % sizeof(int32_t)) % sizeof(int32_t);
  struct ASE_Compiler_Cxx_Pointer__array *_return_value = (struct ASE_Compiler_Cxx_Pointer__array *) malloc(arraySize + 3 * sizeof(int32_t) * (dimen ? dimen : 1));
  int32_t size = 1;
  int32_t d = 0;
  
  /* Initialize array structure */
  _return_value->d_dimen = dimen;
  _return_value->d_borrowed = 1;
  _return_value->d_lower = (int32_t *) ((char *) _return_value + arraySize);
  _return_value->d_upper = _return_value->d_lower + (dimen ? dimen : 1);
  _return_value->d_stride = _return_value->d_upper + (dimen ? dimen : 1);
  _return_value->d_lower[0] = 0;
  _return_value->d_upper[0] = 0;
  _return_value->d_stride[0] = 1;
  /* Determine array size and set bounds */
  for(d = 0; d < dimen; d++)
  {
    _return_value->d_lower[d] = lower->d_firstElement[d];
    _return_value->d_upper[d] = upper->d_firstElement[d];
    _return_value->d_stride[d] = stride->d_firstElement[d];
    size *= upper->d_firstElement[d] - lower->d_firstElement[d] + 1;
  }
  size *= sizeof(struct ASE_Compiler_Cxx_Pointer__object *);
  _return_value->d_firstElement = (struct ASE_Compiler_Cxx_Pointer__object **) first;
  return _return_value;
}

static void destroyArray(/*in*/ struct ASE_Compiler_Cxx_Pointer__array *array, /*out*/ struct ASE_BaseException__object **_exception)
{
}

static int32_t getDimen(/*in*/ struct ASE_Compiler_Cxx_Pointer__array *array, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_dimen;
}

static int32_t getLower(/*in*/ struct ASE_Compiler_Cxx_Pointer__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_lower[dimen];
}

static int32_t getUpper(/*in*/ struct ASE_Compiler_Cxx_Pointer__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_upper[dimen];
}

static struct ASE_Compiler_Cxx_Pointer__object *getElement(/*in*/ struct ASE_Compiler_Cxx_Pointer__array *array, /*in*/ struct int__array *indices, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_Pointer__object *_result = NULL;
  struct ASE_Compiler_Cxx_Pointer__object **_element = NULL;
  int32_t d = 0;
  
  _element = array->d_firstElement;
  for(d = 0; d < array->d_dimen; d++)
  {
    if (indices->d_firstElement[d] < array->d_lower[d] || indices->d_firstElement[d] > array->d_upper[d])
    {
      struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
      
      _local_exception->d_epv->setMessage(_local_exception, "Invalid indices", _exception);
      if (!(*_exception))
      {
        *_exception = (struct ASE_BaseException__object *) _local_exception;
      }
      return _result;
    }
    _element += array->d_stride[d] * (indices->d_firstElement[d] - array->d_lower[d]);
  }
  if (*_element)
  {
    (*(((struct ASE_BaseInterface__object *) (*_element)->d_object)->d_epv->deleteReference))((*_element)->d_object, (void **) _exception);
  }
  return *_element;
}

static struct ASE_Compiler_Cxx_Pointer__object *getElement4(/*in*/ struct ASE_Compiler_Cxx_Pointer__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*out*/ struct ASE_BaseException__object **_exception)
{
}

static void setElement(/*in*/ struct ASE_Compiler_Cxx_Pointer__array *array, /*in*/ struct int__array *indices, /*in*/ struct ASE_Compiler_Cxx_Pointer__object *value, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_Pointer__object **_element = NULL;
  int32_t d = 0;
  
  _element = array->d_firstElement;
  for(d = 0; d < array->d_dimen; d++)
  {
    if (indices->d_firstElement[d] < array->d_lower[d] || indices->d_firstElement[d] > array->d_upper[d])
    {
      struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
      
      _local_exception->d_epv->setMessage(_local_exception, "Invalid indices", _exception);
      if (!(*_exception))
      {
        *_exception = (struct ASE_BaseException__object *) _local_exception;
      }
      return;
    }
    _element += array->d_stride[d] * (indices->d_firstElement[d] - array->d_lower[d]);
  }
  if (value)
  {
    (*(((struct ASE_BaseInterface__object *) (value)->d_object)->d_epv->addReference))((value)->d_object, (void **) _exception);
  }
  if (*_element)
  {
    (*(((struct ASE_BaseInterface__object *) (*_element)->d_object)->d_epv->deleteReference))((*_element)->d_object, (void **) _exception);
  }
  *_element = value;
}

static void setElement4(/*in*/ struct ASE_Compiler_Cxx_Pointer__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*in*/ struct ASE_Compiler_Cxx_Pointer__object *value, /*out*/ struct ASE_BaseException__object **_exception)
{
}

/* The entry points into the DLL containing this type */
static struct ASE_Compiler_Cxx_Pointer__external externalEntryPoints = {
  createObject,
  initObject,
  finiObject,
  createArray,
  borrowArray,
  destroyArray,
  getDimen,
  getLower,
  getUpper,
  getElement,
  getElement4,
  setElement,
  setElement4};

const struct ASE_Compiler_Cxx_Pointer__external *ASE_Compiler_Cxx_Pointer__externals(void)
{
  return &externalEntryPoints;
}
