# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.CodePurpose
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Source:
  '''
  A C source file
  The children are translation units
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.filename = None
    self.purpose = None
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitSource(self.__IORself)
  
  def getFilename(self):
    '''
    Retrieve the source filename
    '''
    return self.filename
  
  def setFilename(self, filename):
    '''
    Set the source filename
    '''
    self.filename = filename
  
  def getPurpose(self):
    '''
    Retrieve the purpose of this source file
    '''
    return self.purpose
  
  def setPurpose(self, purpose):
    '''
    Set the purpose of this source file
    '''
    self.purpose = purpose
  # Ending class methods section
  pass
