# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Assignment
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class DivisionAssignment:
  '''
  A C assignment expression (/=)
  The children are the lvalue and rvalue
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.__IORself.setIdentifier('/=')
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitDivisionAssignment(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.DivisionAssignment.DivisionAssignment()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    [child.deleteReference() for child in root.getChildren()]
    root.addReference()
    return root
  # Ending class methods section
  pass
