# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Expression
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Increment:
  '''
  A C increment expression (++, --)
  The child is the expression to be incremented
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.isDecrement = 0
    self.isPostfix = 0
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitIncrement(self.__IORself)
  
  def getDecrement(self):
    '''
    Retrieve the flag for a decrement
    '''
    return self.isDecrement
  
  def setDecrement(self, isDecrement):
    '''
    Set the flag for a decrement
    '''
    self.isDecrement = isDecrement
  
  def getPostfix(self):
    '''
    Retrieve the flag for a postincrement
    '''
    return self.isPostfix
  
  def setPostfix(self, isPostfix):
    '''
    Set the flag for a decrement
    '''
    self.isPostfix = isPostfix
  # Ending class methods section
  pass
