#include <stdlib.h>

#include <string.h>

#ifndef included_ASE_Compiler_Cxx_Output
#include "ASE/Compiler/Cxx/Output_IOR.h"
#endif

static const char *getClassName(struct ASE_Compiler_Cxx_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return strdup("ASE.Compiler.Cxx.Output");
}

#ifndef included_ASE_Loader
#include "ASE/Loader_IOR.h"
#endif

#ifndef included_ASE_ASEException
#include "ASE/ASEException_IOR.h"
#endif

static void *castObject(struct ASE_Compiler_Cxx_Output__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  /* We are guaranteed here that the first member in any IOR is a ASE.BaseInterface object */
  struct ASE_Compiler_Cxx_Output__object *obj = ((struct ASE_BaseInterface__object *) self)->d_object;
  void *cast = NULL;
  
  if (!strcmp(name, "ASE.Compiler.Cxx.Output"))
  {
    cast = obj;
  }
  else
  if (!strcmp(name, "ASE.Compiler.Cxx.Printer"))
  {
    cast = (&obj->ase_compiler_cxx_printer);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Cxx.DepthFirstVisitor"))
  {
    cast = (&(&obj->ase_compiler_cxx_printer)->ase_compiler_cxx_depthfirstvisitor);
  }
  else
  if (!strcmp(name, "ASE.BaseClass"))
  {
    cast = (&(&(&obj->ase_compiler_cxx_printer)->ase_compiler_cxx_depthfirstvisitor)->ase_baseclass);
  }
  else
  if (!strcmp(name, "ASE.BaseInterface"))
  {
    cast = (&(&(&(&obj->ase_compiler_cxx_printer)->ase_compiler_cxx_depthfirstvisitor)->ase_baseclass)->ase_baseinterface);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Cxx.Visitor"))
  {
    cast = (&(&(&obj->ase_compiler_cxx_printer)->ase_compiler_cxx_depthfirstvisitor)->ase_compiler_cxx_visitor);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Visitor"))
  {
    cast = (&(&(&(&obj->ase_compiler_cxx_printer)->ase_compiler_cxx_depthfirstvisitor)->ase_compiler_cxx_visitor)->ase_compiler_visitor);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Search"))
  {
    cast = (&(&(&obj->ase_compiler_cxx_printer)->ase_compiler_cxx_depthfirstvisitor)->ase_compiler_search);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Printer"))
  {
    cast = (&(&obj->ase_compiler_cxx_printer)->ase_compiler_printer);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Output"))
  {
    cast = (&obj->ase_compiler_output);
  }
  return cast;
}

static const char *strObject(struct ASE_Compiler_Cxx_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return "ASE.Compiler.Cxx.Output";
}

static void finiObject(/*in*/ struct ASE_Compiler_Cxx_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_Printer__object *parent = &self->ase_compiler_cxx_printer;
  const struct ASE_Compiler_Cxx_Printer__external *(*extFunc)(void) = (const struct ASE_Compiler_Cxx_Printer__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.Compiler.Cxx.Printer", _exception);
  void (*parentFini)(/*in*/ struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->finiObject;
  
  self->ase_compiler_output.d_epv = self->ase_compiler_output.d_oldEpv;
  self->ase_compiler_cxx_printer.d_epv = self->ase_compiler_cxx_printer.d_oldEpv;
  (*(self->d_epv->Output_))(self, _exception);
  if (!parentFini)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find finalizer for ASE.Compiler.Cxx.Printer", _exception);
    if (!(*_exception))
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentFini)(parent, _exception);
}

static void destroyObject(struct ASE_Compiler_Cxx_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  finiObject(self->d_object, _exception);
  memset(self->d_object, 0, sizeof(struct ASE_Compiler_Cxx_Output__object));
  free(self->d_object);
}

static void initObject(/*in*/ struct ASE_Compiler_Cxx_Output__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_Printer__object *parent = &self->ase_compiler_cxx_printer;
  const struct ASE_Compiler_Cxx_Printer__external *(*extFunc)(void) = (const struct ASE_Compiler_Cxx_Printer__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.Compiler.Cxx.Printer", _exception);
  void (*parentInit)(/*in*/ struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->initObject;
  int epvInitialized = 0;
  static struct ASE_Compiler_Cxx_Output__epv ASE_Compiler_Cxx_Output_epv;
  static struct ASE_Compiler_Cxx_Printer__epv ASE_Compiler_Cxx_Printer_epv;
  static struct ASE_Compiler_Cxx_DepthFirstVisitor__epv ASE_Compiler_Cxx_DepthFirstVisitor_epv;
  static struct ASE_BaseClass__epv ASE_BaseClass_epv;
  static struct ASE_BaseInterface__epv ASE_BaseInterface_epv;
  static struct ASE_Compiler_Cxx_Visitor__epv ASE_Compiler_Cxx_Visitor_epv;
  static struct ASE_Compiler_Visitor__epv ASE_Compiler_Visitor_epv;
  static struct ASE_Compiler_Search__epv ASE_Compiler_Search_epv;
  static struct ASE_Compiler_Printer__epv ASE_Compiler_Printer_epv;
  static struct ASE_Compiler_Output__epv ASE_Compiler_Output_epv;
  
  if (!parentInit)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find initializer for ASE.Compiler.Cxx.Printer", _exception);
    if (!(*_exception))
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentInit)(parent, obj, _exception);
  if (!epvInitialized)
  {
    ASE_Compiler_Cxx_Output_epv.castObject = castObject;
    ASE_Compiler_Cxx_Output_epv.destroyObject = destroyObject;
    ASE_Compiler_Cxx_Output_epv.strObject = strObject;
    ASE_Compiler_Cxx_Output_epv.getClassName = getClassName;
    ASE_Compiler_Cxx_Output__set_epv(&ASE_Compiler_Cxx_Output_epv, _exception);
    /* Override class ASE.Compiler.Cxx.Output methods with those of superclass ASE.Compiler.Cxx.Printer */
    ASE_Compiler_Cxx_Output_epv.getTab = self->ase_compiler_cxx_printer.d_epv->getTab;
    ASE_Compiler_Cxx_Output_epv.setTab = self->ase_compiler_cxx_printer.d_epv->setTab;
    ASE_Compiler_Cxx_Output_epv.getIndentSize = self->ase_compiler_cxx_printer.d_epv->getIndentSize;
    ASE_Compiler_Cxx_Output_epv.setIndentSize = self->ase_compiler_cxx_printer.d_epv->setIndentSize;
    ASE_Compiler_Cxx_Output_epv.increaseIndent = self->ase_compiler_cxx_printer.d_epv->increaseIndent;
    ASE_Compiler_Cxx_Output_epv.decreaseIndent = self->ase_compiler_cxx_printer.d_epv->decreaseIndent;
    ASE_Compiler_Cxx_Output_epv.indent = self->ase_compiler_cxx_printer.d_epv->indent;
    ASE_Compiler_Cxx_Output_epv.println = self->ase_compiler_cxx_printer.d_epv->println;
    ASE_Compiler_Cxx_Output_epv.getRepository = self->ase_compiler_cxx_printer.d_epv->getRepository;
    ASE_Compiler_Cxx_Output_epv.setRepository = self->ase_compiler_cxx_printer.d_epv->setRepository;
    ASE_Compiler_Cxx_Output_epv.visitVertex = self->ase_compiler_cxx_printer.d_epv->visitVertex;
    ASE_Compiler_Cxx_Output_epv.visitExpression = self->ase_compiler_cxx_printer.d_epv->visitExpression;
    ASE_Compiler_Cxx_Output_epv.getReverseEdges = self->ase_compiler_cxx_printer.d_epv->getReverseEdges;
    ASE_Compiler_Cxx_Output_epv.setReverseEdges = self->ase_compiler_cxx_printer.d_epv->setReverseEdges;
    ASE_Compiler_Cxx_Output_epv.traverseVertex = self->ase_compiler_cxx_printer.d_epv->traverseVertex;
    ASE_Compiler_Cxx_Output_epv.resetVertexNumbering = self->ase_compiler_cxx_printer.d_epv->resetVertexNumbering;
    ASE_Compiler_Cxx_Output_epv.discoverVertex = self->ase_compiler_cxx_printer.d_epv->discoverVertex;
    ASE_Compiler_Cxx_Output_epv.finishVertex = self->ase_compiler_cxx_printer.d_epv->finishVertex;
    ASE_Compiler_Cxx_Output_epv.getVerticesSeen = self->ase_compiler_cxx_printer.d_epv->getVerticesSeen;
    ASE_Compiler_Cxx_Output_epv.setVerticesSeen = self->ase_compiler_cxx_printer.d_epv->setVerticesSeen;
    ASE_Compiler_Cxx_Output_epv.getVertexSeen = self->ase_compiler_cxx_printer.d_epv->getVertexSeen;
    ASE_Compiler_Cxx_Output_epv.setVertexSeen = self->ase_compiler_cxx_printer.d_epv->setVertexSeen;
    ASE_Compiler_Cxx_Output_epv.getReferenceCount = self->ase_compiler_cxx_printer.d_epv->getReferenceCount;
    ASE_Compiler_Cxx_Output_epv.addReference = self->ase_compiler_cxx_printer.d_epv->addReference;
    ASE_Compiler_Cxx_Output_epv.deleteReference = self->ase_compiler_cxx_printer.d_epv->deleteReference;
    ASE_Compiler_Cxx_Output_epv.isSame = self->ase_compiler_cxx_printer.d_epv->isSame;
    ASE_Compiler_Cxx_Output_epv.getClassName = self->ase_compiler_cxx_printer.d_epv->getClassName;
    ASE_Compiler_Cxx_Output_epv.getName = self->ase_compiler_cxx_printer.d_epv->getName;
    ASE_Compiler_Cxx_Output_epv.setName = self->ase_compiler_cxx_printer.d_epv->setName;
    ASE_Compiler_Cxx_Output_epv.isInstanceOf = self->ase_compiler_cxx_printer.d_epv->isInstanceOf;
    ASE_Compiler_Cxx_Output_epv.getSuper = self->ase_compiler_cxx_printer.d_epv->getSuper;
    ASE_Compiler_Cxx_Output_epv.visitInclude = self->ase_compiler_cxx_printer.d_epv->visitInclude;
    ASE_Compiler_Cxx_Output_epv.visitDefine = self->ase_compiler_cxx_printer.d_epv->visitDefine;
    ASE_Compiler_Cxx_Output_epv.visitMacro = self->ase_compiler_cxx_printer.d_epv->visitMacro;
    ASE_Compiler_Cxx_Output_epv.visitPreprocessorConditional = self->ase_compiler_cxx_printer.d_epv->visitPreprocessorConditional;
    ASE_Compiler_Cxx_Output_epv.visitType = self->ase_compiler_cxx_printer.d_epv->visitType;
    ASE_Compiler_Cxx_Output_epv.visitPointer = self->ase_compiler_cxx_printer.d_epv->visitPointer;
    ASE_Compiler_Cxx_Output_epv.visitStruct = self->ase_compiler_cxx_printer.d_epv->visitStruct;
    ASE_Compiler_Cxx_Output_epv.visitBitField = self->ase_compiler_cxx_printer.d_epv->visitBitField;
    ASE_Compiler_Cxx_Output_epv.visitEnumeration = self->ase_compiler_cxx_printer.d_epv->visitEnumeration;
    ASE_Compiler_Cxx_Output_epv.visitEnumerator = self->ase_compiler_cxx_printer.d_epv->visitEnumerator;
    ASE_Compiler_Cxx_Output_epv.visitTypedef = self->ase_compiler_cxx_printer.d_epv->visitTypedef;
    ASE_Compiler_Cxx_Output_epv.visitGroup = self->ase_compiler_cxx_printer.d_epv->visitGroup;
    ASE_Compiler_Cxx_Output_epv.visitDeclarator = self->ase_compiler_cxx_printer.d_epv->visitDeclarator;
    ASE_Compiler_Cxx_Output_epv.visitDeclaratorGroup = self->ase_compiler_cxx_printer.d_epv->visitDeclaratorGroup;
    ASE_Compiler_Cxx_Output_epv.visitArray = self->ase_compiler_cxx_printer.d_epv->visitArray;
    ASE_Compiler_Cxx_Output_epv.visitFunction = self->ase_compiler_cxx_printer.d_epv->visitFunction;
    ASE_Compiler_Cxx_Output_epv.visitParameter = self->ase_compiler_cxx_printer.d_epv->visitParameter;
    ASE_Compiler_Cxx_Output_epv.visitDeclaration = self->ase_compiler_cxx_printer.d_epv->visitDeclaration;
    ASE_Compiler_Cxx_Output_epv.visitStatement = self->ase_compiler_cxx_printer.d_epv->visitStatement;
    ASE_Compiler_Cxx_Output_epv.visitExpressionStatement = self->ase_compiler_cxx_printer.d_epv->visitExpressionStatement;
    ASE_Compiler_Cxx_Output_epv.visitCompoundStatement = self->ase_compiler_cxx_printer.d_epv->visitCompoundStatement;
    ASE_Compiler_Cxx_Output_epv.visitIf = self->ase_compiler_cxx_printer.d_epv->visitIf;
    ASE_Compiler_Cxx_Output_epv.visitSwitch = self->ase_compiler_cxx_printer.d_epv->visitSwitch;
    ASE_Compiler_Cxx_Output_epv.visitWhile = self->ase_compiler_cxx_printer.d_epv->visitWhile;
    ASE_Compiler_Cxx_Output_epv.visitFor = self->ase_compiler_cxx_printer.d_epv->visitFor;
    ASE_Compiler_Cxx_Output_epv.visitGoto = self->ase_compiler_cxx_printer.d_epv->visitGoto;
    ASE_Compiler_Cxx_Output_epv.visitContinue = self->ase_compiler_cxx_printer.d_epv->visitContinue;
    ASE_Compiler_Cxx_Output_epv.visitBreak = self->ase_compiler_cxx_printer.d_epv->visitBreak;
    ASE_Compiler_Cxx_Output_epv.visitReturn = self->ase_compiler_cxx_printer.d_epv->visitReturn;
    ASE_Compiler_Cxx_Output_epv.visitInitializer = self->ase_compiler_cxx_printer.d_epv->visitInitializer;
    ASE_Compiler_Cxx_Output_epv.visitAssignment = self->ase_compiler_cxx_printer.d_epv->visitAssignment;
    ASE_Compiler_Cxx_Output_epv.visitInclusiveOrAssignment = self->ase_compiler_cxx_printer.d_epv->visitInclusiveOrAssignment;
    ASE_Compiler_Cxx_Output_epv.visitExclusiveOrAssignment = self->ase_compiler_cxx_printer.d_epv->visitExclusiveOrAssignment;
    ASE_Compiler_Cxx_Output_epv.visitAndAssignment = self->ase_compiler_cxx_printer.d_epv->visitAndAssignment;
    ASE_Compiler_Cxx_Output_epv.visitLeftShiftAssignment = self->ase_compiler_cxx_printer.d_epv->visitLeftShiftAssignment;
    ASE_Compiler_Cxx_Output_epv.visitRightShiftAssignment = self->ase_compiler_cxx_printer.d_epv->visitRightShiftAssignment;
    ASE_Compiler_Cxx_Output_epv.visitAdditionAssignment = self->ase_compiler_cxx_printer.d_epv->visitAdditionAssignment;
    ASE_Compiler_Cxx_Output_epv.visitSubtractionAssignment = self->ase_compiler_cxx_printer.d_epv->visitSubtractionAssignment;
    ASE_Compiler_Cxx_Output_epv.visitMultiplicationAssignment = self->ase_compiler_cxx_printer.d_epv->visitMultiplicationAssignment;
    ASE_Compiler_Cxx_Output_epv.visitDivisionAssignment = self->ase_compiler_cxx_printer.d_epv->visitDivisionAssignment;
    ASE_Compiler_Cxx_Output_epv.visitModuloAssignment = self->ase_compiler_cxx_printer.d_epv->visitModuloAssignment;
    ASE_Compiler_Cxx_Output_epv.visitLogicalOr = self->ase_compiler_cxx_printer.d_epv->visitLogicalOr;
    ASE_Compiler_Cxx_Output_epv.visitLogicalAnd = self->ase_compiler_cxx_printer.d_epv->visitLogicalAnd;
    ASE_Compiler_Cxx_Output_epv.visitInclusiveOr = self->ase_compiler_cxx_printer.d_epv->visitInclusiveOr;
    ASE_Compiler_Cxx_Output_epv.visitExclusiveOr = self->ase_compiler_cxx_printer.d_epv->visitExclusiveOr;
    ASE_Compiler_Cxx_Output_epv.visitAnd = self->ase_compiler_cxx_printer.d_epv->visitAnd;
    ASE_Compiler_Cxx_Output_epv.visitEquality = self->ase_compiler_cxx_printer.d_epv->visitEquality;
    ASE_Compiler_Cxx_Output_epv.visitInequality = self->ase_compiler_cxx_printer.d_epv->visitInequality;
    ASE_Compiler_Cxx_Output_epv.visitLessThan = self->ase_compiler_cxx_printer.d_epv->visitLessThan;
    ASE_Compiler_Cxx_Output_epv.visitGreaterThan = self->ase_compiler_cxx_printer.d_epv->visitGreaterThan;
    ASE_Compiler_Cxx_Output_epv.visitLessThanOrEqual = self->ase_compiler_cxx_printer.d_epv->visitLessThanOrEqual;
    ASE_Compiler_Cxx_Output_epv.visitGreaterThanOrEqual = self->ase_compiler_cxx_printer.d_epv->visitGreaterThanOrEqual;
    ASE_Compiler_Cxx_Output_epv.visitLeftShift = self->ase_compiler_cxx_printer.d_epv->visitLeftShift;
    ASE_Compiler_Cxx_Output_epv.visitRightShift = self->ase_compiler_cxx_printer.d_epv->visitRightShift;
    ASE_Compiler_Cxx_Output_epv.visitAddition = self->ase_compiler_cxx_printer.d_epv->visitAddition;
    ASE_Compiler_Cxx_Output_epv.visitSubtraction = self->ase_compiler_cxx_printer.d_epv->visitSubtraction;
    ASE_Compiler_Cxx_Output_epv.visitMultiplication = self->ase_compiler_cxx_printer.d_epv->visitMultiplication;
    ASE_Compiler_Cxx_Output_epv.visitDivision = self->ase_compiler_cxx_printer.d_epv->visitDivision;
    ASE_Compiler_Cxx_Output_epv.visitModulo = self->ase_compiler_cxx_printer.d_epv->visitModulo;
    ASE_Compiler_Cxx_Output_epv.visitCast = self->ase_compiler_cxx_printer.d_epv->visitCast;
    ASE_Compiler_Cxx_Output_epv.visitSizeof = self->ase_compiler_cxx_printer.d_epv->visitSizeof;
    ASE_Compiler_Cxx_Output_epv.visitAddress = self->ase_compiler_cxx_printer.d_epv->visitAddress;
    ASE_Compiler_Cxx_Output_epv.visitIndirection = self->ase_compiler_cxx_printer.d_epv->visitIndirection;
    ASE_Compiler_Cxx_Output_epv.visitUnaryPlus = self->ase_compiler_cxx_printer.d_epv->visitUnaryPlus;
    ASE_Compiler_Cxx_Output_epv.visitUnaryMinus = self->ase_compiler_cxx_printer.d_epv->visitUnaryMinus;
    ASE_Compiler_Cxx_Output_epv.visitComplement = self->ase_compiler_cxx_printer.d_epv->visitComplement;
    ASE_Compiler_Cxx_Output_epv.visitNegation = self->ase_compiler_cxx_printer.d_epv->visitNegation;
    ASE_Compiler_Cxx_Output_epv.visitIncrement = self->ase_compiler_cxx_printer.d_epv->visitIncrement;
    ASE_Compiler_Cxx_Output_epv.visitStructReference = self->ase_compiler_cxx_printer.d_epv->visitStructReference;
    ASE_Compiler_Cxx_Output_epv.visitArrayReference = self->ase_compiler_cxx_printer.d_epv->visitArrayReference;
    ASE_Compiler_Cxx_Output_epv.visitFunctionCall = self->ase_compiler_cxx_printer.d_epv->visitFunctionCall;
    ASE_Compiler_Cxx_Output_epv.visitVariable = self->ase_compiler_cxx_printer.d_epv->visitVariable;
    ASE_Compiler_Cxx_Output_epv.visitConstant = self->ase_compiler_cxx_printer.d_epv->visitConstant;
    /* Virtualize superclass ASE.Compiler.Cxx.Printer methods with those of class ASE.Compiler.Cxx.Output */
    ASE_Compiler_Cxx_Printer_epv.castObject = ASE_Compiler_Cxx_Output_epv.castObject;
    ASE_Compiler_Cxx_Printer_epv.destroyObject = ASE_Compiler_Cxx_Output_epv.destroyObject;
    ASE_Compiler_Cxx_Printer_epv.strObject = ASE_Compiler_Cxx_Output_epv.strObject;
    ASE_Compiler_Cxx_Printer_epv.getTab = ASE_Compiler_Cxx_Output_epv.getTab;
    ASE_Compiler_Cxx_Printer_epv.setTab = ASE_Compiler_Cxx_Output_epv.setTab;
    ASE_Compiler_Cxx_Printer_epv.getIndentSize = ASE_Compiler_Cxx_Output_epv.getIndentSize;
    ASE_Compiler_Cxx_Printer_epv.setIndentSize = ASE_Compiler_Cxx_Output_epv.setIndentSize;
    ASE_Compiler_Cxx_Printer_epv.increaseIndent = ASE_Compiler_Cxx_Output_epv.increaseIndent;
    ASE_Compiler_Cxx_Printer_epv.decreaseIndent = ASE_Compiler_Cxx_Output_epv.decreaseIndent;
    ASE_Compiler_Cxx_Printer_epv.indent = ASE_Compiler_Cxx_Output_epv.indent;
    ASE_Compiler_Cxx_Printer_epv.write = ASE_Compiler_Cxx_Output_epv.write;
    ASE_Compiler_Cxx_Printer_epv.println = ASE_Compiler_Cxx_Output_epv.println;
    ASE_Compiler_Cxx_Printer_epv.getRepository = ASE_Compiler_Cxx_Output_epv.getRepository;
    ASE_Compiler_Cxx_Printer_epv.setRepository = ASE_Compiler_Cxx_Output_epv.setRepository;
    ASE_Compiler_Cxx_Printer_epv.visitVertex = ASE_Compiler_Cxx_Output_epv.visitVertex;
    ASE_Compiler_Cxx_Printer_epv.visitSource = ASE_Compiler_Cxx_Output_epv.visitSource;
    ASE_Compiler_Cxx_Printer_epv.visitHeader = ASE_Compiler_Cxx_Output_epv.visitHeader;
    ASE_Compiler_Cxx_Printer_epv.visitPythonModule = ASE_Compiler_Cxx_Output_epv.visitPythonModule;
    ASE_Compiler_Cxx_Printer_epv.visitExpression = ASE_Compiler_Cxx_Output_epv.visitExpression;
    ASE_Compiler_Cxx_Printer_epv.getReverseEdges = ASE_Compiler_Cxx_Output_epv.getReverseEdges;
    ASE_Compiler_Cxx_Printer_epv.setReverseEdges = ASE_Compiler_Cxx_Output_epv.setReverseEdges;
    ASE_Compiler_Cxx_Printer_epv.traverseVertex = ASE_Compiler_Cxx_Output_epv.traverseVertex;
    ASE_Compiler_Cxx_Printer_epv.resetVertexNumbering = ASE_Compiler_Cxx_Output_epv.resetVertexNumbering;
    ASE_Compiler_Cxx_Printer_epv.discoverVertex = ASE_Compiler_Cxx_Output_epv.discoverVertex;
    ASE_Compiler_Cxx_Printer_epv.finishVertex = ASE_Compiler_Cxx_Output_epv.finishVertex;
    ASE_Compiler_Cxx_Printer_epv.getVerticesSeen = ASE_Compiler_Cxx_Output_epv.getVerticesSeen;
    ASE_Compiler_Cxx_Printer_epv.setVerticesSeen = ASE_Compiler_Cxx_Output_epv.setVerticesSeen;
    ASE_Compiler_Cxx_Printer_epv.getVertexSeen = ASE_Compiler_Cxx_Output_epv.getVertexSeen;
    ASE_Compiler_Cxx_Printer_epv.setVertexSeen = ASE_Compiler_Cxx_Output_epv.setVertexSeen;
    ASE_Compiler_Cxx_Printer_epv.getReferenceCount = ASE_Compiler_Cxx_Output_epv.getReferenceCount;
    ASE_Compiler_Cxx_Printer_epv.addReference = ASE_Compiler_Cxx_Output_epv.addReference;
    ASE_Compiler_Cxx_Printer_epv.deleteReference = ASE_Compiler_Cxx_Output_epv.deleteReference;
    ASE_Compiler_Cxx_Printer_epv.isSame = ASE_Compiler_Cxx_Output_epv.isSame;
    ASE_Compiler_Cxx_Printer_epv.getClassName = ASE_Compiler_Cxx_Output_epv.getClassName;
    ASE_Compiler_Cxx_Printer_epv.getName = ASE_Compiler_Cxx_Output_epv.getName;
    ASE_Compiler_Cxx_Printer_epv.setName = ASE_Compiler_Cxx_Output_epv.setName;
    ASE_Compiler_Cxx_Printer_epv.isInstanceOf = ASE_Compiler_Cxx_Output_epv.isInstanceOf;
    ASE_Compiler_Cxx_Printer_epv.getSuper = ASE_Compiler_Cxx_Output_epv.getSuper;
    ASE_Compiler_Cxx_Printer_epv.visitInclude = ASE_Compiler_Cxx_Output_epv.visitInclude;
    ASE_Compiler_Cxx_Printer_epv.visitDefine = ASE_Compiler_Cxx_Output_epv.visitDefine;
    ASE_Compiler_Cxx_Printer_epv.visitMacro = ASE_Compiler_Cxx_Output_epv.visitMacro;
    ASE_Compiler_Cxx_Printer_epv.visitPreprocessorConditional = ASE_Compiler_Cxx_Output_epv.visitPreprocessorConditional;
    ASE_Compiler_Cxx_Printer_epv.visitType = ASE_Compiler_Cxx_Output_epv.visitType;
    ASE_Compiler_Cxx_Printer_epv.visitPointer = ASE_Compiler_Cxx_Output_epv.visitPointer;
    ASE_Compiler_Cxx_Printer_epv.visitStruct = ASE_Compiler_Cxx_Output_epv.visitStruct;
    ASE_Compiler_Cxx_Printer_epv.visitBitField = ASE_Compiler_Cxx_Output_epv.visitBitField;
    ASE_Compiler_Cxx_Printer_epv.visitEnumeration = ASE_Compiler_Cxx_Output_epv.visitEnumeration;
    ASE_Compiler_Cxx_Printer_epv.visitEnumerator = ASE_Compiler_Cxx_Output_epv.visitEnumerator;
    ASE_Compiler_Cxx_Printer_epv.visitTypedef = ASE_Compiler_Cxx_Output_epv.visitTypedef;
    ASE_Compiler_Cxx_Printer_epv.visitGroup = ASE_Compiler_Cxx_Output_epv.visitGroup;
    ASE_Compiler_Cxx_Printer_epv.visitDeclarator = ASE_Compiler_Cxx_Output_epv.visitDeclarator;
    ASE_Compiler_Cxx_Printer_epv.visitDeclaratorGroup = ASE_Compiler_Cxx_Output_epv.visitDeclaratorGroup;
    ASE_Compiler_Cxx_Printer_epv.visitArray = ASE_Compiler_Cxx_Output_epv.visitArray;
    ASE_Compiler_Cxx_Printer_epv.visitFunction = ASE_Compiler_Cxx_Output_epv.visitFunction;
    ASE_Compiler_Cxx_Printer_epv.visitParameter = ASE_Compiler_Cxx_Output_epv.visitParameter;
    ASE_Compiler_Cxx_Printer_epv.visitDeclaration = ASE_Compiler_Cxx_Output_epv.visitDeclaration;
    ASE_Compiler_Cxx_Printer_epv.visitStatement = ASE_Compiler_Cxx_Output_epv.visitStatement;
    ASE_Compiler_Cxx_Printer_epv.visitExpressionStatement = ASE_Compiler_Cxx_Output_epv.visitExpressionStatement;
    ASE_Compiler_Cxx_Printer_epv.visitCompoundStatement = ASE_Compiler_Cxx_Output_epv.visitCompoundStatement;
    ASE_Compiler_Cxx_Printer_epv.visitIf = ASE_Compiler_Cxx_Output_epv.visitIf;
    ASE_Compiler_Cxx_Printer_epv.visitSwitch = ASE_Compiler_Cxx_Output_epv.visitSwitch;
    ASE_Compiler_Cxx_Printer_epv.visitWhile = ASE_Compiler_Cxx_Output_epv.visitWhile;
    ASE_Compiler_Cxx_Printer_epv.visitFor = ASE_Compiler_Cxx_Output_epv.visitFor;
    ASE_Compiler_Cxx_Printer_epv.visitGoto = ASE_Compiler_Cxx_Output_epv.visitGoto;
    ASE_Compiler_Cxx_Printer_epv.visitContinue = ASE_Compiler_Cxx_Output_epv.visitContinue;
    ASE_Compiler_Cxx_Printer_epv.visitBreak = ASE_Compiler_Cxx_Output_epv.visitBreak;
    ASE_Compiler_Cxx_Printer_epv.visitReturn = ASE_Compiler_Cxx_Output_epv.visitReturn;
    ASE_Compiler_Cxx_Printer_epv.visitInitializer = ASE_Compiler_Cxx_Output_epv.visitInitializer;
    ASE_Compiler_Cxx_Printer_epv.visitAssignment = ASE_Compiler_Cxx_Output_epv.visitAssignment;
    ASE_Compiler_Cxx_Printer_epv.visitInclusiveOrAssignment = ASE_Compiler_Cxx_Output_epv.visitInclusiveOrAssignment;
    ASE_Compiler_Cxx_Printer_epv.visitExclusiveOrAssignment = ASE_Compiler_Cxx_Output_epv.visitExclusiveOrAssignment;
    ASE_Compiler_Cxx_Printer_epv.visitAndAssignment = ASE_Compiler_Cxx_Output_epv.visitAndAssignment;
    ASE_Compiler_Cxx_Printer_epv.visitLeftShiftAssignment = ASE_Compiler_Cxx_Output_epv.visitLeftShiftAssignment;
    ASE_Compiler_Cxx_Printer_epv.visitRightShiftAssignment = ASE_Compiler_Cxx_Output_epv.visitRightShiftAssignment;
    ASE_Compiler_Cxx_Printer_epv.visitAdditionAssignment = ASE_Compiler_Cxx_Output_epv.visitAdditionAssignment;
    ASE_Compiler_Cxx_Printer_epv.visitSubtractionAssignment = ASE_Compiler_Cxx_Output_epv.visitSubtractionAssignment;
    ASE_Compiler_Cxx_Printer_epv.visitMultiplicationAssignment = ASE_Compiler_Cxx_Output_epv.visitMultiplicationAssignment;
    ASE_Compiler_Cxx_Printer_epv.visitDivisionAssignment = ASE_Compiler_Cxx_Output_epv.visitDivisionAssignment;
    ASE_Compiler_Cxx_Printer_epv.visitModuloAssignment = ASE_Compiler_Cxx_Output_epv.visitModuloAssignment;
    ASE_Compiler_Cxx_Printer_epv.visitLogicalOr = ASE_Compiler_Cxx_Output_epv.visitLogicalOr;
    ASE_Compiler_Cxx_Printer_epv.visitLogicalAnd = ASE_Compiler_Cxx_Output_epv.visitLogicalAnd;
    ASE_Compiler_Cxx_Printer_epv.visitInclusiveOr = ASE_Compiler_Cxx_Output_epv.visitInclusiveOr;
    ASE_Compiler_Cxx_Printer_epv.visitExclusiveOr = ASE_Compiler_Cxx_Output_epv.visitExclusiveOr;
    ASE_Compiler_Cxx_Printer_epv.visitAnd = ASE_Compiler_Cxx_Output_epv.visitAnd;
    ASE_Compiler_Cxx_Printer_epv.visitEquality = ASE_Compiler_Cxx_Output_epv.visitEquality;
    ASE_Compiler_Cxx_Printer_epv.visitInequality = ASE_Compiler_Cxx_Output_epv.visitInequality;
    ASE_Compiler_Cxx_Printer_epv.visitLessThan = ASE_Compiler_Cxx_Output_epv.visitLessThan;
    ASE_Compiler_Cxx_Printer_epv.visitGreaterThan = ASE_Compiler_Cxx_Output_epv.visitGreaterThan;
    ASE_Compiler_Cxx_Printer_epv.visitLessThanOrEqual = ASE_Compiler_Cxx_Output_epv.visitLessThanOrEqual;
    ASE_Compiler_Cxx_Printer_epv.visitGreaterThanOrEqual = ASE_Compiler_Cxx_Output_epv.visitGreaterThanOrEqual;
    ASE_Compiler_Cxx_Printer_epv.visitLeftShift = ASE_Compiler_Cxx_Output_epv.visitLeftShift;
    ASE_Compiler_Cxx_Printer_epv.visitRightShift = ASE_Compiler_Cxx_Output_epv.visitRightShift;
    ASE_Compiler_Cxx_Printer_epv.visitAddition = ASE_Compiler_Cxx_Output_epv.visitAddition;
    ASE_Compiler_Cxx_Printer_epv.visitSubtraction = ASE_Compiler_Cxx_Output_epv.visitSubtraction;
    ASE_Compiler_Cxx_Printer_epv.visitMultiplication = ASE_Compiler_Cxx_Output_epv.visitMultiplication;
    ASE_Compiler_Cxx_Printer_epv.visitDivision = ASE_Compiler_Cxx_Output_epv.visitDivision;
    ASE_Compiler_Cxx_Printer_epv.visitModulo = ASE_Compiler_Cxx_Output_epv.visitModulo;
    ASE_Compiler_Cxx_Printer_epv.visitCast = ASE_Compiler_Cxx_Output_epv.visitCast;
    ASE_Compiler_Cxx_Printer_epv.visitSizeof = ASE_Compiler_Cxx_Output_epv.visitSizeof;
    ASE_Compiler_Cxx_Printer_epv.visitAddress = ASE_Compiler_Cxx_Output_epv.visitAddress;
    ASE_Compiler_Cxx_Printer_epv.visitIndirection = ASE_Compiler_Cxx_Output_epv.visitIndirection;
    ASE_Compiler_Cxx_Printer_epv.visitUnaryPlus = ASE_Compiler_Cxx_Output_epv.visitUnaryPlus;
    ASE_Compiler_Cxx_Printer_epv.visitUnaryMinus = ASE_Compiler_Cxx_Output_epv.visitUnaryMinus;
    ASE_Compiler_Cxx_Printer_epv.visitComplement = ASE_Compiler_Cxx_Output_epv.visitComplement;
    ASE_Compiler_Cxx_Printer_epv.visitNegation = ASE_Compiler_Cxx_Output_epv.visitNegation;
    ASE_Compiler_Cxx_Printer_epv.visitIncrement = ASE_Compiler_Cxx_Output_epv.visitIncrement;
    ASE_Compiler_Cxx_Printer_epv.visitStructReference = ASE_Compiler_Cxx_Output_epv.visitStructReference;
    ASE_Compiler_Cxx_Printer_epv.visitArrayReference = ASE_Compiler_Cxx_Output_epv.visitArrayReference;
    ASE_Compiler_Cxx_Printer_epv.visitFunctionCall = ASE_Compiler_Cxx_Output_epv.visitFunctionCall;
    ASE_Compiler_Cxx_Printer_epv.visitVariable = ASE_Compiler_Cxx_Output_epv.visitVariable;
    ASE_Compiler_Cxx_Printer_epv.visitConstant = ASE_Compiler_Cxx_Output_epv.visitConstant;
    /* Initialize interface ASE.Compiler.Output methods with those of class ASE.Compiler.Cxx.Output */
    ASE_Compiler_Output_epv.castObject = ASE_Compiler_Cxx_Output_epv.castObject;
    ASE_Compiler_Output_epv.destroyObject = ASE_Compiler_Cxx_Output_epv.destroyObject;
    ASE_Compiler_Output_epv.strObject = ASE_Compiler_Cxx_Output_epv.strObject;
    ASE_Compiler_Output_epv.getReferenceCount = ASE_Compiler_Cxx_Output_epv.getReferenceCount;
    ASE_Compiler_Output_epv.addReference = ASE_Compiler_Cxx_Output_epv.addReference;
    ASE_Compiler_Output_epv.deleteReference = ASE_Compiler_Cxx_Output_epv.deleteReference;
    ASE_Compiler_Output_epv.isSame = ASE_Compiler_Cxx_Output_epv.isSame;
    ASE_Compiler_Output_epv.getClassName = ASE_Compiler_Cxx_Output_epv.getClassName;
    ASE_Compiler_Output_epv.getName = ASE_Compiler_Cxx_Output_epv.getName;
    ASE_Compiler_Output_epv.setName = ASE_Compiler_Cxx_Output_epv.setName;
    ASE_Compiler_Output_epv.isInstanceOf = ASE_Compiler_Cxx_Output_epv.isInstanceOf;
    ASE_Compiler_Output_epv.getSuper = ASE_Compiler_Cxx_Output_epv.getSuper;
    ASE_Compiler_Output_epv.getRepository = ASE_Compiler_Cxx_Output_epv.getRepository;
    ASE_Compiler_Output_epv.setRepository = ASE_Compiler_Cxx_Output_epv.setRepository;
    ASE_Compiler_Output_epv.visitVertex = ASE_Compiler_Cxx_Output_epv.visitVertex;
    ASE_Compiler_Output_epv.getDisableOutput = ASE_Compiler_Cxx_Output_epv.getDisableOutput;
    ASE_Compiler_Output_epv.setDisableOutput = ASE_Compiler_Cxx_Output_epv.setDisableOutput;
    ASE_Compiler_Output_epv.getDisableSource = ASE_Compiler_Cxx_Output_epv.getDisableSource;
    ASE_Compiler_Output_epv.setDisableSource = ASE_Compiler_Cxx_Output_epv.setDisableSource;
    ASE_Compiler_Output_epv.getRoot = ASE_Compiler_Cxx_Output_epv.getRoot;
    ASE_Compiler_Output_epv.setRoot = ASE_Compiler_Cxx_Output_epv.setRoot;
    ASE_Compiler_Output_epv.getIncludeDirectories = ASE_Compiler_Cxx_Output_epv.getIncludeDirectories;
    ASE_Compiler_Output_epv.setIncludeDirectories = ASE_Compiler_Cxx_Output_epv.setIncludeDirectories;
    ASE_Compiler_Output_epv.getSystemIncludeDirectories = ASE_Compiler_Cxx_Output_epv.getSystemIncludeDirectories;
    ASE_Compiler_Output_epv.setSystemIncludeDirectories = ASE_Compiler_Cxx_Output_epv.setSystemIncludeDirectories;
    ASE_Compiler_Output_epv.getFiles = ASE_Compiler_Cxx_Output_epv.getFiles;
    ASE_Compiler_Output_epv.setFiles = ASE_Compiler_Cxx_Output_epv.setFiles;
    /* Initialize interface ASE.Compiler.Visitor methods with those of class ASE.Compiler.Cxx.Output */
    ASE_Compiler_Visitor_epv.castObject = ASE_Compiler_Cxx_Output_epv.castObject;
    ASE_Compiler_Visitor_epv.destroyObject = ASE_Compiler_Cxx_Output_epv.destroyObject;
    ASE_Compiler_Visitor_epv.strObject = ASE_Compiler_Cxx_Output_epv.strObject;
    ASE_Compiler_Visitor_epv.getReferenceCount = ASE_Compiler_Cxx_Output_epv.getReferenceCount;
    ASE_Compiler_Visitor_epv.addReference = ASE_Compiler_Cxx_Output_epv.addReference;
    ASE_Compiler_Visitor_epv.deleteReference = ASE_Compiler_Cxx_Output_epv.deleteReference;
    ASE_Compiler_Visitor_epv.isSame = ASE_Compiler_Cxx_Output_epv.isSame;
    ASE_Compiler_Visitor_epv.getClassName = ASE_Compiler_Cxx_Output_epv.getClassName;
    ASE_Compiler_Visitor_epv.getName = ASE_Compiler_Cxx_Output_epv.getName;
    ASE_Compiler_Visitor_epv.setName = ASE_Compiler_Cxx_Output_epv.setName;
    ASE_Compiler_Visitor_epv.isInstanceOf = ASE_Compiler_Cxx_Output_epv.isInstanceOf;
    ASE_Compiler_Visitor_epv.getSuper = ASE_Compiler_Cxx_Output_epv.getSuper;
    ASE_Compiler_Visitor_epv.getRepository = ASE_Compiler_Cxx_Output_epv.getRepository;
    ASE_Compiler_Visitor_epv.setRepository = ASE_Compiler_Cxx_Output_epv.setRepository;
    ASE_Compiler_Visitor_epv.visitVertex = ASE_Compiler_Cxx_Output_epv.visitVertex;
    /* Initialize interface ASE.BaseInterface methods with those of class ASE.Compiler.Cxx.Output */
    ASE_BaseInterface_epv.castObject = ASE_Compiler_Cxx_Output_epv.castObject;
    ASE_BaseInterface_epv.destroyObject = ASE_Compiler_Cxx_Output_epv.destroyObject;
    ASE_BaseInterface_epv.strObject = ASE_Compiler_Cxx_Output_epv.strObject;
    ASE_BaseInterface_epv.getReferenceCount = ASE_Compiler_Cxx_Output_epv.getReferenceCount;
    ASE_BaseInterface_epv.addReference = ASE_Compiler_Cxx_Output_epv.addReference;
    ASE_BaseInterface_epv.deleteReference = ASE_Compiler_Cxx_Output_epv.deleteReference;
    ASE_BaseInterface_epv.isSame = ASE_Compiler_Cxx_Output_epv.isSame;
    ASE_BaseInterface_epv.getClassName = ASE_Compiler_Cxx_Output_epv.getClassName;
    ASE_BaseInterface_epv.getName = ASE_Compiler_Cxx_Output_epv.getName;
    ASE_BaseInterface_epv.setName = ASE_Compiler_Cxx_Output_epv.setName;
    ASE_BaseInterface_epv.isInstanceOf = ASE_Compiler_Cxx_Output_epv.isInstanceOf;
    ASE_BaseInterface_epv.getSuper = ASE_Compiler_Cxx_Output_epv.getSuper;
    /* Override class ASE.Compiler.Cxx.Printer methods with those of superclass ASE.Compiler.Cxx.DepthFirstVisitor */
    ASE_Compiler_Cxx_Printer_epv.getRepository = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->getRepository;
    ASE_Compiler_Cxx_Printer_epv.setRepository = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->setRepository;
    ASE_Compiler_Cxx_Printer_epv.visitVertex = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->visitVertex;
    ASE_Compiler_Cxx_Printer_epv.visitExpression = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->visitExpression;
    ASE_Compiler_Cxx_Printer_epv.getReverseEdges = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->getReverseEdges;
    ASE_Compiler_Cxx_Printer_epv.setReverseEdges = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->setReverseEdges;
    ASE_Compiler_Cxx_Printer_epv.traverseVertex = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->traverseVertex;
    ASE_Compiler_Cxx_Printer_epv.resetVertexNumbering = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->resetVertexNumbering;
    ASE_Compiler_Cxx_Printer_epv.discoverVertex = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->discoverVertex;
    ASE_Compiler_Cxx_Printer_epv.finishVertex = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->finishVertex;
    ASE_Compiler_Cxx_Printer_epv.getVerticesSeen = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->getVerticesSeen;
    ASE_Compiler_Cxx_Printer_epv.setVerticesSeen = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->setVerticesSeen;
    ASE_Compiler_Cxx_Printer_epv.getVertexSeen = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->getVertexSeen;
    ASE_Compiler_Cxx_Printer_epv.setVertexSeen = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->setVertexSeen;
    ASE_Compiler_Cxx_Printer_epv.getReferenceCount = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->getReferenceCount;
    ASE_Compiler_Cxx_Printer_epv.addReference = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->addReference;
    ASE_Compiler_Cxx_Printer_epv.deleteReference = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->deleteReference;
    ASE_Compiler_Cxx_Printer_epv.isSame = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->isSame;
    ASE_Compiler_Cxx_Printer_epv.getClassName = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->getClassName;
    ASE_Compiler_Cxx_Printer_epv.getName = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->getName;
    ASE_Compiler_Cxx_Printer_epv.setName = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->setName;
    ASE_Compiler_Cxx_Printer_epv.isInstanceOf = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->isInstanceOf;
    ASE_Compiler_Cxx_Printer_epv.getSuper = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv->getSuper;
    /* Virtualize superclass ASE.Compiler.Cxx.DepthFirstVisitor methods with those of class ASE.Compiler.Cxx.Printer */
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.castObject = ASE_Compiler_Cxx_Printer_epv.castObject;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.destroyObject = ASE_Compiler_Cxx_Printer_epv.destroyObject;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.strObject = ASE_Compiler_Cxx_Printer_epv.strObject;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getRepository = ASE_Compiler_Cxx_Printer_epv.getRepository;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.setRepository = ASE_Compiler_Cxx_Printer_epv.setRepository;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitVertex = ASE_Compiler_Cxx_Printer_epv.visitVertex;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSource = ASE_Compiler_Cxx_Printer_epv.visitSource;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitHeader = ASE_Compiler_Cxx_Printer_epv.visitHeader;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitPythonModule = ASE_Compiler_Cxx_Printer_epv.visitPythonModule;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInclude = ASE_Compiler_Cxx_Printer_epv.visitInclude;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDefine = ASE_Compiler_Cxx_Printer_epv.visitDefine;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitMacro = ASE_Compiler_Cxx_Printer_epv.visitMacro;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitPreprocessorConditional = ASE_Compiler_Cxx_Printer_epv.visitPreprocessorConditional;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitType = ASE_Compiler_Cxx_Printer_epv.visitType;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitPointer = ASE_Compiler_Cxx_Printer_epv.visitPointer;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitStruct = ASE_Compiler_Cxx_Printer_epv.visitStruct;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitBitField = ASE_Compiler_Cxx_Printer_epv.visitBitField;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitEnumeration = ASE_Compiler_Cxx_Printer_epv.visitEnumeration;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitEnumerator = ASE_Compiler_Cxx_Printer_epv.visitEnumerator;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitTypedef = ASE_Compiler_Cxx_Printer_epv.visitTypedef;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitGroup = ASE_Compiler_Cxx_Printer_epv.visitGroup;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDeclarator = ASE_Compiler_Cxx_Printer_epv.visitDeclarator;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDeclaratorGroup = ASE_Compiler_Cxx_Printer_epv.visitDeclaratorGroup;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitArray = ASE_Compiler_Cxx_Printer_epv.visitArray;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitFunction = ASE_Compiler_Cxx_Printer_epv.visitFunction;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitParameter = ASE_Compiler_Cxx_Printer_epv.visitParameter;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDeclaration = ASE_Compiler_Cxx_Printer_epv.visitDeclaration;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitStatement = ASE_Compiler_Cxx_Printer_epv.visitStatement;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitExpressionStatement = ASE_Compiler_Cxx_Printer_epv.visitExpressionStatement;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitCompoundStatement = ASE_Compiler_Cxx_Printer_epv.visitCompoundStatement;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitIf = ASE_Compiler_Cxx_Printer_epv.visitIf;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSwitch = ASE_Compiler_Cxx_Printer_epv.visitSwitch;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitWhile = ASE_Compiler_Cxx_Printer_epv.visitWhile;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitFor = ASE_Compiler_Cxx_Printer_epv.visitFor;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitGoto = ASE_Compiler_Cxx_Printer_epv.visitGoto;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitContinue = ASE_Compiler_Cxx_Printer_epv.visitContinue;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitBreak = ASE_Compiler_Cxx_Printer_epv.visitBreak;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitReturn = ASE_Compiler_Cxx_Printer_epv.visitReturn;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInitializer = ASE_Compiler_Cxx_Printer_epv.visitInitializer;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitExpression = ASE_Compiler_Cxx_Printer_epv.visitExpression;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAssignment = ASE_Compiler_Cxx_Printer_epv.visitAssignment;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInclusiveOrAssignment = ASE_Compiler_Cxx_Printer_epv.visitInclusiveOrAssignment;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitExclusiveOrAssignment = ASE_Compiler_Cxx_Printer_epv.visitExclusiveOrAssignment;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAndAssignment = ASE_Compiler_Cxx_Printer_epv.visitAndAssignment;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLeftShiftAssignment = ASE_Compiler_Cxx_Printer_epv.visitLeftShiftAssignment;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitRightShiftAssignment = ASE_Compiler_Cxx_Printer_epv.visitRightShiftAssignment;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAdditionAssignment = ASE_Compiler_Cxx_Printer_epv.visitAdditionAssignment;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSubtractionAssignment = ASE_Compiler_Cxx_Printer_epv.visitSubtractionAssignment;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitMultiplicationAssignment = ASE_Compiler_Cxx_Printer_epv.visitMultiplicationAssignment;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDivisionAssignment = ASE_Compiler_Cxx_Printer_epv.visitDivisionAssignment;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitModuloAssignment = ASE_Compiler_Cxx_Printer_epv.visitModuloAssignment;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLogicalOr = ASE_Compiler_Cxx_Printer_epv.visitLogicalOr;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLogicalAnd = ASE_Compiler_Cxx_Printer_epv.visitLogicalAnd;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInclusiveOr = ASE_Compiler_Cxx_Printer_epv.visitInclusiveOr;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitExclusiveOr = ASE_Compiler_Cxx_Printer_epv.visitExclusiveOr;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAnd = ASE_Compiler_Cxx_Printer_epv.visitAnd;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitEquality = ASE_Compiler_Cxx_Printer_epv.visitEquality;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInequality = ASE_Compiler_Cxx_Printer_epv.visitInequality;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLessThan = ASE_Compiler_Cxx_Printer_epv.visitLessThan;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitGreaterThan = ASE_Compiler_Cxx_Printer_epv.visitGreaterThan;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLessThanOrEqual = ASE_Compiler_Cxx_Printer_epv.visitLessThanOrEqual;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitGreaterThanOrEqual = ASE_Compiler_Cxx_Printer_epv.visitGreaterThanOrEqual;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLeftShift = ASE_Compiler_Cxx_Printer_epv.visitLeftShift;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitRightShift = ASE_Compiler_Cxx_Printer_epv.visitRightShift;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAddition = ASE_Compiler_Cxx_Printer_epv.visitAddition;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSubtraction = ASE_Compiler_Cxx_Printer_epv.visitSubtraction;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitMultiplication = ASE_Compiler_Cxx_Printer_epv.visitMultiplication;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDivision = ASE_Compiler_Cxx_Printer_epv.visitDivision;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitModulo = ASE_Compiler_Cxx_Printer_epv.visitModulo;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitCast = ASE_Compiler_Cxx_Printer_epv.visitCast;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSizeof = ASE_Compiler_Cxx_Printer_epv.visitSizeof;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAddress = ASE_Compiler_Cxx_Printer_epv.visitAddress;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitIndirection = ASE_Compiler_Cxx_Printer_epv.visitIndirection;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitUnaryPlus = ASE_Compiler_Cxx_Printer_epv.visitUnaryPlus;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitUnaryMinus = ASE_Compiler_Cxx_Printer_epv.visitUnaryMinus;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitComplement = ASE_Compiler_Cxx_Printer_epv.visitComplement;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitNegation = ASE_Compiler_Cxx_Printer_epv.visitNegation;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitIncrement = ASE_Compiler_Cxx_Printer_epv.visitIncrement;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitStructReference = ASE_Compiler_Cxx_Printer_epv.visitStructReference;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitArrayReference = ASE_Compiler_Cxx_Printer_epv.visitArrayReference;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitFunctionCall = ASE_Compiler_Cxx_Printer_epv.visitFunctionCall;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitVariable = ASE_Compiler_Cxx_Printer_epv.visitVariable;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitConstant = ASE_Compiler_Cxx_Printer_epv.visitConstant;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReverseEdges = ASE_Compiler_Cxx_Printer_epv.getReverseEdges;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.setReverseEdges = ASE_Compiler_Cxx_Printer_epv.setReverseEdges;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.traverseVertex = ASE_Compiler_Cxx_Printer_epv.traverseVertex;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.resetVertexNumbering = ASE_Compiler_Cxx_Printer_epv.resetVertexNumbering;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.discoverVertex = ASE_Compiler_Cxx_Printer_epv.discoverVertex;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.finishVertex = ASE_Compiler_Cxx_Printer_epv.finishVertex;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getVerticesSeen = ASE_Compiler_Cxx_Printer_epv.getVerticesSeen;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.setVerticesSeen = ASE_Compiler_Cxx_Printer_epv.setVerticesSeen;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getVertexSeen = ASE_Compiler_Cxx_Printer_epv.getVertexSeen;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.setVertexSeen = ASE_Compiler_Cxx_Printer_epv.setVertexSeen;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReferenceCount = ASE_Compiler_Cxx_Printer_epv.getReferenceCount;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.addReference = ASE_Compiler_Cxx_Printer_epv.addReference;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.deleteReference = ASE_Compiler_Cxx_Printer_epv.deleteReference;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.isSame = ASE_Compiler_Cxx_Printer_epv.isSame;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getClassName = ASE_Compiler_Cxx_Printer_epv.getClassName;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getName = ASE_Compiler_Cxx_Printer_epv.getName;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.setName = ASE_Compiler_Cxx_Printer_epv.setName;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.isInstanceOf = ASE_Compiler_Cxx_Printer_epv.isInstanceOf;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getSuper = ASE_Compiler_Cxx_Printer_epv.getSuper;
    /* Initialize interface ASE.Compiler.Printer methods with those of class ASE.Compiler.Cxx.Printer */
    ASE_Compiler_Printer_epv.castObject = ASE_Compiler_Cxx_Printer_epv.castObject;
    ASE_Compiler_Printer_epv.destroyObject = ASE_Compiler_Cxx_Printer_epv.destroyObject;
    ASE_Compiler_Printer_epv.strObject = ASE_Compiler_Cxx_Printer_epv.strObject;
    ASE_Compiler_Printer_epv.getReferenceCount = ASE_Compiler_Cxx_Printer_epv.getReferenceCount;
    ASE_Compiler_Printer_epv.addReference = ASE_Compiler_Cxx_Printer_epv.addReference;
    ASE_Compiler_Printer_epv.deleteReference = ASE_Compiler_Cxx_Printer_epv.deleteReference;
    ASE_Compiler_Printer_epv.isSame = ASE_Compiler_Cxx_Printer_epv.isSame;
    ASE_Compiler_Printer_epv.getClassName = ASE_Compiler_Cxx_Printer_epv.getClassName;
    ASE_Compiler_Printer_epv.getName = ASE_Compiler_Cxx_Printer_epv.getName;
    ASE_Compiler_Printer_epv.setName = ASE_Compiler_Cxx_Printer_epv.setName;
    ASE_Compiler_Printer_epv.isInstanceOf = ASE_Compiler_Cxx_Printer_epv.isInstanceOf;
    ASE_Compiler_Printer_epv.getSuper = ASE_Compiler_Cxx_Printer_epv.getSuper;
    ASE_Compiler_Printer_epv.getRepository = ASE_Compiler_Cxx_Printer_epv.getRepository;
    ASE_Compiler_Printer_epv.setRepository = ASE_Compiler_Cxx_Printer_epv.setRepository;
    ASE_Compiler_Printer_epv.visitVertex = ASE_Compiler_Cxx_Printer_epv.visitVertex;
    ASE_Compiler_Printer_epv.getTab = ASE_Compiler_Cxx_Printer_epv.getTab;
    ASE_Compiler_Printer_epv.setTab = ASE_Compiler_Cxx_Printer_epv.setTab;
    ASE_Compiler_Printer_epv.getIndentSize = ASE_Compiler_Cxx_Printer_epv.getIndentSize;
    ASE_Compiler_Printer_epv.setIndentSize = ASE_Compiler_Cxx_Printer_epv.setIndentSize;
    ASE_Compiler_Printer_epv.increaseIndent = ASE_Compiler_Cxx_Printer_epv.increaseIndent;
    ASE_Compiler_Printer_epv.decreaseIndent = ASE_Compiler_Cxx_Printer_epv.decreaseIndent;
    ASE_Compiler_Printer_epv.indent = ASE_Compiler_Cxx_Printer_epv.indent;
    ASE_Compiler_Printer_epv.write = ASE_Compiler_Cxx_Printer_epv.write;
    ASE_Compiler_Printer_epv.println = ASE_Compiler_Cxx_Printer_epv.println;
    /* Override class ASE.Compiler.Cxx.DepthFirstVisitor methods with those of superclass ASE.BaseClass */
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReferenceCount = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_baseclass.d_epv->getReferenceCount;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.addReference = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_baseclass.d_epv->addReference;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.deleteReference = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_baseclass.d_epv->deleteReference;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.isSame = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_baseclass.d_epv->isSame;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getClassName = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_baseclass.d_epv->getClassName;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getName = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_baseclass.d_epv->getName;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.setName = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_baseclass.d_epv->setName;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.isInstanceOf = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_baseclass.d_epv->isInstanceOf;
    ASE_Compiler_Cxx_DepthFirstVisitor_epv.getSuper = self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_baseclass.d_epv->getSuper;
    /* Virtualize superclass ASE.BaseClass methods with those of class ASE.Compiler.Cxx.DepthFirstVisitor */
    ASE_BaseClass_epv.castObject = ASE_Compiler_Cxx_DepthFirstVisitor_epv.castObject;
    ASE_BaseClass_epv.destroyObject = ASE_Compiler_Cxx_DepthFirstVisitor_epv.destroyObject;
    ASE_BaseClass_epv.strObject = ASE_Compiler_Cxx_DepthFirstVisitor_epv.strObject;
    ASE_BaseClass_epv.getReferenceCount = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReferenceCount;
    ASE_BaseClass_epv.addReference = ASE_Compiler_Cxx_DepthFirstVisitor_epv.addReference;
    ASE_BaseClass_epv.deleteReference = ASE_Compiler_Cxx_DepthFirstVisitor_epv.deleteReference;
    ASE_BaseClass_epv.isSame = ASE_Compiler_Cxx_DepthFirstVisitor_epv.isSame;
    ASE_BaseClass_epv.getClassName = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getClassName;
    ASE_BaseClass_epv.getName = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getName;
    ASE_BaseClass_epv.setName = ASE_Compiler_Cxx_DepthFirstVisitor_epv.setName;
    ASE_BaseClass_epv.isInstanceOf = ASE_Compiler_Cxx_DepthFirstVisitor_epv.isInstanceOf;
    ASE_BaseClass_epv.getSuper = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getSuper;
    /* Initialize interface ASE.Compiler.Cxx.Visitor methods with those of class ASE.Compiler.Cxx.DepthFirstVisitor */
    ASE_Compiler_Cxx_Visitor_epv.castObject = ASE_Compiler_Cxx_DepthFirstVisitor_epv.castObject;
    ASE_Compiler_Cxx_Visitor_epv.destroyObject = ASE_Compiler_Cxx_DepthFirstVisitor_epv.destroyObject;
    ASE_Compiler_Cxx_Visitor_epv.strObject = ASE_Compiler_Cxx_DepthFirstVisitor_epv.strObject;
    ASE_Compiler_Cxx_Visitor_epv.getReferenceCount = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReferenceCount;
    ASE_Compiler_Cxx_Visitor_epv.addReference = ASE_Compiler_Cxx_DepthFirstVisitor_epv.addReference;
    ASE_Compiler_Cxx_Visitor_epv.deleteReference = ASE_Compiler_Cxx_DepthFirstVisitor_epv.deleteReference;
    ASE_Compiler_Cxx_Visitor_epv.isSame = ASE_Compiler_Cxx_DepthFirstVisitor_epv.isSame;
    ASE_Compiler_Cxx_Visitor_epv.getClassName = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getClassName;
    ASE_Compiler_Cxx_Visitor_epv.getName = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getName;
    ASE_Compiler_Cxx_Visitor_epv.setName = ASE_Compiler_Cxx_DepthFirstVisitor_epv.setName;
    ASE_Compiler_Cxx_Visitor_epv.isInstanceOf = ASE_Compiler_Cxx_DepthFirstVisitor_epv.isInstanceOf;
    ASE_Compiler_Cxx_Visitor_epv.getSuper = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getSuper;
    ASE_Compiler_Cxx_Visitor_epv.getRepository = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getRepository;
    ASE_Compiler_Cxx_Visitor_epv.setRepository = ASE_Compiler_Cxx_DepthFirstVisitor_epv.setRepository;
    ASE_Compiler_Cxx_Visitor_epv.visitVertex = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitVertex;
    ASE_Compiler_Cxx_Visitor_epv.visitSource = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSource;
    ASE_Compiler_Cxx_Visitor_epv.visitHeader = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitHeader;
    ASE_Compiler_Cxx_Visitor_epv.visitPythonModule = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitPythonModule;
    ASE_Compiler_Cxx_Visitor_epv.visitInclude = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInclude;
    ASE_Compiler_Cxx_Visitor_epv.visitDefine = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDefine;
    ASE_Compiler_Cxx_Visitor_epv.visitMacro = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitMacro;
    ASE_Compiler_Cxx_Visitor_epv.visitPreprocessorConditional = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitPreprocessorConditional;
    ASE_Compiler_Cxx_Visitor_epv.visitType = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitType;
    ASE_Compiler_Cxx_Visitor_epv.visitPointer = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitPointer;
    ASE_Compiler_Cxx_Visitor_epv.visitStruct = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitStruct;
    ASE_Compiler_Cxx_Visitor_epv.visitBitField = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitBitField;
    ASE_Compiler_Cxx_Visitor_epv.visitEnumeration = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitEnumeration;
    ASE_Compiler_Cxx_Visitor_epv.visitEnumerator = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitEnumerator;
    ASE_Compiler_Cxx_Visitor_epv.visitTypedef = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitTypedef;
    ASE_Compiler_Cxx_Visitor_epv.visitGroup = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitGroup;
    ASE_Compiler_Cxx_Visitor_epv.visitDeclarator = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDeclarator;
    ASE_Compiler_Cxx_Visitor_epv.visitDeclaratorGroup = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDeclaratorGroup;
    ASE_Compiler_Cxx_Visitor_epv.visitArray = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitArray;
    ASE_Compiler_Cxx_Visitor_epv.visitFunction = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitFunction;
    ASE_Compiler_Cxx_Visitor_epv.visitParameter = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitParameter;
    ASE_Compiler_Cxx_Visitor_epv.visitDeclaration = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDeclaration;
    ASE_Compiler_Cxx_Visitor_epv.visitStatement = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitStatement;
    ASE_Compiler_Cxx_Visitor_epv.visitExpressionStatement = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitExpressionStatement;
    ASE_Compiler_Cxx_Visitor_epv.visitCompoundStatement = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitCompoundStatement;
    ASE_Compiler_Cxx_Visitor_epv.visitIf = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitIf;
    ASE_Compiler_Cxx_Visitor_epv.visitSwitch = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSwitch;
    ASE_Compiler_Cxx_Visitor_epv.visitWhile = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitWhile;
    ASE_Compiler_Cxx_Visitor_epv.visitFor = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitFor;
    ASE_Compiler_Cxx_Visitor_epv.visitGoto = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitGoto;
    ASE_Compiler_Cxx_Visitor_epv.visitContinue = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitContinue;
    ASE_Compiler_Cxx_Visitor_epv.visitBreak = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitBreak;
    ASE_Compiler_Cxx_Visitor_epv.visitReturn = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitReturn;
    ASE_Compiler_Cxx_Visitor_epv.visitInitializer = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInitializer;
    ASE_Compiler_Cxx_Visitor_epv.visitExpression = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitExpression;
    ASE_Compiler_Cxx_Visitor_epv.visitAssignment = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitInclusiveOrAssignment = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInclusiveOrAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitExclusiveOrAssignment = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitExclusiveOrAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitAndAssignment = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAndAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitLeftShiftAssignment = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLeftShiftAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitRightShiftAssignment = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitRightShiftAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitAdditionAssignment = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAdditionAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitSubtractionAssignment = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSubtractionAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitMultiplicationAssignment = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitMultiplicationAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitDivisionAssignment = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDivisionAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitModuloAssignment = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitModuloAssignment;
    ASE_Compiler_Cxx_Visitor_epv.visitLogicalOr = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLogicalOr;
    ASE_Compiler_Cxx_Visitor_epv.visitLogicalAnd = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLogicalAnd;
    ASE_Compiler_Cxx_Visitor_epv.visitInclusiveOr = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInclusiveOr;
    ASE_Compiler_Cxx_Visitor_epv.visitExclusiveOr = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitExclusiveOr;
    ASE_Compiler_Cxx_Visitor_epv.visitAnd = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAnd;
    ASE_Compiler_Cxx_Visitor_epv.visitEquality = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitEquality;
    ASE_Compiler_Cxx_Visitor_epv.visitInequality = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitInequality;
    ASE_Compiler_Cxx_Visitor_epv.visitLessThan = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLessThan;
    ASE_Compiler_Cxx_Visitor_epv.visitGreaterThan = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitGreaterThan;
    ASE_Compiler_Cxx_Visitor_epv.visitLessThanOrEqual = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLessThanOrEqual;
    ASE_Compiler_Cxx_Visitor_epv.visitGreaterThanOrEqual = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitGreaterThanOrEqual;
    ASE_Compiler_Cxx_Visitor_epv.visitLeftShift = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitLeftShift;
    ASE_Compiler_Cxx_Visitor_epv.visitRightShift = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitRightShift;
    ASE_Compiler_Cxx_Visitor_epv.visitAddition = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAddition;
    ASE_Compiler_Cxx_Visitor_epv.visitSubtraction = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSubtraction;
    ASE_Compiler_Cxx_Visitor_epv.visitMultiplication = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitMultiplication;
    ASE_Compiler_Cxx_Visitor_epv.visitDivision = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitDivision;
    ASE_Compiler_Cxx_Visitor_epv.visitModulo = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitModulo;
    ASE_Compiler_Cxx_Visitor_epv.visitCast = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitCast;
    ASE_Compiler_Cxx_Visitor_epv.visitSizeof = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitSizeof;
    ASE_Compiler_Cxx_Visitor_epv.visitAddress = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitAddress;
    ASE_Compiler_Cxx_Visitor_epv.visitIndirection = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitIndirection;
    ASE_Compiler_Cxx_Visitor_epv.visitUnaryPlus = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitUnaryPlus;
    ASE_Compiler_Cxx_Visitor_epv.visitUnaryMinus = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitUnaryMinus;
    ASE_Compiler_Cxx_Visitor_epv.visitComplement = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitComplement;
    ASE_Compiler_Cxx_Visitor_epv.visitNegation = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitNegation;
    ASE_Compiler_Cxx_Visitor_epv.visitIncrement = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitIncrement;
    ASE_Compiler_Cxx_Visitor_epv.visitStructReference = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitStructReference;
    ASE_Compiler_Cxx_Visitor_epv.visitArrayReference = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitArrayReference;
    ASE_Compiler_Cxx_Visitor_epv.visitFunctionCall = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitFunctionCall;
    ASE_Compiler_Cxx_Visitor_epv.visitVariable = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitVariable;
    ASE_Compiler_Cxx_Visitor_epv.visitConstant = ASE_Compiler_Cxx_DepthFirstVisitor_epv.visitConstant;
    /* Initialize interface ASE.Compiler.Search methods with those of class ASE.Compiler.Cxx.DepthFirstVisitor */
    ASE_Compiler_Search_epv.castObject = ASE_Compiler_Cxx_DepthFirstVisitor_epv.castObject;
    ASE_Compiler_Search_epv.destroyObject = ASE_Compiler_Cxx_DepthFirstVisitor_epv.destroyObject;
    ASE_Compiler_Search_epv.strObject = ASE_Compiler_Cxx_DepthFirstVisitor_epv.strObject;
    ASE_Compiler_Search_epv.getReferenceCount = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReferenceCount;
    ASE_Compiler_Search_epv.addReference = ASE_Compiler_Cxx_DepthFirstVisitor_epv.addReference;
    ASE_Compiler_Search_epv.deleteReference = ASE_Compiler_Cxx_DepthFirstVisitor_epv.deleteReference;
    ASE_Compiler_Search_epv.isSame = ASE_Compiler_Cxx_DepthFirstVisitor_epv.isSame;
    ASE_Compiler_Search_epv.getClassName = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getClassName;
    ASE_Compiler_Search_epv.getName = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getName;
    ASE_Compiler_Search_epv.setName = ASE_Compiler_Cxx_DepthFirstVisitor_epv.setName;
    ASE_Compiler_Search_epv.isInstanceOf = ASE_Compiler_Cxx_DepthFirstVisitor_epv.isInstanceOf;
    ASE_Compiler_Search_epv.getSuper = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getSuper;
    ASE_Compiler_Search_epv.getReverseEdges = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getReverseEdges;
    ASE_Compiler_Search_epv.setReverseEdges = ASE_Compiler_Cxx_DepthFirstVisitor_epv.setReverseEdges;
    ASE_Compiler_Search_epv.traverseVertex = ASE_Compiler_Cxx_DepthFirstVisitor_epv.traverseVertex;
    ASE_Compiler_Search_epv.resetVertexNumbering = ASE_Compiler_Cxx_DepthFirstVisitor_epv.resetVertexNumbering;
    ASE_Compiler_Search_epv.discoverVertex = ASE_Compiler_Cxx_DepthFirstVisitor_epv.discoverVertex;
    ASE_Compiler_Search_epv.finishVertex = ASE_Compiler_Cxx_DepthFirstVisitor_epv.finishVertex;
    ASE_Compiler_Search_epv.getVerticesSeen = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getVerticesSeen;
    ASE_Compiler_Search_epv.setVerticesSeen = ASE_Compiler_Cxx_DepthFirstVisitor_epv.setVerticesSeen;
    ASE_Compiler_Search_epv.getVertexSeen = ASE_Compiler_Cxx_DepthFirstVisitor_epv.getVertexSeen;
    ASE_Compiler_Search_epv.setVertexSeen = ASE_Compiler_Cxx_DepthFirstVisitor_epv.setVertexSeen;
    epvInitialized = 1;
  }
  self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_baseclass.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_baseclass.d_epv = &ASE_BaseClass_epv;
  self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_compiler_cxx_visitor.ase_compiler_visitor.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_compiler_cxx_visitor.ase_compiler_visitor.d_epv = &ASE_Compiler_Visitor_epv;
  self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_compiler_cxx_visitor.d_epv = &ASE_Compiler_Cxx_Visitor_epv;
  self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_compiler_search.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.ase_compiler_search.d_epv = &ASE_Compiler_Search_epv;
  self->ase_compiler_cxx_printer.ase_compiler_cxx_depthfirstvisitor.d_epv = &ASE_Compiler_Cxx_DepthFirstVisitor_epv;
  self->ase_compiler_cxx_printer.ase_compiler_printer.ase_compiler_visitor.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_cxx_printer.ase_compiler_printer.ase_compiler_visitor.d_epv = &ASE_Compiler_Visitor_epv;
  self->ase_compiler_cxx_printer.ase_compiler_printer.d_epv = &ASE_Compiler_Printer_epv;
  self->ase_compiler_cxx_printer.d_epv = &ASE_Compiler_Cxx_Printer_epv;
  self->ase_compiler_output.ase_compiler_visitor.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_output.ase_compiler_visitor.d_epv = &ASE_Compiler_Visitor_epv;
  self->ase_compiler_output.d_epv = &ASE_Compiler_Output_epv;
  self->d_epv = &ASE_Compiler_Cxx_Output_epv;
  /* Save old EPV for getSuper() */
  self->d_oldEpv = self->d_epv;
  /* Initialize pointers to the original object */
  self->d_object = obj;
  self->ase_compiler_output.d_object = obj;
  self->ase_compiler_output.ase_compiler_visitor.d_object = obj;
  self->ase_compiler_output.ase_compiler_visitor.ase_baseinterface.d_object = obj;
  /* Setup implementation data */
  self->d_data = NULL;
  (*(self->d_epv->Output))(self, _exception);
}

static struct ASE_Compiler_Cxx_Output__object *createObject(/*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_Output__object *self = (struct ASE_Compiler_Cxx_Output__object *) malloc(sizeof(struct ASE_Compiler_Cxx_Output__object));
  
  initObject(self, self, _exception);
  return self;
}

#ifndef included_ASE_ASEException
#include "ASE/ASEException_IOR.h"
#endif

static struct ASE_Compiler_Cxx_Output__array *createArray(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*out*/ struct ASE_BaseException__object **_exception)
{
  static int32_t arraySize = sizeof(struct ASE_Compiler_Cxx_Output__array) + (sizeof(int32_t) - (sizeof(struct ASE_Compiler_Cxx_Output__array)) % sizeof(int32_t)) % sizeof(int32_t);
  struct ASE_Compiler_Cxx_Output__array *_return_value = (struct ASE_Compiler_Cxx_Output__array *) malloc(arraySize + 3 * sizeof(int32_t) * (dimen ? dimen : 1));
  int32_t size = 1;
  int32_t d = 0;
  
  /* Initialize array structure */
  _return_value->d_dimen = dimen;
  _return_value->d_borrowed = 0;
  _return_value->d_lower = (int32_t *) ((char *) _return_value + arraySize);
  _return_value->d_upper = _return_value->d_lower + (dimen ? dimen : 1);
  _return_value->d_stride = _return_value->d_upper + (dimen ? dimen : 1);
  _return_value->d_lower[0] = 0;
  _return_value->d_upper[0] = 0;
  _return_value->d_stride[0] = 1;
  /* Determine array size and set bounds */
  for(d = 0; d < dimen; d++)
  {
    _return_value->d_lower[d] = lower->d_firstElement[d];
    _return_value->d_upper[d] = upper->d_firstElement[d];
    _return_value->d_stride[d] = size;
    size *= upper->d_firstElement[d] - lower->d_firstElement[d] + 1;
  }
  size *= sizeof(struct ASE_Compiler_Cxx_Output__object *);
  /* Allocate and initialize data */
  _return_value->d_firstElement = (struct ASE_Compiler_Cxx_Output__object **) malloc(size);
  memset(_return_value->d_firstElement, 0, size);
  return _return_value;
}

static struct ASE_Compiler_Cxx_Output__array *borrowArray(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*in*/ struct int__array *stride, /*in*/ void *first, /*out*/ struct ASE_BaseException__object **_exception)
{
  static int32_t arraySize = sizeof(struct ASE_Compiler_Cxx_Output__array) + (sizeof(int32_t) - (sizeof(struct ASE_Compiler_Cxx_Output__array)) % sizeof(int32_t)) % sizeof(int32_t);
  struct ASE_Compiler_Cxx_Output__array *_return_value = (struct ASE_Compiler_Cxx_Output__array *) malloc(arraySize + 3 * sizeof(int32_t) * (dimen ? dimen : 1));
  int32_t size = 1;
  int32_t d = 0;
  
  /* Initialize array structure */
  _return_value->d_dimen = dimen;
  _return_value->d_borrowed = 1;
  _return_value->d_lower = (int32_t *) ((char *) _return_value + arraySize);
  _return_value->d_upper = _return_value->d_lower + (dimen ? dimen : 1);
  _return_value->d_stride = _return_value->d_upper + (dimen ? dimen : 1);
  _return_value->d_lower[0] = 0;
  _return_value->d_upper[0] = 0;
  _return_value->d_stride[0] = 1;
  /* Determine array size and set bounds */
  for(d = 0; d < dimen; d++)
  {
    _return_value->d_lower[d] = lower->d_firstElement[d];
    _return_value->d_upper[d] = upper->d_firstElement[d];
    _return_value->d_stride[d] = stride->d_firstElement[d];
    size *= upper->d_firstElement[d] - lower->d_firstElement[d] + 1;
  }
  size *= sizeof(struct ASE_Compiler_Cxx_Output__object *);
  _return_value->d_firstElement = (struct ASE_Compiler_Cxx_Output__object **) first;
  return _return_value;
}

static void destroyArray(/*in*/ struct ASE_Compiler_Cxx_Output__array *array, /*out*/ struct ASE_BaseException__object **_exception)
{
}

static int32_t getDimen(/*in*/ struct ASE_Compiler_Cxx_Output__array *array, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_dimen;
}

static int32_t getLower(/*in*/ struct ASE_Compiler_Cxx_Output__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_lower[dimen];
}

static int32_t getUpper(/*in*/ struct ASE_Compiler_Cxx_Output__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_upper[dimen];
}

static struct ASE_Compiler_Cxx_Output__object *getElement(/*in*/ struct ASE_Compiler_Cxx_Output__array *array, /*in*/ struct int__array *indices, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_Output__object *_result = NULL;
  struct ASE_Compiler_Cxx_Output__object **_element = NULL;
  int32_t d = 0;
  
  _element = array->d_firstElement;
  for(d = 0; d < array->d_dimen; d++)
  {
    if (indices->d_firstElement[d] < array->d_lower[d] || indices->d_firstElement[d] > array->d_upper[d])
    {
      struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
      
      _local_exception->d_epv->setMessage(_local_exception, "Invalid indices", _exception);
      if (!(*_exception))
      {
        *_exception = (struct ASE_BaseException__object *) _local_exception;
      }
      return _result;
    }
    _element += array->d_stride[d] * (indices->d_firstElement[d] - array->d_lower[d]);
  }
  if (*_element)
  {
    (*(((struct ASE_BaseInterface__object *) (*_element)->d_object)->d_epv->deleteReference))((*_element)->d_object, (void **) _exception);
  }
  return *_element;
}

static struct ASE_Compiler_Cxx_Output__object *getElement4(/*in*/ struct ASE_Compiler_Cxx_Output__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*out*/ struct ASE_BaseException__object **_exception)
{
}

static void setElement(/*in*/ struct ASE_Compiler_Cxx_Output__array *array, /*in*/ struct int__array *indices, /*in*/ struct ASE_Compiler_Cxx_Output__object *value, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Cxx_Output__object **_element = NULL;
  int32_t d = 0;
  
  _element = array->d_firstElement;
  for(d = 0; d < array->d_dimen; d++)
  {
    if (indices->d_firstElement[d] < array->d_lower[d] || indices->d_firstElement[d] > array->d_upper[d])
    {
      struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
      
      _local_exception->d_epv->setMessage(_local_exception, "Invalid indices", _exception);
      if (!(*_exception))
      {
        *_exception = (struct ASE_BaseException__object *) _local_exception;
      }
      return;
    }
    _element += array->d_stride[d] * (indices->d_firstElement[d] - array->d_lower[d]);
  }
  if (value)
  {
    (*(((struct ASE_BaseInterface__object *) (value)->d_object)->d_epv->addReference))((value)->d_object, (void **) _exception);
  }
  if (*_element)
  {
    (*(((struct ASE_BaseInterface__object *) (*_element)->d_object)->d_epv->deleteReference))((*_element)->d_object, (void **) _exception);
  }
  *_element = value;
}

static void setElement4(/*in*/ struct ASE_Compiler_Cxx_Output__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*in*/ struct ASE_Compiler_Cxx_Output__object *value, /*out*/ struct ASE_BaseException__object **_exception)
{
}

/* The entry points into the DLL containing this type */
static struct ASE_Compiler_Cxx_Output__external externalEntryPoints = {
  createObject,
  initObject,
  finiObject,
  createArray,
  borrowArray,
  destroyArray,
  getDimen,
  getLower,
  getUpper,
  getElement,
  getElement4,
  setElement,
  setElement4};

const struct ASE_Compiler_Cxx_Output__external *ASE_Compiler_Cxx_Output__externals(void)
{
  return &externalEntryPoints;
}
