# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Python.Class
import ASE.Compiler.Python.Vertex
import ASE.Compiler.Python.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Class:
  '''
  A Python class
  The children of this node constitue the body of the class
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.parents = []
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitClass(self.__IORself)
  
  def getParents(self):
    '''
    Retrieve the superclasses of this class
    '''
    return self.parents
  
  def setParents(self, parents):
    '''
    Set the superclasses of this class
    '''
    self.parents = list(parents)
  
  def addParents(self, parents):
    '''
    Add superclasses to this class
    '''
    self.parents.extend(parents)
  
  def removeParents(self, parents):
    '''
    Remove superclasses from this class
    Throws an exception if a parent does not exist
    '''
    for parent in parents:
      if parent in self.parents:
        self.parents.remove(parent)
      else:
        e = ASE.Compiler.CompilerException.CompilerException()
        e.setMessage('Superclass does not exist: ' + interface.getIdentifier())
        raise e
  # Ending class methods section
  pass
