# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Python.Vertex
import ASE.Compiler.Python.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class For:
  '''
  A Python for statement
  The child is the body
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.var = None
    self.list = None
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitFor(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.For.For()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    root.setVar(self.__IORself.getVar().copy())
    root.setList(self.__IORself.getList().copy())
    return root
  
  def getVar(self):
    '''
    Retrieve the iteration variable
    '''
    return self.var
  
  def setVar(self, var):
    '''
    Set the iteration list
    '''
    self.var = var
  
  def getList(self):
    '''
    Retrieve the iteration list
    '''
    return self.list
  
  def setList(self, list):
    '''
    Set the iteration list
    '''
    self.list = list
  # Ending class methods section
  pass
