#include <stdlib.h>

#include <string.h>

#ifndef included_ASE_Compiler_Python_Output
#include "ASE/Compiler/Python/Output_IOR.h"
#endif

static const char *getClassName(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return strdup("ASE.Compiler.Python.Output");
}

#ifndef included_ASE_Loader
#include "ASE/Loader_IOR.h"
#endif

#ifndef included_ASE_ASEException
#include "ASE/ASEException_IOR.h"
#endif

static void *castObject(struct ASE_Compiler_Python_Output__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  /* We are guaranteed here that the first member in any IOR is a ASE.BaseInterface object */
  struct ASE_Compiler_Python_Output__object *obj = ((struct ASE_BaseInterface__object *) self)->d_object;
  void *cast = NULL;
  
  if (!strcmp(name, "ASE.Compiler.Python.Output"))
  {
    cast = obj;
  }
  else
  if (!strcmp(name, "ASE.Compiler.Python.Printer"))
  {
    cast = (&obj->ase_compiler_python_printer);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Python.DepthFirstVisitor"))
  {
    cast = (&(&obj->ase_compiler_python_printer)->ase_compiler_python_depthfirstvisitor);
  }
  else
  if (!strcmp(name, "ASE.BaseClass"))
  {
    cast = (&(&(&obj->ase_compiler_python_printer)->ase_compiler_python_depthfirstvisitor)->ase_baseclass);
  }
  else
  if (!strcmp(name, "ASE.BaseInterface"))
  {
    cast = (&(&(&(&obj->ase_compiler_python_printer)->ase_compiler_python_depthfirstvisitor)->ase_baseclass)->ase_baseinterface);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Python.Visitor"))
  {
    cast = (&(&(&obj->ase_compiler_python_printer)->ase_compiler_python_depthfirstvisitor)->ase_compiler_python_visitor);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Visitor"))
  {
    cast = (&(&(&(&obj->ase_compiler_python_printer)->ase_compiler_python_depthfirstvisitor)->ase_compiler_python_visitor)->ase_compiler_visitor);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Search"))
  {
    cast = (&(&(&obj->ase_compiler_python_printer)->ase_compiler_python_depthfirstvisitor)->ase_compiler_search);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Printer"))
  {
    cast = (&(&obj->ase_compiler_python_printer)->ase_compiler_printer);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Output"))
  {
    cast = (&obj->ase_compiler_output);
  }
  return cast;
}

static const char *strObject(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return "ASE.Compiler.Python.Output";
}

static void finiObject(/*in*/ struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_Printer__object *parent = &self->ase_compiler_python_printer;
  const struct ASE_Compiler_Python_Printer__external *(*extFunc)(void) = (const struct ASE_Compiler_Python_Printer__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.Compiler.Python.Printer", _exception);
  void (*parentFini)(/*in*/ struct ASE_Compiler_Python_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->finiObject;
  
  self->ase_compiler_output.d_epv = self->ase_compiler_output.d_oldEpv;
  self->ase_compiler_python_printer.d_epv = self->ase_compiler_python_printer.d_oldEpv;
  (*(self->d_epv->Output_))(self, _exception);
  if (!parentFini)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find finalizer for ASE.Compiler.Python.Printer", _exception);
    if (!(*_exception))
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentFini)(parent, _exception);
}

static void destroyObject(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  finiObject(self->d_object, _exception);
  memset(self->d_object, 0, sizeof(struct ASE_Compiler_Python_Output__object));
  free(self->d_object);
}

static void initObject(/*in*/ struct ASE_Compiler_Python_Output__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_Printer__object *parent = &self->ase_compiler_python_printer;
  const struct ASE_Compiler_Python_Printer__external *(*extFunc)(void) = (const struct ASE_Compiler_Python_Printer__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.Compiler.Python.Printer", _exception);
  void (*parentInit)(/*in*/ struct ASE_Compiler_Python_Printer__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->initObject;
  int epvInitialized = 0;
  static struct ASE_Compiler_Python_Output__epv ASE_Compiler_Python_Output_epv;
  static struct ASE_Compiler_Python_Printer__epv ASE_Compiler_Python_Printer_epv;
  static struct ASE_Compiler_Python_DepthFirstVisitor__epv ASE_Compiler_Python_DepthFirstVisitor_epv;
  static struct ASE_BaseClass__epv ASE_BaseClass_epv;
  static struct ASE_BaseInterface__epv ASE_BaseInterface_epv;
  static struct ASE_Compiler_Python_Visitor__epv ASE_Compiler_Python_Visitor_epv;
  static struct ASE_Compiler_Visitor__epv ASE_Compiler_Visitor_epv;
  static struct ASE_Compiler_Search__epv ASE_Compiler_Search_epv;
  static struct ASE_Compiler_Printer__epv ASE_Compiler_Printer_epv;
  static struct ASE_Compiler_Output__epv ASE_Compiler_Output_epv;
  
  if (!parentInit)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find initializer for ASE.Compiler.Python.Printer", _exception);
    if (!(*_exception))
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentInit)(parent, obj, _exception);
  if (!epvInitialized)
  {
    ASE_Compiler_Python_Output_epv.castObject = castObject;
    ASE_Compiler_Python_Output_epv.destroyObject = destroyObject;
    ASE_Compiler_Python_Output_epv.strObject = strObject;
    ASE_Compiler_Python_Output_epv.getClassName = getClassName;
    ASE_Compiler_Python_Output__set_epv(&ASE_Compiler_Python_Output_epv, _exception);
    /* Override class ASE.Compiler.Python.Output methods with those of superclass ASE.Compiler.Python.Printer */
    ASE_Compiler_Python_Output_epv.getTab = self->ase_compiler_python_printer.d_epv->getTab;
    ASE_Compiler_Python_Output_epv.setTab = self->ase_compiler_python_printer.d_epv->setTab;
    ASE_Compiler_Python_Output_epv.getIndentSize = self->ase_compiler_python_printer.d_epv->getIndentSize;
    ASE_Compiler_Python_Output_epv.setIndentSize = self->ase_compiler_python_printer.d_epv->setIndentSize;
    ASE_Compiler_Python_Output_epv.increaseIndent = self->ase_compiler_python_printer.d_epv->increaseIndent;
    ASE_Compiler_Python_Output_epv.decreaseIndent = self->ase_compiler_python_printer.d_epv->decreaseIndent;
    ASE_Compiler_Python_Output_epv.indent = self->ase_compiler_python_printer.d_epv->indent;
    ASE_Compiler_Python_Output_epv.println = self->ase_compiler_python_printer.d_epv->println;
    ASE_Compiler_Python_Output_epv.getRepository = self->ase_compiler_python_printer.d_epv->getRepository;
    ASE_Compiler_Python_Output_epv.setRepository = self->ase_compiler_python_printer.d_epv->setRepository;
    ASE_Compiler_Python_Output_epv.visitVertex = self->ase_compiler_python_printer.d_epv->visitVertex;
    ASE_Compiler_Python_Output_epv.getReverseEdges = self->ase_compiler_python_printer.d_epv->getReverseEdges;
    ASE_Compiler_Python_Output_epv.setReverseEdges = self->ase_compiler_python_printer.d_epv->setReverseEdges;
    ASE_Compiler_Python_Output_epv.traverseVertex = self->ase_compiler_python_printer.d_epv->traverseVertex;
    ASE_Compiler_Python_Output_epv.resetVertexNumbering = self->ase_compiler_python_printer.d_epv->resetVertexNumbering;
    ASE_Compiler_Python_Output_epv.discoverVertex = self->ase_compiler_python_printer.d_epv->discoverVertex;
    ASE_Compiler_Python_Output_epv.finishVertex = self->ase_compiler_python_printer.d_epv->finishVertex;
    ASE_Compiler_Python_Output_epv.getVerticesSeen = self->ase_compiler_python_printer.d_epv->getVerticesSeen;
    ASE_Compiler_Python_Output_epv.setVerticesSeen = self->ase_compiler_python_printer.d_epv->setVerticesSeen;
    ASE_Compiler_Python_Output_epv.getVertexSeen = self->ase_compiler_python_printer.d_epv->getVertexSeen;
    ASE_Compiler_Python_Output_epv.setVertexSeen = self->ase_compiler_python_printer.d_epv->setVertexSeen;
    ASE_Compiler_Python_Output_epv.getReferenceCount = self->ase_compiler_python_printer.d_epv->getReferenceCount;
    ASE_Compiler_Python_Output_epv.addReference = self->ase_compiler_python_printer.d_epv->addReference;
    ASE_Compiler_Python_Output_epv.deleteReference = self->ase_compiler_python_printer.d_epv->deleteReference;
    ASE_Compiler_Python_Output_epv.isSame = self->ase_compiler_python_printer.d_epv->isSame;
    ASE_Compiler_Python_Output_epv.getClassName = self->ase_compiler_python_printer.d_epv->getClassName;
    ASE_Compiler_Python_Output_epv.getName = self->ase_compiler_python_printer.d_epv->getName;
    ASE_Compiler_Python_Output_epv.setName = self->ase_compiler_python_printer.d_epv->setName;
    ASE_Compiler_Python_Output_epv.isInstanceOf = self->ase_compiler_python_printer.d_epv->isInstanceOf;
    ASE_Compiler_Python_Output_epv.getSuper = self->ase_compiler_python_printer.d_epv->getSuper;
    ASE_Compiler_Python_Output_epv.visitAdd = self->ase_compiler_python_printer.d_epv->visitAdd;
    ASE_Compiler_Python_Output_epv.visitAnd = self->ase_compiler_python_printer.d_epv->visitAnd;
    ASE_Compiler_Python_Output_epv.visitAssAttr = self->ase_compiler_python_printer.d_epv->visitAssAttr;
    ASE_Compiler_Python_Output_epv.visitAssList = self->ase_compiler_python_printer.d_epv->visitAssList;
    ASE_Compiler_Python_Output_epv.visitAssName = self->ase_compiler_python_printer.d_epv->visitAssName;
    ASE_Compiler_Python_Output_epv.visitAssTuple = self->ase_compiler_python_printer.d_epv->visitAssTuple;
    ASE_Compiler_Python_Output_epv.visitAssign = self->ase_compiler_python_printer.d_epv->visitAssign;
    ASE_Compiler_Python_Output_epv.visitAugAssign = self->ase_compiler_python_printer.d_epv->visitAugAssign;
    ASE_Compiler_Python_Output_epv.visitBitand = self->ase_compiler_python_printer.d_epv->visitBitand;
    ASE_Compiler_Python_Output_epv.visitBitor = self->ase_compiler_python_printer.d_epv->visitBitor;
    ASE_Compiler_Python_Output_epv.visitBitxor = self->ase_compiler_python_printer.d_epv->visitBitxor;
    ASE_Compiler_Python_Output_epv.visitBreak = self->ase_compiler_python_printer.d_epv->visitBreak;
    ASE_Compiler_Python_Output_epv.visitCallFunc = self->ase_compiler_python_printer.d_epv->visitCallFunc;
    ASE_Compiler_Python_Output_epv.visitClass = self->ase_compiler_python_printer.d_epv->visitClass;
    ASE_Compiler_Python_Output_epv.visitCompare = self->ase_compiler_python_printer.d_epv->visitCompare;
    ASE_Compiler_Python_Output_epv.visitConst = self->ase_compiler_python_printer.d_epv->visitConst;
    ASE_Compiler_Python_Output_epv.visitPyNone = self->ase_compiler_python_printer.d_epv->visitPyNone;
    ASE_Compiler_Python_Output_epv.visitContinue = self->ase_compiler_python_printer.d_epv->visitContinue;
    ASE_Compiler_Python_Output_epv.visitDict = self->ase_compiler_python_printer.d_epv->visitDict;
    ASE_Compiler_Python_Output_epv.visitDiscard = self->ase_compiler_python_printer.d_epv->visitDiscard;
    ASE_Compiler_Python_Output_epv.visitDiv = self->ase_compiler_python_printer.d_epv->visitDiv;
    ASE_Compiler_Python_Output_epv.visitEllipsis = self->ase_compiler_python_printer.d_epv->visitEllipsis;
    ASE_Compiler_Python_Output_epv.visitFor = self->ase_compiler_python_printer.d_epv->visitFor;
    ASE_Compiler_Python_Output_epv.visitListCompFor = self->ase_compiler_python_printer.d_epv->visitListCompFor;
    ASE_Compiler_Python_Output_epv.visitFunction = self->ase_compiler_python_printer.d_epv->visitFunction;
    ASE_Compiler_Python_Output_epv.visitLambda = self->ase_compiler_python_printer.d_epv->visitLambda;
    ASE_Compiler_Python_Output_epv.visitGetAttr = self->ase_compiler_python_printer.d_epv->visitGetAttr;
    ASE_Compiler_Python_Output_epv.visitGlobal = self->ase_compiler_python_printer.d_epv->visitGlobal;
    ASE_Compiler_Python_Output_epv.visitIf = self->ase_compiler_python_printer.d_epv->visitIf;
    ASE_Compiler_Python_Output_epv.visitListCompIf = self->ase_compiler_python_printer.d_epv->visitListCompIf;
    ASE_Compiler_Python_Output_epv.visitImport = self->ase_compiler_python_printer.d_epv->visitImport;
    ASE_Compiler_Python_Output_epv.visitFrom = self->ase_compiler_python_printer.d_epv->visitFrom;
    ASE_Compiler_Python_Output_epv.visitInvert = self->ase_compiler_python_printer.d_epv->visitInvert;
    ASE_Compiler_Python_Output_epv.visitKeyword = self->ase_compiler_python_printer.d_epv->visitKeyword;
    ASE_Compiler_Python_Output_epv.visitLeftShift = self->ase_compiler_python_printer.d_epv->visitLeftShift;
    ASE_Compiler_Python_Output_epv.visitList = self->ase_compiler_python_printer.d_epv->visitList;
    ASE_Compiler_Python_Output_epv.visitListComp = self->ase_compiler_python_printer.d_epv->visitListComp;
    ASE_Compiler_Python_Output_epv.visitMod = self->ase_compiler_python_printer.d_epv->visitMod;
    ASE_Compiler_Python_Output_epv.visitMul = self->ase_compiler_python_printer.d_epv->visitMul;
    ASE_Compiler_Python_Output_epv.visitName = self->ase_compiler_python_printer.d_epv->visitName;
    ASE_Compiler_Python_Output_epv.visitNot = self->ase_compiler_python_printer.d_epv->visitNot;
    ASE_Compiler_Python_Output_epv.visitOr = self->ase_compiler_python_printer.d_epv->visitOr;
    ASE_Compiler_Python_Output_epv.visitPass = self->ase_compiler_python_printer.d_epv->visitPass;
    ASE_Compiler_Python_Output_epv.visitPower = self->ase_compiler_python_printer.d_epv->visitPower;
    ASE_Compiler_Python_Output_epv.visitPrint = self->ase_compiler_python_printer.d_epv->visitPrint;
    ASE_Compiler_Python_Output_epv.visitPrintnl = self->ase_compiler_python_printer.d_epv->visitPrintnl;
    ASE_Compiler_Python_Output_epv.visitRaise = self->ase_compiler_python_printer.d_epv->visitRaise;
    ASE_Compiler_Python_Output_epv.visitReturn = self->ase_compiler_python_printer.d_epv->visitReturn;
    ASE_Compiler_Python_Output_epv.visitRightShift = self->ase_compiler_python_printer.d_epv->visitRightShift;
    ASE_Compiler_Python_Output_epv.visitSlice = self->ase_compiler_python_printer.d_epv->visitSlice;
    ASE_Compiler_Python_Output_epv.visitStmt = self->ase_compiler_python_printer.d_epv->visitStmt;
    ASE_Compiler_Python_Output_epv.visitSub = self->ase_compiler_python_printer.d_epv->visitSub;
    ASE_Compiler_Python_Output_epv.visitSubscript = self->ase_compiler_python_printer.d_epv->visitSubscript;
    ASE_Compiler_Python_Output_epv.visitTryExcept = self->ase_compiler_python_printer.d_epv->visitTryExcept;
    ASE_Compiler_Python_Output_epv.visitTryFinally = self->ase_compiler_python_printer.d_epv->visitTryFinally;
    ASE_Compiler_Python_Output_epv.visitTuple = self->ase_compiler_python_printer.d_epv->visitTuple;
    ASE_Compiler_Python_Output_epv.visitUnaryAdd = self->ase_compiler_python_printer.d_epv->visitUnaryAdd;
    ASE_Compiler_Python_Output_epv.visitUnarySub = self->ase_compiler_python_printer.d_epv->visitUnarySub;
    ASE_Compiler_Python_Output_epv.visitWhile = self->ase_compiler_python_printer.d_epv->visitWhile;
    ASE_Compiler_Python_Output_epv.visitYield = self->ase_compiler_python_printer.d_epv->visitYield;
    ASE_Compiler_Python_Output_epv.printDocComment = self->ase_compiler_python_printer.d_epv->printDocComment;
    /* Virtualize superclass ASE.Compiler.Python.Printer methods with those of class ASE.Compiler.Python.Output */
    ASE_Compiler_Python_Printer_epv.castObject = ASE_Compiler_Python_Output_epv.castObject;
    ASE_Compiler_Python_Printer_epv.destroyObject = ASE_Compiler_Python_Output_epv.destroyObject;
    ASE_Compiler_Python_Printer_epv.strObject = ASE_Compiler_Python_Output_epv.strObject;
    ASE_Compiler_Python_Printer_epv.getTab = ASE_Compiler_Python_Output_epv.getTab;
    ASE_Compiler_Python_Printer_epv.setTab = ASE_Compiler_Python_Output_epv.setTab;
    ASE_Compiler_Python_Printer_epv.getIndentSize = ASE_Compiler_Python_Output_epv.getIndentSize;
    ASE_Compiler_Python_Printer_epv.setIndentSize = ASE_Compiler_Python_Output_epv.setIndentSize;
    ASE_Compiler_Python_Printer_epv.increaseIndent = ASE_Compiler_Python_Output_epv.increaseIndent;
    ASE_Compiler_Python_Printer_epv.decreaseIndent = ASE_Compiler_Python_Output_epv.decreaseIndent;
    ASE_Compiler_Python_Printer_epv.indent = ASE_Compiler_Python_Output_epv.indent;
    ASE_Compiler_Python_Printer_epv.write = ASE_Compiler_Python_Output_epv.write;
    ASE_Compiler_Python_Printer_epv.println = ASE_Compiler_Python_Output_epv.println;
    ASE_Compiler_Python_Printer_epv.getRepository = ASE_Compiler_Python_Output_epv.getRepository;
    ASE_Compiler_Python_Printer_epv.setRepository = ASE_Compiler_Python_Output_epv.setRepository;
    ASE_Compiler_Python_Printer_epv.visitVertex = ASE_Compiler_Python_Output_epv.visitVertex;
    ASE_Compiler_Python_Printer_epv.getReverseEdges = ASE_Compiler_Python_Output_epv.getReverseEdges;
    ASE_Compiler_Python_Printer_epv.setReverseEdges = ASE_Compiler_Python_Output_epv.setReverseEdges;
    ASE_Compiler_Python_Printer_epv.traverseVertex = ASE_Compiler_Python_Output_epv.traverseVertex;
    ASE_Compiler_Python_Printer_epv.resetVertexNumbering = ASE_Compiler_Python_Output_epv.resetVertexNumbering;
    ASE_Compiler_Python_Printer_epv.discoverVertex = ASE_Compiler_Python_Output_epv.discoverVertex;
    ASE_Compiler_Python_Printer_epv.finishVertex = ASE_Compiler_Python_Output_epv.finishVertex;
    ASE_Compiler_Python_Printer_epv.getVerticesSeen = ASE_Compiler_Python_Output_epv.getVerticesSeen;
    ASE_Compiler_Python_Printer_epv.setVerticesSeen = ASE_Compiler_Python_Output_epv.setVerticesSeen;
    ASE_Compiler_Python_Printer_epv.getVertexSeen = ASE_Compiler_Python_Output_epv.getVertexSeen;
    ASE_Compiler_Python_Printer_epv.setVertexSeen = ASE_Compiler_Python_Output_epv.setVertexSeen;
    ASE_Compiler_Python_Printer_epv.getReferenceCount = ASE_Compiler_Python_Output_epv.getReferenceCount;
    ASE_Compiler_Python_Printer_epv.addReference = ASE_Compiler_Python_Output_epv.addReference;
    ASE_Compiler_Python_Printer_epv.deleteReference = ASE_Compiler_Python_Output_epv.deleteReference;
    ASE_Compiler_Python_Printer_epv.isSame = ASE_Compiler_Python_Output_epv.isSame;
    ASE_Compiler_Python_Printer_epv.getClassName = ASE_Compiler_Python_Output_epv.getClassName;
    ASE_Compiler_Python_Printer_epv.getName = ASE_Compiler_Python_Output_epv.getName;
    ASE_Compiler_Python_Printer_epv.setName = ASE_Compiler_Python_Output_epv.setName;
    ASE_Compiler_Python_Printer_epv.isInstanceOf = ASE_Compiler_Python_Output_epv.isInstanceOf;
    ASE_Compiler_Python_Printer_epv.getSuper = ASE_Compiler_Python_Output_epv.getSuper;
    ASE_Compiler_Python_Printer_epv.visitAdd = ASE_Compiler_Python_Output_epv.visitAdd;
    ASE_Compiler_Python_Printer_epv.visitAnd = ASE_Compiler_Python_Output_epv.visitAnd;
    ASE_Compiler_Python_Printer_epv.visitAssAttr = ASE_Compiler_Python_Output_epv.visitAssAttr;
    ASE_Compiler_Python_Printer_epv.visitAssList = ASE_Compiler_Python_Output_epv.visitAssList;
    ASE_Compiler_Python_Printer_epv.visitAssName = ASE_Compiler_Python_Output_epv.visitAssName;
    ASE_Compiler_Python_Printer_epv.visitAssTuple = ASE_Compiler_Python_Output_epv.visitAssTuple;
    ASE_Compiler_Python_Printer_epv.visitAssign = ASE_Compiler_Python_Output_epv.visitAssign;
    ASE_Compiler_Python_Printer_epv.visitAugAssign = ASE_Compiler_Python_Output_epv.visitAugAssign;
    ASE_Compiler_Python_Printer_epv.visitBitand = ASE_Compiler_Python_Output_epv.visitBitand;
    ASE_Compiler_Python_Printer_epv.visitBitor = ASE_Compiler_Python_Output_epv.visitBitor;
    ASE_Compiler_Python_Printer_epv.visitBitxor = ASE_Compiler_Python_Output_epv.visitBitxor;
    ASE_Compiler_Python_Printer_epv.visitBreak = ASE_Compiler_Python_Output_epv.visitBreak;
    ASE_Compiler_Python_Printer_epv.visitCallFunc = ASE_Compiler_Python_Output_epv.visitCallFunc;
    ASE_Compiler_Python_Printer_epv.visitClass = ASE_Compiler_Python_Output_epv.visitClass;
    ASE_Compiler_Python_Printer_epv.visitCompare = ASE_Compiler_Python_Output_epv.visitCompare;
    ASE_Compiler_Python_Printer_epv.visitConst = ASE_Compiler_Python_Output_epv.visitConst;
    ASE_Compiler_Python_Printer_epv.visitPyNone = ASE_Compiler_Python_Output_epv.visitPyNone;
    ASE_Compiler_Python_Printer_epv.visitContinue = ASE_Compiler_Python_Output_epv.visitContinue;
    ASE_Compiler_Python_Printer_epv.visitDict = ASE_Compiler_Python_Output_epv.visitDict;
    ASE_Compiler_Python_Printer_epv.visitDiscard = ASE_Compiler_Python_Output_epv.visitDiscard;
    ASE_Compiler_Python_Printer_epv.visitDiv = ASE_Compiler_Python_Output_epv.visitDiv;
    ASE_Compiler_Python_Printer_epv.visitEllipsis = ASE_Compiler_Python_Output_epv.visitEllipsis;
    ASE_Compiler_Python_Printer_epv.visitFor = ASE_Compiler_Python_Output_epv.visitFor;
    ASE_Compiler_Python_Printer_epv.visitListCompFor = ASE_Compiler_Python_Output_epv.visitListCompFor;
    ASE_Compiler_Python_Printer_epv.visitFunction = ASE_Compiler_Python_Output_epv.visitFunction;
    ASE_Compiler_Python_Printer_epv.visitLambda = ASE_Compiler_Python_Output_epv.visitLambda;
    ASE_Compiler_Python_Printer_epv.visitGetAttr = ASE_Compiler_Python_Output_epv.visitGetAttr;
    ASE_Compiler_Python_Printer_epv.visitGlobal = ASE_Compiler_Python_Output_epv.visitGlobal;
    ASE_Compiler_Python_Printer_epv.visitIf = ASE_Compiler_Python_Output_epv.visitIf;
    ASE_Compiler_Python_Printer_epv.visitListCompIf = ASE_Compiler_Python_Output_epv.visitListCompIf;
    ASE_Compiler_Python_Printer_epv.visitImport = ASE_Compiler_Python_Output_epv.visitImport;
    ASE_Compiler_Python_Printer_epv.visitFrom = ASE_Compiler_Python_Output_epv.visitFrom;
    ASE_Compiler_Python_Printer_epv.visitInvert = ASE_Compiler_Python_Output_epv.visitInvert;
    ASE_Compiler_Python_Printer_epv.visitKeyword = ASE_Compiler_Python_Output_epv.visitKeyword;
    ASE_Compiler_Python_Printer_epv.visitLeftShift = ASE_Compiler_Python_Output_epv.visitLeftShift;
    ASE_Compiler_Python_Printer_epv.visitList = ASE_Compiler_Python_Output_epv.visitList;
    ASE_Compiler_Python_Printer_epv.visitListComp = ASE_Compiler_Python_Output_epv.visitListComp;
    ASE_Compiler_Python_Printer_epv.visitMod = ASE_Compiler_Python_Output_epv.visitMod;
    ASE_Compiler_Python_Printer_epv.visitModule = ASE_Compiler_Python_Output_epv.visitModule;
    ASE_Compiler_Python_Printer_epv.visitMul = ASE_Compiler_Python_Output_epv.visitMul;
    ASE_Compiler_Python_Printer_epv.visitName = ASE_Compiler_Python_Output_epv.visitName;
    ASE_Compiler_Python_Printer_epv.visitNot = ASE_Compiler_Python_Output_epv.visitNot;
    ASE_Compiler_Python_Printer_epv.visitOr = ASE_Compiler_Python_Output_epv.visitOr;
    ASE_Compiler_Python_Printer_epv.visitPass = ASE_Compiler_Python_Output_epv.visitPass;
    ASE_Compiler_Python_Printer_epv.visitPower = ASE_Compiler_Python_Output_epv.visitPower;
    ASE_Compiler_Python_Printer_epv.visitPrint = ASE_Compiler_Python_Output_epv.visitPrint;
    ASE_Compiler_Python_Printer_epv.visitPrintnl = ASE_Compiler_Python_Output_epv.visitPrintnl;
    ASE_Compiler_Python_Printer_epv.visitRaise = ASE_Compiler_Python_Output_epv.visitRaise;
    ASE_Compiler_Python_Printer_epv.visitReturn = ASE_Compiler_Python_Output_epv.visitReturn;
    ASE_Compiler_Python_Printer_epv.visitRightShift = ASE_Compiler_Python_Output_epv.visitRightShift;
    ASE_Compiler_Python_Printer_epv.visitSlice = ASE_Compiler_Python_Output_epv.visitSlice;
    ASE_Compiler_Python_Printer_epv.visitStmt = ASE_Compiler_Python_Output_epv.visitStmt;
    ASE_Compiler_Python_Printer_epv.visitSub = ASE_Compiler_Python_Output_epv.visitSub;
    ASE_Compiler_Python_Printer_epv.visitSubscript = ASE_Compiler_Python_Output_epv.visitSubscript;
    ASE_Compiler_Python_Printer_epv.visitTryExcept = ASE_Compiler_Python_Output_epv.visitTryExcept;
    ASE_Compiler_Python_Printer_epv.visitTryFinally = ASE_Compiler_Python_Output_epv.visitTryFinally;
    ASE_Compiler_Python_Printer_epv.visitTuple = ASE_Compiler_Python_Output_epv.visitTuple;
    ASE_Compiler_Python_Printer_epv.visitUnaryAdd = ASE_Compiler_Python_Output_epv.visitUnaryAdd;
    ASE_Compiler_Python_Printer_epv.visitUnarySub = ASE_Compiler_Python_Output_epv.visitUnarySub;
    ASE_Compiler_Python_Printer_epv.visitWhile = ASE_Compiler_Python_Output_epv.visitWhile;
    ASE_Compiler_Python_Printer_epv.visitYield = ASE_Compiler_Python_Output_epv.visitYield;
    ASE_Compiler_Python_Printer_epv.printDocComment = ASE_Compiler_Python_Output_epv.printDocComment;
    /* Initialize interface ASE.Compiler.Output methods with those of class ASE.Compiler.Python.Output */
    ASE_Compiler_Output_epv.castObject = ASE_Compiler_Python_Output_epv.castObject;
    ASE_Compiler_Output_epv.destroyObject = ASE_Compiler_Python_Output_epv.destroyObject;
    ASE_Compiler_Output_epv.strObject = ASE_Compiler_Python_Output_epv.strObject;
    ASE_Compiler_Output_epv.getReferenceCount = ASE_Compiler_Python_Output_epv.getReferenceCount;
    ASE_Compiler_Output_epv.addReference = ASE_Compiler_Python_Output_epv.addReference;
    ASE_Compiler_Output_epv.deleteReference = ASE_Compiler_Python_Output_epv.deleteReference;
    ASE_Compiler_Output_epv.isSame = ASE_Compiler_Python_Output_epv.isSame;
    ASE_Compiler_Output_epv.getClassName = ASE_Compiler_Python_Output_epv.getClassName;
    ASE_Compiler_Output_epv.getName = ASE_Compiler_Python_Output_epv.getName;
    ASE_Compiler_Output_epv.setName = ASE_Compiler_Python_Output_epv.setName;
    ASE_Compiler_Output_epv.isInstanceOf = ASE_Compiler_Python_Output_epv.isInstanceOf;
    ASE_Compiler_Output_epv.getSuper = ASE_Compiler_Python_Output_epv.getSuper;
    ASE_Compiler_Output_epv.getRepository = ASE_Compiler_Python_Output_epv.getRepository;
    ASE_Compiler_Output_epv.setRepository = ASE_Compiler_Python_Output_epv.setRepository;
    ASE_Compiler_Output_epv.visitVertex = ASE_Compiler_Python_Output_epv.visitVertex;
    ASE_Compiler_Output_epv.getDisableOutput = ASE_Compiler_Python_Output_epv.getDisableOutput;
    ASE_Compiler_Output_epv.setDisableOutput = ASE_Compiler_Python_Output_epv.setDisableOutput;
    ASE_Compiler_Output_epv.getDisableSource = ASE_Compiler_Python_Output_epv.getDisableSource;
    ASE_Compiler_Output_epv.setDisableSource = ASE_Compiler_Python_Output_epv.setDisableSource;
    ASE_Compiler_Output_epv.getRoot = ASE_Compiler_Python_Output_epv.getRoot;
    ASE_Compiler_Output_epv.setRoot = ASE_Compiler_Python_Output_epv.setRoot;
    ASE_Compiler_Output_epv.getIncludeDirectories = ASE_Compiler_Python_Output_epv.getIncludeDirectories;
    ASE_Compiler_Output_epv.setIncludeDirectories = ASE_Compiler_Python_Output_epv.setIncludeDirectories;
    ASE_Compiler_Output_epv.getSystemIncludeDirectories = ASE_Compiler_Python_Output_epv.getSystemIncludeDirectories;
    ASE_Compiler_Output_epv.setSystemIncludeDirectories = ASE_Compiler_Python_Output_epv.setSystemIncludeDirectories;
    ASE_Compiler_Output_epv.getFiles = ASE_Compiler_Python_Output_epv.getFiles;
    ASE_Compiler_Output_epv.setFiles = ASE_Compiler_Python_Output_epv.setFiles;
    /* Initialize interface ASE.Compiler.Visitor methods with those of class ASE.Compiler.Python.Output */
    ASE_Compiler_Visitor_epv.castObject = ASE_Compiler_Python_Output_epv.castObject;
    ASE_Compiler_Visitor_epv.destroyObject = ASE_Compiler_Python_Output_epv.destroyObject;
    ASE_Compiler_Visitor_epv.strObject = ASE_Compiler_Python_Output_epv.strObject;
    ASE_Compiler_Visitor_epv.getReferenceCount = ASE_Compiler_Python_Output_epv.getReferenceCount;
    ASE_Compiler_Visitor_epv.addReference = ASE_Compiler_Python_Output_epv.addReference;
    ASE_Compiler_Visitor_epv.deleteReference = ASE_Compiler_Python_Output_epv.deleteReference;
    ASE_Compiler_Visitor_epv.isSame = ASE_Compiler_Python_Output_epv.isSame;
    ASE_Compiler_Visitor_epv.getClassName = ASE_Compiler_Python_Output_epv.getClassName;
    ASE_Compiler_Visitor_epv.getName = ASE_Compiler_Python_Output_epv.getName;
    ASE_Compiler_Visitor_epv.setName = ASE_Compiler_Python_Output_epv.setName;
    ASE_Compiler_Visitor_epv.isInstanceOf = ASE_Compiler_Python_Output_epv.isInstanceOf;
    ASE_Compiler_Visitor_epv.getSuper = ASE_Compiler_Python_Output_epv.getSuper;
    ASE_Compiler_Visitor_epv.getRepository = ASE_Compiler_Python_Output_epv.getRepository;
    ASE_Compiler_Visitor_epv.setRepository = ASE_Compiler_Python_Output_epv.setRepository;
    ASE_Compiler_Visitor_epv.visitVertex = ASE_Compiler_Python_Output_epv.visitVertex;
    /* Initialize interface ASE.BaseInterface methods with those of class ASE.Compiler.Python.Output */
    ASE_BaseInterface_epv.castObject = ASE_Compiler_Python_Output_epv.castObject;
    ASE_BaseInterface_epv.destroyObject = ASE_Compiler_Python_Output_epv.destroyObject;
    ASE_BaseInterface_epv.strObject = ASE_Compiler_Python_Output_epv.strObject;
    ASE_BaseInterface_epv.getReferenceCount = ASE_Compiler_Python_Output_epv.getReferenceCount;
    ASE_BaseInterface_epv.addReference = ASE_Compiler_Python_Output_epv.addReference;
    ASE_BaseInterface_epv.deleteReference = ASE_Compiler_Python_Output_epv.deleteReference;
    ASE_BaseInterface_epv.isSame = ASE_Compiler_Python_Output_epv.isSame;
    ASE_BaseInterface_epv.getClassName = ASE_Compiler_Python_Output_epv.getClassName;
    ASE_BaseInterface_epv.getName = ASE_Compiler_Python_Output_epv.getName;
    ASE_BaseInterface_epv.setName = ASE_Compiler_Python_Output_epv.setName;
    ASE_BaseInterface_epv.isInstanceOf = ASE_Compiler_Python_Output_epv.isInstanceOf;
    ASE_BaseInterface_epv.getSuper = ASE_Compiler_Python_Output_epv.getSuper;
    /* Override class ASE.Compiler.Python.Printer methods with those of superclass ASE.Compiler.Python.DepthFirstVisitor */
    ASE_Compiler_Python_Printer_epv.getRepository = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->getRepository;
    ASE_Compiler_Python_Printer_epv.setRepository = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->setRepository;
    ASE_Compiler_Python_Printer_epv.visitVertex = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->visitVertex;
    ASE_Compiler_Python_Printer_epv.getReverseEdges = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->getReverseEdges;
    ASE_Compiler_Python_Printer_epv.setReverseEdges = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->setReverseEdges;
    ASE_Compiler_Python_Printer_epv.traverseVertex = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->traverseVertex;
    ASE_Compiler_Python_Printer_epv.resetVertexNumbering = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->resetVertexNumbering;
    ASE_Compiler_Python_Printer_epv.discoverVertex = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->discoverVertex;
    ASE_Compiler_Python_Printer_epv.finishVertex = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->finishVertex;
    ASE_Compiler_Python_Printer_epv.getVerticesSeen = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->getVerticesSeen;
    ASE_Compiler_Python_Printer_epv.setVerticesSeen = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->setVerticesSeen;
    ASE_Compiler_Python_Printer_epv.getVertexSeen = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->getVertexSeen;
    ASE_Compiler_Python_Printer_epv.setVertexSeen = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->setVertexSeen;
    ASE_Compiler_Python_Printer_epv.getReferenceCount = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->getReferenceCount;
    ASE_Compiler_Python_Printer_epv.addReference = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->addReference;
    ASE_Compiler_Python_Printer_epv.deleteReference = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->deleteReference;
    ASE_Compiler_Python_Printer_epv.isSame = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->isSame;
    ASE_Compiler_Python_Printer_epv.getClassName = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->getClassName;
    ASE_Compiler_Python_Printer_epv.getName = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->getName;
    ASE_Compiler_Python_Printer_epv.setName = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->setName;
    ASE_Compiler_Python_Printer_epv.isInstanceOf = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->isInstanceOf;
    ASE_Compiler_Python_Printer_epv.getSuper = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv->getSuper;
    /* Virtualize superclass ASE.Compiler.Python.DepthFirstVisitor methods with those of class ASE.Compiler.Python.Printer */
    ASE_Compiler_Python_DepthFirstVisitor_epv.castObject = ASE_Compiler_Python_Printer_epv.castObject;
    ASE_Compiler_Python_DepthFirstVisitor_epv.destroyObject = ASE_Compiler_Python_Printer_epv.destroyObject;
    ASE_Compiler_Python_DepthFirstVisitor_epv.strObject = ASE_Compiler_Python_Printer_epv.strObject;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getRepository = ASE_Compiler_Python_Printer_epv.getRepository;
    ASE_Compiler_Python_DepthFirstVisitor_epv.setRepository = ASE_Compiler_Python_Printer_epv.setRepository;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitVertex = ASE_Compiler_Python_Printer_epv.visitVertex;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitAdd = ASE_Compiler_Python_Printer_epv.visitAdd;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitAnd = ASE_Compiler_Python_Printer_epv.visitAnd;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssAttr = ASE_Compiler_Python_Printer_epv.visitAssAttr;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssList = ASE_Compiler_Python_Printer_epv.visitAssList;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssName = ASE_Compiler_Python_Printer_epv.visitAssName;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssTuple = ASE_Compiler_Python_Printer_epv.visitAssTuple;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssign = ASE_Compiler_Python_Printer_epv.visitAssign;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitAugAssign = ASE_Compiler_Python_Printer_epv.visitAugAssign;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitBitand = ASE_Compiler_Python_Printer_epv.visitBitand;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitBitor = ASE_Compiler_Python_Printer_epv.visitBitor;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitBitxor = ASE_Compiler_Python_Printer_epv.visitBitxor;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitBreak = ASE_Compiler_Python_Printer_epv.visitBreak;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitCallFunc = ASE_Compiler_Python_Printer_epv.visitCallFunc;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitClass = ASE_Compiler_Python_Printer_epv.visitClass;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitCompare = ASE_Compiler_Python_Printer_epv.visitCompare;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitConst = ASE_Compiler_Python_Printer_epv.visitConst;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitPyNone = ASE_Compiler_Python_Printer_epv.visitPyNone;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitContinue = ASE_Compiler_Python_Printer_epv.visitContinue;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitDict = ASE_Compiler_Python_Printer_epv.visitDict;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitDiscard = ASE_Compiler_Python_Printer_epv.visitDiscard;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitDiv = ASE_Compiler_Python_Printer_epv.visitDiv;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitEllipsis = ASE_Compiler_Python_Printer_epv.visitEllipsis;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitFor = ASE_Compiler_Python_Printer_epv.visitFor;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitListCompFor = ASE_Compiler_Python_Printer_epv.visitListCompFor;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitFunction = ASE_Compiler_Python_Printer_epv.visitFunction;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitLambda = ASE_Compiler_Python_Printer_epv.visitLambda;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitGetAttr = ASE_Compiler_Python_Printer_epv.visitGetAttr;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitGlobal = ASE_Compiler_Python_Printer_epv.visitGlobal;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitIf = ASE_Compiler_Python_Printer_epv.visitIf;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitListCompIf = ASE_Compiler_Python_Printer_epv.visitListCompIf;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitImport = ASE_Compiler_Python_Printer_epv.visitImport;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitFrom = ASE_Compiler_Python_Printer_epv.visitFrom;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitInvert = ASE_Compiler_Python_Printer_epv.visitInvert;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitKeyword = ASE_Compiler_Python_Printer_epv.visitKeyword;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitLeftShift = ASE_Compiler_Python_Printer_epv.visitLeftShift;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitList = ASE_Compiler_Python_Printer_epv.visitList;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitListComp = ASE_Compiler_Python_Printer_epv.visitListComp;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitMod = ASE_Compiler_Python_Printer_epv.visitMod;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitModule = ASE_Compiler_Python_Printer_epv.visitModule;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitMul = ASE_Compiler_Python_Printer_epv.visitMul;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitName = ASE_Compiler_Python_Printer_epv.visitName;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitNot = ASE_Compiler_Python_Printer_epv.visitNot;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitOr = ASE_Compiler_Python_Printer_epv.visitOr;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitPass = ASE_Compiler_Python_Printer_epv.visitPass;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitPower = ASE_Compiler_Python_Printer_epv.visitPower;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitPrint = ASE_Compiler_Python_Printer_epv.visitPrint;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitPrintnl = ASE_Compiler_Python_Printer_epv.visitPrintnl;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitRaise = ASE_Compiler_Python_Printer_epv.visitRaise;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitReturn = ASE_Compiler_Python_Printer_epv.visitReturn;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitRightShift = ASE_Compiler_Python_Printer_epv.visitRightShift;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitSlice = ASE_Compiler_Python_Printer_epv.visitSlice;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitStmt = ASE_Compiler_Python_Printer_epv.visitStmt;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitSub = ASE_Compiler_Python_Printer_epv.visitSub;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitSubscript = ASE_Compiler_Python_Printer_epv.visitSubscript;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitTryExcept = ASE_Compiler_Python_Printer_epv.visitTryExcept;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitTryFinally = ASE_Compiler_Python_Printer_epv.visitTryFinally;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitTuple = ASE_Compiler_Python_Printer_epv.visitTuple;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitUnaryAdd = ASE_Compiler_Python_Printer_epv.visitUnaryAdd;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitUnarySub = ASE_Compiler_Python_Printer_epv.visitUnarySub;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitWhile = ASE_Compiler_Python_Printer_epv.visitWhile;
    ASE_Compiler_Python_DepthFirstVisitor_epv.visitYield = ASE_Compiler_Python_Printer_epv.visitYield;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getReverseEdges = ASE_Compiler_Python_Printer_epv.getReverseEdges;
    ASE_Compiler_Python_DepthFirstVisitor_epv.setReverseEdges = ASE_Compiler_Python_Printer_epv.setReverseEdges;
    ASE_Compiler_Python_DepthFirstVisitor_epv.traverseVertex = ASE_Compiler_Python_Printer_epv.traverseVertex;
    ASE_Compiler_Python_DepthFirstVisitor_epv.resetVertexNumbering = ASE_Compiler_Python_Printer_epv.resetVertexNumbering;
    ASE_Compiler_Python_DepthFirstVisitor_epv.discoverVertex = ASE_Compiler_Python_Printer_epv.discoverVertex;
    ASE_Compiler_Python_DepthFirstVisitor_epv.finishVertex = ASE_Compiler_Python_Printer_epv.finishVertex;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getVerticesSeen = ASE_Compiler_Python_Printer_epv.getVerticesSeen;
    ASE_Compiler_Python_DepthFirstVisitor_epv.setVerticesSeen = ASE_Compiler_Python_Printer_epv.setVerticesSeen;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getVertexSeen = ASE_Compiler_Python_Printer_epv.getVertexSeen;
    ASE_Compiler_Python_DepthFirstVisitor_epv.setVertexSeen = ASE_Compiler_Python_Printer_epv.setVertexSeen;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getReferenceCount = ASE_Compiler_Python_Printer_epv.getReferenceCount;
    ASE_Compiler_Python_DepthFirstVisitor_epv.addReference = ASE_Compiler_Python_Printer_epv.addReference;
    ASE_Compiler_Python_DepthFirstVisitor_epv.deleteReference = ASE_Compiler_Python_Printer_epv.deleteReference;
    ASE_Compiler_Python_DepthFirstVisitor_epv.isSame = ASE_Compiler_Python_Printer_epv.isSame;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getClassName = ASE_Compiler_Python_Printer_epv.getClassName;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getName = ASE_Compiler_Python_Printer_epv.getName;
    ASE_Compiler_Python_DepthFirstVisitor_epv.setName = ASE_Compiler_Python_Printer_epv.setName;
    ASE_Compiler_Python_DepthFirstVisitor_epv.isInstanceOf = ASE_Compiler_Python_Printer_epv.isInstanceOf;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getSuper = ASE_Compiler_Python_Printer_epv.getSuper;
    /* Initialize interface ASE.Compiler.Printer methods with those of class ASE.Compiler.Python.Printer */
    ASE_Compiler_Printer_epv.castObject = ASE_Compiler_Python_Printer_epv.castObject;
    ASE_Compiler_Printer_epv.destroyObject = ASE_Compiler_Python_Printer_epv.destroyObject;
    ASE_Compiler_Printer_epv.strObject = ASE_Compiler_Python_Printer_epv.strObject;
    ASE_Compiler_Printer_epv.getReferenceCount = ASE_Compiler_Python_Printer_epv.getReferenceCount;
    ASE_Compiler_Printer_epv.addReference = ASE_Compiler_Python_Printer_epv.addReference;
    ASE_Compiler_Printer_epv.deleteReference = ASE_Compiler_Python_Printer_epv.deleteReference;
    ASE_Compiler_Printer_epv.isSame = ASE_Compiler_Python_Printer_epv.isSame;
    ASE_Compiler_Printer_epv.getClassName = ASE_Compiler_Python_Printer_epv.getClassName;
    ASE_Compiler_Printer_epv.getName = ASE_Compiler_Python_Printer_epv.getName;
    ASE_Compiler_Printer_epv.setName = ASE_Compiler_Python_Printer_epv.setName;
    ASE_Compiler_Printer_epv.isInstanceOf = ASE_Compiler_Python_Printer_epv.isInstanceOf;
    ASE_Compiler_Printer_epv.getSuper = ASE_Compiler_Python_Printer_epv.getSuper;
    ASE_Compiler_Printer_epv.getRepository = ASE_Compiler_Python_Printer_epv.getRepository;
    ASE_Compiler_Printer_epv.setRepository = ASE_Compiler_Python_Printer_epv.setRepository;
    ASE_Compiler_Printer_epv.visitVertex = ASE_Compiler_Python_Printer_epv.visitVertex;
    ASE_Compiler_Printer_epv.getTab = ASE_Compiler_Python_Printer_epv.getTab;
    ASE_Compiler_Printer_epv.setTab = ASE_Compiler_Python_Printer_epv.setTab;
    ASE_Compiler_Printer_epv.getIndentSize = ASE_Compiler_Python_Printer_epv.getIndentSize;
    ASE_Compiler_Printer_epv.setIndentSize = ASE_Compiler_Python_Printer_epv.setIndentSize;
    ASE_Compiler_Printer_epv.increaseIndent = ASE_Compiler_Python_Printer_epv.increaseIndent;
    ASE_Compiler_Printer_epv.decreaseIndent = ASE_Compiler_Python_Printer_epv.decreaseIndent;
    ASE_Compiler_Printer_epv.indent = ASE_Compiler_Python_Printer_epv.indent;
    ASE_Compiler_Printer_epv.write = ASE_Compiler_Python_Printer_epv.write;
    ASE_Compiler_Printer_epv.println = ASE_Compiler_Python_Printer_epv.println;
    /* Override class ASE.Compiler.Python.DepthFirstVisitor methods with those of superclass ASE.BaseClass */
    ASE_Compiler_Python_DepthFirstVisitor_epv.getReferenceCount = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_baseclass.d_epv->getReferenceCount;
    ASE_Compiler_Python_DepthFirstVisitor_epv.addReference = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_baseclass.d_epv->addReference;
    ASE_Compiler_Python_DepthFirstVisitor_epv.deleteReference = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_baseclass.d_epv->deleteReference;
    ASE_Compiler_Python_DepthFirstVisitor_epv.isSame = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_baseclass.d_epv->isSame;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getClassName = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_baseclass.d_epv->getClassName;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getName = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_baseclass.d_epv->getName;
    ASE_Compiler_Python_DepthFirstVisitor_epv.setName = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_baseclass.d_epv->setName;
    ASE_Compiler_Python_DepthFirstVisitor_epv.isInstanceOf = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_baseclass.d_epv->isInstanceOf;
    ASE_Compiler_Python_DepthFirstVisitor_epv.getSuper = self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_baseclass.d_epv->getSuper;
    /* Virtualize superclass ASE.BaseClass methods with those of class ASE.Compiler.Python.DepthFirstVisitor */
    ASE_BaseClass_epv.castObject = ASE_Compiler_Python_DepthFirstVisitor_epv.castObject;
    ASE_BaseClass_epv.destroyObject = ASE_Compiler_Python_DepthFirstVisitor_epv.destroyObject;
    ASE_BaseClass_epv.strObject = ASE_Compiler_Python_DepthFirstVisitor_epv.strObject;
    ASE_BaseClass_epv.getReferenceCount = ASE_Compiler_Python_DepthFirstVisitor_epv.getReferenceCount;
    ASE_BaseClass_epv.addReference = ASE_Compiler_Python_DepthFirstVisitor_epv.addReference;
    ASE_BaseClass_epv.deleteReference = ASE_Compiler_Python_DepthFirstVisitor_epv.deleteReference;
    ASE_BaseClass_epv.isSame = ASE_Compiler_Python_DepthFirstVisitor_epv.isSame;
    ASE_BaseClass_epv.getClassName = ASE_Compiler_Python_DepthFirstVisitor_epv.getClassName;
    ASE_BaseClass_epv.getName = ASE_Compiler_Python_DepthFirstVisitor_epv.getName;
    ASE_BaseClass_epv.setName = ASE_Compiler_Python_DepthFirstVisitor_epv.setName;
    ASE_BaseClass_epv.isInstanceOf = ASE_Compiler_Python_DepthFirstVisitor_epv.isInstanceOf;
    ASE_BaseClass_epv.getSuper = ASE_Compiler_Python_DepthFirstVisitor_epv.getSuper;
    /* Initialize interface ASE.Compiler.Python.Visitor methods with those of class ASE.Compiler.Python.DepthFirstVisitor */
    ASE_Compiler_Python_Visitor_epv.castObject = ASE_Compiler_Python_DepthFirstVisitor_epv.castObject;
    ASE_Compiler_Python_Visitor_epv.destroyObject = ASE_Compiler_Python_DepthFirstVisitor_epv.destroyObject;
    ASE_Compiler_Python_Visitor_epv.strObject = ASE_Compiler_Python_DepthFirstVisitor_epv.strObject;
    ASE_Compiler_Python_Visitor_epv.getReferenceCount = ASE_Compiler_Python_DepthFirstVisitor_epv.getReferenceCount;
    ASE_Compiler_Python_Visitor_epv.addReference = ASE_Compiler_Python_DepthFirstVisitor_epv.addReference;
    ASE_Compiler_Python_Visitor_epv.deleteReference = ASE_Compiler_Python_DepthFirstVisitor_epv.deleteReference;
    ASE_Compiler_Python_Visitor_epv.isSame = ASE_Compiler_Python_DepthFirstVisitor_epv.isSame;
    ASE_Compiler_Python_Visitor_epv.getClassName = ASE_Compiler_Python_DepthFirstVisitor_epv.getClassName;
    ASE_Compiler_Python_Visitor_epv.getName = ASE_Compiler_Python_DepthFirstVisitor_epv.getName;
    ASE_Compiler_Python_Visitor_epv.setName = ASE_Compiler_Python_DepthFirstVisitor_epv.setName;
    ASE_Compiler_Python_Visitor_epv.isInstanceOf = ASE_Compiler_Python_DepthFirstVisitor_epv.isInstanceOf;
    ASE_Compiler_Python_Visitor_epv.getSuper = ASE_Compiler_Python_DepthFirstVisitor_epv.getSuper;
    ASE_Compiler_Python_Visitor_epv.getRepository = ASE_Compiler_Python_DepthFirstVisitor_epv.getRepository;
    ASE_Compiler_Python_Visitor_epv.setRepository = ASE_Compiler_Python_DepthFirstVisitor_epv.setRepository;
    ASE_Compiler_Python_Visitor_epv.visitVertex = ASE_Compiler_Python_DepthFirstVisitor_epv.visitVertex;
    ASE_Compiler_Python_Visitor_epv.visitAdd = ASE_Compiler_Python_DepthFirstVisitor_epv.visitAdd;
    ASE_Compiler_Python_Visitor_epv.visitAnd = ASE_Compiler_Python_DepthFirstVisitor_epv.visitAnd;
    ASE_Compiler_Python_Visitor_epv.visitAssAttr = ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssAttr;
    ASE_Compiler_Python_Visitor_epv.visitAssList = ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssList;
    ASE_Compiler_Python_Visitor_epv.visitAssName = ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssName;
    ASE_Compiler_Python_Visitor_epv.visitAssTuple = ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssTuple;
    ASE_Compiler_Python_Visitor_epv.visitAssign = ASE_Compiler_Python_DepthFirstVisitor_epv.visitAssign;
    ASE_Compiler_Python_Visitor_epv.visitAugAssign = ASE_Compiler_Python_DepthFirstVisitor_epv.visitAugAssign;
    ASE_Compiler_Python_Visitor_epv.visitBitand = ASE_Compiler_Python_DepthFirstVisitor_epv.visitBitand;
    ASE_Compiler_Python_Visitor_epv.visitBitor = ASE_Compiler_Python_DepthFirstVisitor_epv.visitBitor;
    ASE_Compiler_Python_Visitor_epv.visitBitxor = ASE_Compiler_Python_DepthFirstVisitor_epv.visitBitxor;
    ASE_Compiler_Python_Visitor_epv.visitBreak = ASE_Compiler_Python_DepthFirstVisitor_epv.visitBreak;
    ASE_Compiler_Python_Visitor_epv.visitCallFunc = ASE_Compiler_Python_DepthFirstVisitor_epv.visitCallFunc;
    ASE_Compiler_Python_Visitor_epv.visitClass = ASE_Compiler_Python_DepthFirstVisitor_epv.visitClass;
    ASE_Compiler_Python_Visitor_epv.visitCompare = ASE_Compiler_Python_DepthFirstVisitor_epv.visitCompare;
    ASE_Compiler_Python_Visitor_epv.visitConst = ASE_Compiler_Python_DepthFirstVisitor_epv.visitConst;
    ASE_Compiler_Python_Visitor_epv.visitPyNone = ASE_Compiler_Python_DepthFirstVisitor_epv.visitPyNone;
    ASE_Compiler_Python_Visitor_epv.visitContinue = ASE_Compiler_Python_DepthFirstVisitor_epv.visitContinue;
    ASE_Compiler_Python_Visitor_epv.visitDict = ASE_Compiler_Python_DepthFirstVisitor_epv.visitDict;
    ASE_Compiler_Python_Visitor_epv.visitDiscard = ASE_Compiler_Python_DepthFirstVisitor_epv.visitDiscard;
    ASE_Compiler_Python_Visitor_epv.visitDiv = ASE_Compiler_Python_DepthFirstVisitor_epv.visitDiv;
    ASE_Compiler_Python_Visitor_epv.visitEllipsis = ASE_Compiler_Python_DepthFirstVisitor_epv.visitEllipsis;
    ASE_Compiler_Python_Visitor_epv.visitFor = ASE_Compiler_Python_DepthFirstVisitor_epv.visitFor;
    ASE_Compiler_Python_Visitor_epv.visitListCompFor = ASE_Compiler_Python_DepthFirstVisitor_epv.visitListCompFor;
    ASE_Compiler_Python_Visitor_epv.visitFunction = ASE_Compiler_Python_DepthFirstVisitor_epv.visitFunction;
    ASE_Compiler_Python_Visitor_epv.visitLambda = ASE_Compiler_Python_DepthFirstVisitor_epv.visitLambda;
    ASE_Compiler_Python_Visitor_epv.visitGetAttr = ASE_Compiler_Python_DepthFirstVisitor_epv.visitGetAttr;
    ASE_Compiler_Python_Visitor_epv.visitGlobal = ASE_Compiler_Python_DepthFirstVisitor_epv.visitGlobal;
    ASE_Compiler_Python_Visitor_epv.visitIf = ASE_Compiler_Python_DepthFirstVisitor_epv.visitIf;
    ASE_Compiler_Python_Visitor_epv.visitListCompIf = ASE_Compiler_Python_DepthFirstVisitor_epv.visitListCompIf;
    ASE_Compiler_Python_Visitor_epv.visitImport = ASE_Compiler_Python_DepthFirstVisitor_epv.visitImport;
    ASE_Compiler_Python_Visitor_epv.visitFrom = ASE_Compiler_Python_DepthFirstVisitor_epv.visitFrom;
    ASE_Compiler_Python_Visitor_epv.visitInvert = ASE_Compiler_Python_DepthFirstVisitor_epv.visitInvert;
    ASE_Compiler_Python_Visitor_epv.visitKeyword = ASE_Compiler_Python_DepthFirstVisitor_epv.visitKeyword;
    ASE_Compiler_Python_Visitor_epv.visitLeftShift = ASE_Compiler_Python_DepthFirstVisitor_epv.visitLeftShift;
    ASE_Compiler_Python_Visitor_epv.visitList = ASE_Compiler_Python_DepthFirstVisitor_epv.visitList;
    ASE_Compiler_Python_Visitor_epv.visitListComp = ASE_Compiler_Python_DepthFirstVisitor_epv.visitListComp;
    ASE_Compiler_Python_Visitor_epv.visitMod = ASE_Compiler_Python_DepthFirstVisitor_epv.visitMod;
    ASE_Compiler_Python_Visitor_epv.visitModule = ASE_Compiler_Python_DepthFirstVisitor_epv.visitModule;
    ASE_Compiler_Python_Visitor_epv.visitMul = ASE_Compiler_Python_DepthFirstVisitor_epv.visitMul;
    ASE_Compiler_Python_Visitor_epv.visitName = ASE_Compiler_Python_DepthFirstVisitor_epv.visitName;
    ASE_Compiler_Python_Visitor_epv.visitNot = ASE_Compiler_Python_DepthFirstVisitor_epv.visitNot;
    ASE_Compiler_Python_Visitor_epv.visitOr = ASE_Compiler_Python_DepthFirstVisitor_epv.visitOr;
    ASE_Compiler_Python_Visitor_epv.visitPass = ASE_Compiler_Python_DepthFirstVisitor_epv.visitPass;
    ASE_Compiler_Python_Visitor_epv.visitPower = ASE_Compiler_Python_DepthFirstVisitor_epv.visitPower;
    ASE_Compiler_Python_Visitor_epv.visitPrint = ASE_Compiler_Python_DepthFirstVisitor_epv.visitPrint;
    ASE_Compiler_Python_Visitor_epv.visitPrintnl = ASE_Compiler_Python_DepthFirstVisitor_epv.visitPrintnl;
    ASE_Compiler_Python_Visitor_epv.visitRaise = ASE_Compiler_Python_DepthFirstVisitor_epv.visitRaise;
    ASE_Compiler_Python_Visitor_epv.visitReturn = ASE_Compiler_Python_DepthFirstVisitor_epv.visitReturn;
    ASE_Compiler_Python_Visitor_epv.visitRightShift = ASE_Compiler_Python_DepthFirstVisitor_epv.visitRightShift;
    ASE_Compiler_Python_Visitor_epv.visitSlice = ASE_Compiler_Python_DepthFirstVisitor_epv.visitSlice;
    ASE_Compiler_Python_Visitor_epv.visitStmt = ASE_Compiler_Python_DepthFirstVisitor_epv.visitStmt;
    ASE_Compiler_Python_Visitor_epv.visitSub = ASE_Compiler_Python_DepthFirstVisitor_epv.visitSub;
    ASE_Compiler_Python_Visitor_epv.visitSubscript = ASE_Compiler_Python_DepthFirstVisitor_epv.visitSubscript;
    ASE_Compiler_Python_Visitor_epv.visitTryExcept = ASE_Compiler_Python_DepthFirstVisitor_epv.visitTryExcept;
    ASE_Compiler_Python_Visitor_epv.visitTryFinally = ASE_Compiler_Python_DepthFirstVisitor_epv.visitTryFinally;
    ASE_Compiler_Python_Visitor_epv.visitTuple = ASE_Compiler_Python_DepthFirstVisitor_epv.visitTuple;
    ASE_Compiler_Python_Visitor_epv.visitUnaryAdd = ASE_Compiler_Python_DepthFirstVisitor_epv.visitUnaryAdd;
    ASE_Compiler_Python_Visitor_epv.visitUnarySub = ASE_Compiler_Python_DepthFirstVisitor_epv.visitUnarySub;
    ASE_Compiler_Python_Visitor_epv.visitWhile = ASE_Compiler_Python_DepthFirstVisitor_epv.visitWhile;
    ASE_Compiler_Python_Visitor_epv.visitYield = ASE_Compiler_Python_DepthFirstVisitor_epv.visitYield;
    /* Initialize interface ASE.Compiler.Search methods with those of class ASE.Compiler.Python.DepthFirstVisitor */
    ASE_Compiler_Search_epv.castObject = ASE_Compiler_Python_DepthFirstVisitor_epv.castObject;
    ASE_Compiler_Search_epv.destroyObject = ASE_Compiler_Python_DepthFirstVisitor_epv.destroyObject;
    ASE_Compiler_Search_epv.strObject = ASE_Compiler_Python_DepthFirstVisitor_epv.strObject;
    ASE_Compiler_Search_epv.getReferenceCount = ASE_Compiler_Python_DepthFirstVisitor_epv.getReferenceCount;
    ASE_Compiler_Search_epv.addReference = ASE_Compiler_Python_DepthFirstVisitor_epv.addReference;
    ASE_Compiler_Search_epv.deleteReference = ASE_Compiler_Python_DepthFirstVisitor_epv.deleteReference;
    ASE_Compiler_Search_epv.isSame = ASE_Compiler_Python_DepthFirstVisitor_epv.isSame;
    ASE_Compiler_Search_epv.getClassName = ASE_Compiler_Python_DepthFirstVisitor_epv.getClassName;
    ASE_Compiler_Search_epv.getName = ASE_Compiler_Python_DepthFirstVisitor_epv.getName;
    ASE_Compiler_Search_epv.setName = ASE_Compiler_Python_DepthFirstVisitor_epv.setName;
    ASE_Compiler_Search_epv.isInstanceOf = ASE_Compiler_Python_DepthFirstVisitor_epv.isInstanceOf;
    ASE_Compiler_Search_epv.getSuper = ASE_Compiler_Python_DepthFirstVisitor_epv.getSuper;
    ASE_Compiler_Search_epv.getReverseEdges = ASE_Compiler_Python_DepthFirstVisitor_epv.getReverseEdges;
    ASE_Compiler_Search_epv.setReverseEdges = ASE_Compiler_Python_DepthFirstVisitor_epv.setReverseEdges;
    ASE_Compiler_Search_epv.traverseVertex = ASE_Compiler_Python_DepthFirstVisitor_epv.traverseVertex;
    ASE_Compiler_Search_epv.resetVertexNumbering = ASE_Compiler_Python_DepthFirstVisitor_epv.resetVertexNumbering;
    ASE_Compiler_Search_epv.discoverVertex = ASE_Compiler_Python_DepthFirstVisitor_epv.discoverVertex;
    ASE_Compiler_Search_epv.finishVertex = ASE_Compiler_Python_DepthFirstVisitor_epv.finishVertex;
    ASE_Compiler_Search_epv.getVerticesSeen = ASE_Compiler_Python_DepthFirstVisitor_epv.getVerticesSeen;
    ASE_Compiler_Search_epv.setVerticesSeen = ASE_Compiler_Python_DepthFirstVisitor_epv.setVerticesSeen;
    ASE_Compiler_Search_epv.getVertexSeen = ASE_Compiler_Python_DepthFirstVisitor_epv.getVertexSeen;
    ASE_Compiler_Search_epv.setVertexSeen = ASE_Compiler_Python_DepthFirstVisitor_epv.setVertexSeen;
    epvInitialized = 1;
  }
  self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_baseclass.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_baseclass.d_epv = &ASE_BaseClass_epv;
  self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_compiler_python_visitor.ase_compiler_visitor.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_compiler_python_visitor.ase_compiler_visitor.d_epv = &ASE_Compiler_Visitor_epv;
  self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_compiler_python_visitor.d_epv = &ASE_Compiler_Python_Visitor_epv;
  self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_compiler_search.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.ase_compiler_search.d_epv = &ASE_Compiler_Search_epv;
  self->ase_compiler_python_printer.ase_compiler_python_depthfirstvisitor.d_epv = &ASE_Compiler_Python_DepthFirstVisitor_epv;
  self->ase_compiler_python_printer.ase_compiler_printer.ase_compiler_visitor.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_python_printer.ase_compiler_printer.ase_compiler_visitor.d_epv = &ASE_Compiler_Visitor_epv;
  self->ase_compiler_python_printer.ase_compiler_printer.d_epv = &ASE_Compiler_Printer_epv;
  self->ase_compiler_python_printer.d_epv = &ASE_Compiler_Python_Printer_epv;
  self->ase_compiler_output.ase_compiler_visitor.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_output.ase_compiler_visitor.d_epv = &ASE_Compiler_Visitor_epv;
  self->ase_compiler_output.d_epv = &ASE_Compiler_Output_epv;
  self->d_epv = &ASE_Compiler_Python_Output_epv;
  /* Save old EPV for getSuper() */
  self->d_oldEpv = self->d_epv;
  /* Initialize pointers to the original object */
  self->d_object = obj;
  self->ase_compiler_output.d_object = obj;
  self->ase_compiler_output.ase_compiler_visitor.d_object = obj;
  self->ase_compiler_output.ase_compiler_visitor.ase_baseinterface.d_object = obj;
  /* Setup implementation data */
  self->d_data = NULL;
  (*(self->d_epv->Output))(self, _exception);
}

static struct ASE_Compiler_Python_Output__object *createObject(/*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_Output__object *self = (struct ASE_Compiler_Python_Output__object *) malloc(sizeof(struct ASE_Compiler_Python_Output__object));
  
  initObject(self, self, _exception);
  return self;
}

#ifndef included_ASE_ASEException
#include "ASE/ASEException_IOR.h"
#endif

static struct ASE_Compiler_Python_Output__array *createArray(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*out*/ struct ASE_BaseException__object **_exception)
{
  static int32_t arraySize = sizeof(struct ASE_Compiler_Python_Output__array) + (sizeof(int32_t) - (sizeof(struct ASE_Compiler_Python_Output__array)) % sizeof(int32_t)) % sizeof(int32_t);
  struct ASE_Compiler_Python_Output__array *_return_value = (struct ASE_Compiler_Python_Output__array *) malloc(arraySize + 3 * sizeof(int32_t) * (dimen ? dimen : 1));
  int32_t size = 1;
  int32_t d = 0;
  
  /* Initialize array structure */
  _return_value->d_dimen = dimen;
  _return_value->d_borrowed = 0;
  _return_value->d_lower = (int32_t *) ((char *) _return_value + arraySize);
  _return_value->d_upper = _return_value->d_lower + (dimen ? dimen : 1);
  _return_value->d_stride = _return_value->d_upper + (dimen ? dimen : 1);
  _return_value->d_lower[0] = 0;
  _return_value->d_upper[0] = 0;
  _return_value->d_stride[0] = 1;
  /* Determine array size and set bounds */
  for(d = 0; d < dimen; d++)
  {
    _return_value->d_lower[d] = lower->d_firstElement[d];
    _return_value->d_upper[d] = upper->d_firstElement[d];
    _return_value->d_stride[d] = size;
    size *= upper->d_firstElement[d] - lower->d_firstElement[d] + 1;
  }
  size *= sizeof(struct ASE_Compiler_Python_Output__object *);
  /* Allocate and initialize data */
  _return_value->d_firstElement = (struct ASE_Compiler_Python_Output__object **) malloc(size);
  memset(_return_value->d_firstElement, 0, size);
  return _return_value;
}

static struct ASE_Compiler_Python_Output__array *borrowArray(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*in*/ struct int__array *stride, /*in*/ void *first, /*out*/ struct ASE_BaseException__object **_exception)
{
  static int32_t arraySize = sizeof(struct ASE_Compiler_Python_Output__array) + (sizeof(int32_t) - (sizeof(struct ASE_Compiler_Python_Output__array)) % sizeof(int32_t)) % sizeof(int32_t);
  struct ASE_Compiler_Python_Output__array *_return_value = (struct ASE_Compiler_Python_Output__array *) malloc(arraySize + 3 * sizeof(int32_t) * (dimen ? dimen : 1));
  int32_t size = 1;
  int32_t d = 0;
  
  /* Initialize array structure */
  _return_value->d_dimen = dimen;
  _return_value->d_borrowed = 1;
  _return_value->d_lower = (int32_t *) ((char *) _return_value + arraySize);
  _return_value->d_upper = _return_value->d_lower + (dimen ? dimen : 1);
  _return_value->d_stride = _return_value->d_upper + (dimen ? dimen : 1);
  _return_value->d_lower[0] = 0;
  _return_value->d_upper[0] = 0;
  _return_value->d_stride[0] = 1;
  /* Determine array size and set bounds */
  for(d = 0; d < dimen; d++)
  {
    _return_value->d_lower[d] = lower->d_firstElement[d];
    _return_value->d_upper[d] = upper->d_firstElement[d];
    _return_value->d_stride[d] = stride->d_firstElement[d];
    size *= upper->d_firstElement[d] - lower->d_firstElement[d] + 1;
  }
  size *= sizeof(struct ASE_Compiler_Python_Output__object *);
  _return_value->d_firstElement = (struct ASE_Compiler_Python_Output__object **) first;
  return _return_value;
}

static void destroyArray(/*in*/ struct ASE_Compiler_Python_Output__array *array, /*out*/ struct ASE_BaseException__object **_exception)
{
}

static int32_t getDimen(/*in*/ struct ASE_Compiler_Python_Output__array *array, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_dimen;
}

static int32_t getLower(/*in*/ struct ASE_Compiler_Python_Output__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_lower[dimen];
}

static int32_t getUpper(/*in*/ struct ASE_Compiler_Python_Output__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception)
{
  return array->d_upper[dimen];
}

static struct ASE_Compiler_Python_Output__object *getElement(/*in*/ struct ASE_Compiler_Python_Output__array *array, /*in*/ struct int__array *indices, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_Output__object *_result = NULL;
  struct ASE_Compiler_Python_Output__object **_element = NULL;
  int32_t d = 0;
  
  _element = array->d_firstElement;
  for(d = 0; d < array->d_dimen; d++)
  {
    if (indices->d_firstElement[d] < array->d_lower[d] || indices->d_firstElement[d] > array->d_upper[d])
    {
      struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
      
      _local_exception->d_epv->setMessage(_local_exception, "Invalid indices", _exception);
      if (!(*_exception))
      {
        *_exception = (struct ASE_BaseException__object *) _local_exception;
      }
      return _result;
    }
    _element += array->d_stride[d] * (indices->d_firstElement[d] - array->d_lower[d]);
  }
  if (*_element)
  {
    (*(((struct ASE_BaseInterface__object *) (*_element)->d_object)->d_epv->deleteReference))((*_element)->d_object, (void **) _exception);
  }
  return *_element;
}

static struct ASE_Compiler_Python_Output__object *getElement4(/*in*/ struct ASE_Compiler_Python_Output__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*out*/ struct ASE_BaseException__object **_exception)
{
}

static void setElement(/*in*/ struct ASE_Compiler_Python_Output__array *array, /*in*/ struct int__array *indices, /*in*/ struct ASE_Compiler_Python_Output__object *value, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_Output__object **_element = NULL;
  int32_t d = 0;
  
  _element = array->d_firstElement;
  for(d = 0; d < array->d_dimen; d++)
  {
    if (indices->d_firstElement[d] < array->d_lower[d] || indices->d_firstElement[d] > array->d_upper[d])
    {
      struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
      
      _local_exception->d_epv->setMessage(_local_exception, "Invalid indices", _exception);
      if (!(*_exception))
      {
        *_exception = (struct ASE_BaseException__object *) _local_exception;
      }
      return;
    }
    _element += array->d_stride[d] * (indices->d_firstElement[d] - array->d_lower[d]);
  }
  if (value)
  {
    (*(((struct ASE_BaseInterface__object *) (value)->d_object)->d_epv->addReference))((value)->d_object, (void **) _exception);
  }
  if (*_element)
  {
    (*(((struct ASE_BaseInterface__object *) (*_element)->d_object)->d_epv->deleteReference))((*_element)->d_object, (void **) _exception);
  }
  *_element = value;
}

static void setElement4(/*in*/ struct ASE_Compiler_Python_Output__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*in*/ struct ASE_Compiler_Python_Output__object *value, /*out*/ struct ASE_BaseException__object **_exception)
{
}

/* The entry points into the DLL containing this type */
static struct ASE_Compiler_Python_Output__external externalEntryPoints = {
  createObject,
  initObject,
  finiObject,
  createArray,
  borrowArray,
  destroyArray,
  getDimen,
  getLower,
  getUpper,
  getElement,
  getElement4,
  setElement,
  setElement4};

const struct ASE_Compiler_Python_Output__external *ASE_Compiler_Python_Output__externals(void)
{
  return &externalEntryPoints;
}
